﻿using System;

/// <summary>
/// Mini Version:
/// Removed Dangerousness flag and relative dangerousness functions.
/// Removed Stupid move flag.
/// Removed unwanted variables.
/// </summary>

namespace Huo_Chess_0._971_cs
{
    class HuoChess_main
    {
        // HuoChessConsole.cpp : main project file.

        /////////////////////////////////////////////
        // Huo Chess                               //
        // version: 0.980                          //
        // Various changes of improvement marked as "v0.980"
        // version: 0.971                          //
        // Changes in v0.971: Fixed the Nodes Analysis: Created a different NodesAnalysis array for each level. Fixed bugs so that the analysis stores correctly the values and the MiniMax algorithm performs as it should. Fixed the “Stupid move” filter for the computer moves. Fixed the “Possibility to eat back” functionality.
        // Changes from version 0.81: Removed the ComputerMove functions and used a template function to create all new ComputerMove functions I need.
        // Changes from version 0.722: Changed the ComputerMove, HumanMove, CountScore, ElegxosOrthotitas functions.
        // Changes from verion 0.721: Removed some useless code and added the variable thinking depth (depending on the piece the opponent moves)
        // Changes from version 0.6: Added more thinking depths
        // Year: 2008-2015                         //
        // Place: Earth - Greece                   //
        // Programmed by Spiros I. Kakos (huo)     //
        // License: TOTALLY FREEWARE!              //
        //          Do anything you want with it!  //
        //          Spread the knowledge!          //
        //          Fix its bugs!                  //
        //          Sell it (if you can...)!       //
        //          Call me for help! :P           //
        // Site: www.kakos.com.gr                  //
        //       www.kakos.eu                      //
        //       Harmonia Philosophica portals     //
        // Dedicated to Matoula!!! The light of my life!!!! E-U!//
        /////////////////////////////////////////////

        // Icon created with : http://www.rw-designer.com/online_icon_maker.php
        // Algorithm analysis: http://www.codeproject.com/KB/game/cpp_microchess.aspx

        ///////////////////////////////////////////////////////////////////////////////////////////
        // MAIN ALGORITHM
        // 1. ComputerMove: Scans the chessboard and makes all possible moves.
        // 2. CheckMove: It checks the legality and correctness of these possible moves.
        // 3. (if thinking depth not reached) => call HumanMove
        // 4. HumanMove2: Checks and finds the possible answers of the human opponent for the next move.
        // 5. ComputerMove2: Scans the chessboard and makes all possible moves at the next thinking level.
        // 6. CheckMove: It checks the legality and correctness of these possible moves.
        // 7. (if thinking depth not reached) => call HumanMove for the next level of thinking
        // 8. HumanMove4: Checks and finds the possible answers of the human opponent for the next move.
        // 9. ComputerMove4: Scans the chessboard and makes all possible moves at the next thinking level.
        // 10. CheckMove: It checks the legality and correctness of these possible moves.
        // 11. (if thinking depth reached) => record the score of the final position.
        // 12. (if score of position the best so far) => record the move as best move!
        // 13. The algorithm continues until all possible moves are scanned.
        // SET huo_debug to TRUE to see live the progress of the computer thought!
        // FIND us at Codeproject (www.codeproject.com) or MSDN Code Gallery!
        // ---------------------------------------------------------------------------
        // The score before every human opponents move and after any human opponents move are stored in the
        // Temp_Score_Move_1_human (i.e. the score after the first move of the H/Y and before the 1st move of human
        // while at the 2nd -ply of computer thinking), Temp_Score_Move_2, etc variables.
        // ---------------------------------------------------------------------------
        // At every level of thinking, the scores are stored in the NodesAnalysis table. This table is used for the
        // implementation of the MiniMax algorithm.
        ////////////////////////////////////////////////////////////////////////////////////////////

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        // DECLARE VARIABLES (v0.970: Sanitization)
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        #region VariablesDeclaration

        //Mini version
        public static String PlayerMove;

        public static String NextLine;
        // Mini version: Removed unused variables
        //public static string FinalPositions;
        public static int Move_Number_Global;

        //Mini edition: Removed dangerousness and stupid flags
        //public static String ThisIsStupidMove = "N";
        //public static bool move_dangerousness = false; // v0.992: Add dangerousness flag
        //public static bool Danger_for_piece;
        public static bool ThereIsCheck;
        //Is it possible to eat a piece of greater value?
        public static bool possibility_to_eat;
        public static int ValueOfTargetPiece = 0;
        // Chessboard for logging purposes
        // public static String[,] SkakieraLog = new String[8, 8];  // Δήλωση πίνακα που αντιπροσωπεύει τη σκακιέρα

        //v0.980: Change small Strings to Int
        //0 = Not dangerous square
        //1 = Dangerous square
        // public static int[,] Skakiera_Dangerous_Squares = new int[8, 8];
        //v0.990: New dangerous squares check to see if the computer moves his pieve into a square,
        //where the only defender was the same moving piece! (and there exists an attacker of course...)
        //public static int[,] Skakiera_Dangerous_Squares_2 = new int[8, 8];
        public static int[,] Number_of_defenders = new int[8, 8];
        public static int[,] Number_of_attackers = new int[8, 8];
        //v0.980: Removed Attackers_coordinates_column/ rank since they are not used!
        //public static int[,] Attackers_coordinates_column = new int[8, 8];
        //public static int[,] Attackers_coordinates_rank = new int[8, 8];
        public static int[,] Value_of_defenders = new int[8, 8];
        public static int[,] Value_of_attackers = new int[8, 8];
        //v0.980: Removed Exception_defender_column/ rank since they are not used!
        //public static int[,] Exception_defender_column = new int[8, 8];
        //public static int[,] Exception_defender_rank = new int[8, 8];

        //Parameter which determined the weight of danger in the counting of the score of positions
        //v0.980: Removed humanDangerParameter and computerDangerParameter
        //public static int humanDangerParameter = 0;
        //public static int computerDangerParameter = 1;

        // Is it possible to eat back the piece that was moved by the computer?
        public static bool possibility_to_eat_back;

        // v0.970 added
        public static int ValueOfHumanMovingPiece = 0;
        public static int ValueOfMovingPiece = 0;

        // Variables to store the scores of positions during the analysis
        // v0.970: Changed them to integers
        public static int Temp_Score_Move_0;
        public static int Temp_Score_Move_1_human;
        public static int Temp_Score_Move_2;
        public static int Temp_Score_Move_3_human;
        public static int Temp_Score_Move_4;

        public static int bestNode0, bestNode1, bestNode2, bestNode3, bestNode4;

        // These arrays will hold the Minimax analysis nodes data (skakos)
        // Dimension ,1: For the score
        // Dimension ,2: For the parent
        // Dimensions 3-6: For the initial move starting/ finishing columns-ranks (only for the 0-level array)
        // Changed them to integers for less memory usage
        // v0.980: Reduced size of arrays
        public static int[,] NodesAnalysis0 = new int[1000000, 6];
        public static int[,] NodesAnalysis1 = new int[1000000, 2];
        public static int[,] NodesAnalysis2 = new int[1000000, 2];
        public static int[,] NodesAnalysis3 = new int[10000000, 2];
        public static int[,] NodesAnalysis4 = new int[10000000, 2];  // Increased depth => Increased size (logical...)

        public static int[] bestNodes0 = new int[10000000];
        public static int[] bestNodes1 = new int[10000000];
        public static int[] bestNodes2 = new int[10000000];
        public static int[] bestNodes3 = new int[10000000];
        public static int[] bestNodes4 = new int[10000000];

        public static int m_StartingColumnNumber1_public;
        public static int m_StartingRank1_public;
        public static int m_FinishingColumnNumber1_public;
        public static int m_FinishingRank1_public;
        public static int m_StartingColumnNumber2_public;
        public static int m_StartingRank2_public;
        public static int m_FinishingColumnNumber2_public;
        public static int m_FinishingRank2_public;

        // For the logs...
        // v0.991: Variable to denote if logs are activated
        //public static bool activateLogs;
        // v0.991: Variables to store the moves the computer thinks of
        //public static String Move0_text;
        //public static String Move1_text;
        //public static String Move2_text;
        //public static String Move3_text; // v0.992
        //public static String Move4_text; // v0.992
        //public static String[] NodesAnalysis0_MoveText = new String[1000000];  //v0.991
        //public static String[] NodesAnalysis1_MoveText = new String[1000000];  //v0.991
        //public static String[] NodesAnalysis2_MoveText = new String[1000000];  //v0.991
        //public static String[] NodesAnalysis3_MoveText = new String[10000000];  //v0.992 (Initially: 100000)
        //public static String[] NodesAnalysis4_MoveText = new String[10000000];  //v0.992 (Initially: 100000)
        //public static String Best_Variant_text;
        // Tables to store the chessboards to show in the logs
        //public static String[,,] NodesAnalysis0_Chessboard = new String[8, 8, 1000000];  //v0.990
        //public static String[,,] NodesAnalysis1_Chessboard = new String[8, 8, 1000000];  //v0.990
        //public static String[,,] NodesAnalysis2_Chessboard = new String[8, 8, 1000000];  //v0.990
        //public static String[,,] NodesAnalysis2_Chessboard_2 = new String[8, 8, 1000000];  //v0.990
        //public static String[,,] NodesAnalysis4_Chessboard_4 = new String[8, 8, 1000000];  //v0.990
        //public static String[,,] NodesAnalysis0_Chessboard_before = new String[8, 8, 1000000];  //v0.990
        //public static String[,,] NodesAnalysis1_Chessboard_before = new String[8, 8, 1000000];  //v0.990
        //public static String[,,] NodesAnalysis2_Chessboard_before = new String[8, 8, 1000000];  //v0.990

        // Nodes count (per level)
        public static int Nodes_Total_count;
        public static int NodeLevel_0_count;
        public static int NodeLevel_1_count;
        public static int NodeLevel_2_count;
        public static int NodeLevel_3_count;
        public static int NodeLevel_4_count;

        // If HY eats a piece, then make the square a preferred target!!!
        public static int Human_last_move_target_column;
        public static int Human_last_move_target_row;

        // The chessboard (= 'skakiera' in Greek)
        public static String[,] Skakiera = new String[8, 8];  // Δήλωση πίνακα που αντιπροσωπεύει τη σκακιέρα

        public static String m_PlayerColor;
        public static String m_WhoPlays;
        public static String m_WhichColorPlays;
        public static String MovingPiece;

        // Variable to store temporarily the piece that is moving
        public static String ProsorinoKommati;

        // Variables to check the legality of the move
        public static bool exit_elegxos_nomimothtas = false;
        public static int h;
        public static int p;
        public static int how_to_move_Rank;
        public static int how_to_move_Column;

        public static bool KingCheck = false;

        // Coordinates of the starting square of the move
        public static String m_StartingColumn;
        public static int m_StartingRank;
        public static String m_FinishingColumn;
        public static int m_FinishingRank;

        // Variable for en passant moves
        public static bool enpassant_occured;

        // Mini version: Removed all these...
        // Move number
        //public static int Move;
        //public static int number_of_moves_analysed;

        // Variable to show if promotion of a pawn occured
        public static bool Promotion_Occured = false;

        // Variable to show if castrling occured
        public static bool Castling_Occured = false;
        // v0.9921: Castling moves
        public static bool White_Castling_Occured = false;
        public static bool Black_Castling_Occured = false;

        // Variables to show where the kings are in the chessboard
        public static int WhiteKingColumn;
        public static int WhiteKingRank;
        public static int BlKingColumn;
        public static int BlKingRank;

        // Variables to show if king is in check
        public static bool WhiteKingCheck;
        public static bool BlackKingCheck;

        // Variable to show if a move is found for the H/Y to do
        public static bool Best_Move_Found;

        // Variables to help find if a king is under check.
        // (see CheckForWhiteCheck and CheckForBlackCheck functions)
        public static bool DangerFromRight;
        public static bool DangerFromLeft;
        public static bool DangerFromUp;
        public static bool DangerFromDown;
        public static bool DangerFromUpRight;
        public static bool DangerFromDownRight;
        public static bool DangerFromUpLeft;
        public static bool DangerFromDownLeft;

        // Volumn number inserted by the user
        public static int m_StartingColumnNumber;
        public static int m_FinishingColumnNumber;

        ///////////////////////////////////////////////////////////////////////////////////////////////////
        // Μεταβλητές για τον έλεγχο της "ορθότητας" και της "νομιμότητας" μιας κίνησης του χρήστη
        // Variables to check the correctess (ορθότητα) and the legality (νομιμότητα) of the moves
        ///////////////////////////////////////////////////////////////////////////////////////////////////

        // Variable for the correctness of the move
        public static bool m_OrthotitaKinisis;
        // Variable for the legality of the move
        public static bool m_NomimotitaKinisis;
        // Has the user entered a wrong column?
        public static bool m_WrongColumn;

        // Variables for 'For' loops
        public static int i;
        public static int j;

        // User choices
        // Mini version: Removed unused variables
        //public static int ApophasiXristi = 1;
        //public static int choise_of_user;

        //////////////////////////////////////
        // Computer Thought
        //////////////////////////////////////
        // Chessboards used for the computer throught
        public static String[,] Skakiera_Move_0 = new String[8, 8]; // Δήλωση πίνακα που αντιπροσωπεύει τη σκακιέρα
        public static String[,] Skakiera_Move_After = new String[8, 8];
        public static String[,] Skakiera_Thinking = new String[8, 8];
        public static String[,] Skakiera_CM_Check = new String[8, 8];
        // Rest of variables used for computer thought
        public static int Current_Move_Score;
        public static int Best_Move_StartingColumnNumber;
        public static int Best_Move_FinishingColumnNumber;
        public static int Best_Move_StartingRank;
        public static int Best_Move_FinishingRank;
        public static int Move_Analyzed;
        public static bool Stop_Analyzing;
        // Thinking depth of the application
        // Possible values: 2 (for 3-ply search), 4 (for 5-ply search)
        // Thinking depth must be ζυγός number because the nodes are recorded only in the Analyze_Computer functions!
        public static int Thinking_Depth;
        public static int m_StartingColumnNumber_HY;
        public static int m_FinishingColumnNumber_HY;
        public static int m_StartingRank_HY;
        public static int m_FinishingRank_HY;
        public static bool First_Call;
        public static String Who_Is_Analyzed;
        public static String MovingPiece_HY;

        // For writing the computer move
        public static String HY_Starting_Column_Text;
        public static String HY_Finishing_Column_Text;

        // Coordinates of the square Where the player can perform en passant
        public static int enpassant_possible_target_rank;
        public static int enpassant_possible_target_column;

        public static bool White_King_Moved = false;
        public static bool Black_King_Moved = false;
        public static bool Castling_Move = false;

        public static String prev_MovingPiece;
        public static int prev_Best_Move_StartingColumnNumber;
        public static int prev_Best_Move_StartingRank;
        public static bool Human_Move_Found;
        public static bool Pat_Found;
        public static bool Mate_Found;
        public static int m_StartingColumnNumber_mate;
        public static int m_FinishingColumnNumber_mate;
        public static int m_StartingRank_mate;
        public static int m_FinishingRank_mate;

        #endregion VariablesDeclaration

        ///////////////////////////////////////////////////////////////////////////////////////////////////
        // END OF VARIABLES DECLARATION
        ///////////////////////////////////////////////////////////////////////////////////////////////////


        static void Main(string[] args)
        {

            /////////////////////////////////////////////////////////////////////////
            // CHANGE Thinking_Depth TO HAVE MORE THINKING DEPTHS
            // BUT REMEMBER TO ALSO ADD Analyze_Move functions!
            /////////////////////////////////////////////////////////////////////////
            // ΠΡΟΣΟΧΗ: Αν βάλω τον υπολογιστή να σκεφτεί σε βάθος 1 κίνησης
            // (ήτοι Thinking_Depth = 0), τότε ΔΕΝ σκέφτεται σωστά! Αυτό συμβαίνει
            // διότι η HumanMove πρέπει να κληθεί τουλάχιστον μία φορά για να
            // ολοκληρωθεί σωστά τουλάχιστον ένας πλήρης κύκλος σκέψης του ΗΥ.
            /////////////////////////////////////////////////////////////////////////

            // MiniMax algorithm currently only utilizes 4-ply thinking depth
            // Add more "for loops" in the required section in ComputerMove to allow more deep thinking
            // However remember that the NodesAnalysis table has a limit!!! (and so does the memory)
            // Thinking depth must be ζυγός number because the nodes are recorded only in the Analyze_Computer functions!

            //Thinking_Depth = 2;
            Thinking_Depth = 4;

            Console.WriteLine("\nHuo Chess v0.9921 by Spiros I. Kakos (huo) [2021] - C# Mini Edition");

            /////////////////////
            // Setup game
            /////////////////////
            Console.Write("\nColor (w/b)? ");
            String the_choise_of_user = Console.ReadLine();

            //v0.980: Reduce choices (only 'w' and 'b' valid)
            if (the_choise_of_user.CompareTo("w") == 0)
            {
                m_PlayerColor = "White";
                m_WhoPlays = "Human";
            }
            else if (the_choise_of_user.CompareTo("b") == 0)
            {
                m_PlayerColor = "Black";
                m_WhoPlays = "HY";
            }

            // Initial values
            // Mini version: Update Move to Move_Global
            Move_Number_Global = 0;
            m_WhichColorPlays = "White";
            //v0.9921
            White_King_Moved = false;
            Black_King_Moved = false;
            White_Castling_Occured = false;
            Black_Castling_Occured = false;

            // Setup startup position
            Starting_position();

            // If it is the turn of HY to play, then call the respective function to implement HY thought

            bool exit_game = false;

            do
            {

                if (m_WhoPlays.CompareTo("HY") == 0)
                {
                    // Call HY Thought function
                    Move_Analyzed = 0;
                    Stop_Analyzing = false;
                    First_Call = true;
                    Best_Move_Found = false;
                    Who_Is_Analyzed = "HY";

                    // CHECK DANGER - Start
                    // Mini version: Remioved
                    #region checkDanger
                    // Find the dangerous squares in the chessboard, where if the HY
                    // moves its piece, it will immediately (or most probably) loose it.

                    //for (i = 0; i <= 7; i++)
                    //{
                    //    for (j = 0; j <= 7; j++)
                    //    {
                    //            //v0.980: Change small Strings to Int
                    //            Skakiera_Dangerous_Squares[i, j] = 0;
                    //    }
                    //}

                    //// Initialize variables for finding the dangerous squares
                    //for (int di = 0; di <= 7; di++)
                    //{
                    //    for (int dj = 0; dj <= 7; dj++)
                    //    {
                    //        Number_of_attackers[di, dj] = 0;
                    //        Number_of_defenders[di, dj] = 0;
                    //        Value_of_attackers[di, dj] = 0;
                    //        //v0.980: Removed Attackers_coordinates_column/ rank since they are not used!
                    //        //Attackers_coordinates_column[di, dj] = 0;
                    //        //Attackers_coordinates_rank[di, dj] = 0;
                    //        Value_of_defenders[di, dj] = 0;
                    //        //v0.980: Removed Exception_defender_column/ rank since they are not used!
                    //        //Exception_defender_column[di, dj] = -9;
                    //        //Exception_defender_rank[di, dj] = -9;
                    //    }
                    //}

                    //FindAttackers(Skakiera);
                    //FindDefenders(Skakiera);

                    #endregion checkDanger
                    // CHECK DANGER - End


                    ComputerMove(Skakiera);
                }
                else if (m_WhoPlays.CompareTo("Human") == 0)
                {
                    ////////////////////////////
                    // Human enters his move
                    ////////////////////////////

                    // Mini version: Made code more concise
                    Console.WriteLine("");
                    Console.Write("Enter move (e.g. e2e4): ");
                    PlayerMove = Console.ReadLine().ToUpper();
                    m_StartingColumn = PlayerMove.Substring(0, 1);
                    m_StartingRank = Int32.Parse(PlayerMove.Substring(1, 1));
                    m_FinishingColumn = PlayerMove.Substring(2, 1);
                    m_FinishingRank = Int32.Parse(PlayerMove.Substring(3, 1));

                    //Console.WriteLine("");
                    //Console.Write("Starting column (A to H)...");
                    //m_StartingColumn = Console.ReadLine().ToUpper();

                    //Console.Write("Starting rank (1 to 8).....");
                    //m_StartingRank = Int32.Parse(Console.ReadLine());

                    //Console.Write("Finishing column (A to H)...");
                    //m_FinishingColumn = Console.ReadLine().ToUpper();

                    //Console.Write("Finishing rank (1 to 8).....");
                    //m_FinishingRank = Int32.Parse(Console.ReadLine());

                    // Show the move entered
                    // Mini version: Do not show the move again!
                    //String huoMove = String.Concat("Your move: ", m_StartingColumn, m_StartingRank.ToString(), " -> " );
                    //huoMove = String.Concat( huoMove, m_FinishingColumn, m_FinishingRank.ToString() );
                    //Console.WriteLine( huoMove );

                    //Console.Clear();
                    Console.WriteLine("");
                    Console.WriteLine("Thinking...");

                    // Check the move entered by the Human for correctness (='Orthotita' in Greek) and legality (='Nomimotita' in Greek)
                    Enter_move();
                }

            } while (exit_game == false);

        }

        // v0.990 changes
        public static bool CheckForBlackCheck(string[,] BCSkakiera)
        {
            // Check if the BK is under threat

            bool KingCheck;
            //v0.990
            int klopa;

            ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Εύρεση των συντεταγμένων του βασιλιά.
            // Αν σε κάποιο τετράγωνο βρεθεί ότι υπάρχει ένας βασιλιάς, τότε απλά καταγράφεται η τιμή του εν λόγω
            // τετραγώνου στις αντίστοιχες μεταβλητές που δηλώνουν τη στήλη και τη γραμμή στην οποία υπάρχει μαύρος
            // βασιλιάς.
            // ΠΡΟΣΟΧΗ: Γράφω (i+1) αντί για i και (j+1) αντί για j γιατί το πρώτο στοιχείο του πίνακα BCSkakiera[(8),(8)]
            // είναι το BCSkakiera[(0),(0)] και ΟΧΙ το BCSkakiera[(1),(1)]!
            ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

            for (i = 0; i <= 7; i++)
            {
                for (j = 0; j <= 7; j++)
                {

                    if (BCSkakiera[(i), (j)].CompareTo("Black King") == 0)
                    {
                        BlKingColumn = (i + 1);
                        BlKingRank = (j + 1);
                    }

                }
            }

            ///////////////////////////////////////////////////////////////
            // Έλεγχος του αν ο μαύρος βασιλιάς υφίσταται "σαχ"
            ///////////////////////////////////////////////////////////////

            KingCheck = false;

            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Ελέγχουμε αρχικά αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΤΑ ΔΕΞΙΑ ΤΟΥ. Για να μην βγούμε έξω από τα
            // όρια της BCSkakiera[(8),(8)] έχουμε προσθέσει τον έλεγχο (BlKingColumn + 1) <= 8 στο "if". Αρχικά ο "κίνδυνος"
            // από τα "δεξιά" είναι υπαρκτός, άρα DangerFromRight = true. Ωστόσο αν βρεθεί ότι στα δεξιά του μαύρου βασι-
            // λιά υπάρχει κάποιο μαύρο κομμάτι, τότε δεν είναι δυνατόν ο εν λόγω βασιλιάς να υφίσταται σαχ από τα δεξιά
            // του (αφού θα "προστατεύεται" από το κομμάτι ιδίου χρώματος), οπότε η DangerFromRight = false και ο έλεγχος
            // για απειλές από τα δεξιά σταματάει (για αυτό και έχω προσθέσει την προϋπόθεση (DangerFromRight == true) στα
            // "if" που κάνουν αυτόν τον έλεγχο).
            // Αν όμως δεν υπάρχει κανένα μαύρο κομμάτι δεξιά του βασιλιά για να τον προστατεύει, τότε συνεχίζει να
            // υπάρχει πιθανότητα να απειλείται ο βασιλιάς από τα δεξιά του, οπότε ο έλεγχος συνεχίζεται.
            // Σημείωση: Ο έλεγχος γίνεται για πιθανό σαχ από πύργο ή βασίλισσα αντίθετου χρώματος.
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromRight = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingColumn + klopa) <= 8) && (DangerFromRight == true))
                {
                    if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("Black Queen") == 0))
                        DangerFromRight = false;
                    else if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - 1)].CompareTo("White King") == 0))
                        DangerFromRight = false;
                }
            }



            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΤΑ ΑΡΙΣΤΕΡΑ ΤΟΥ (από πύργο ή βασίλισσα).
            ///////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromLeft = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingColumn - klopa) >= 1) && (DangerFromLeft == true))
                {
                    if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("Black Queen") == 0))
                        DangerFromLeft = false;
                    else if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - 1)].CompareTo("White King") == 0))
                        DangerFromLeft = false;
                }
            }



            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΠΑΝΩ (από πύργο ή βασίλισσα).
            ///////////////////////////////////////////////////////////////////////////////////////////////////////


            DangerFromUp = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingRank + klopa) <= 8) && (DangerFromUp == true))
                {
                    if ((BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("Black Queen") == 0))
                        DangerFromUp = false;
                    else if ((BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank + klopa - 1)].CompareTo("White King") == 0))
                        DangerFromUp = false;
                }
            }



            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΚΑΤΩ (από πύργο ή βασίλισσα).
            ///////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromDown = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingRank - klopa) >= 1) && (DangerFromDown == true))
                {
                    if ((BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("Black Queen") == 0))
                        DangerFromDown = false;
                    else if ((BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn - 1), (BlKingRank - klopa - 1)].CompareTo("White King") == 0))
                        DangerFromDown = false;
                }
            }



            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΠΑΝΩ-ΔΕΞΙΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromUpRight = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingColumn + klopa) <= 8) && ((BlKingRank + klopa) <= 8) && (DangerFromUpRight == true))
                {
                    if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Queen") == 0))
                        DangerFromUpRight = false;
                    else if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White King") == 0))
                        DangerFromUpRight = false;
                }
            }



            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΚΑΤΩ-ΑΡΙΣΤΕΡΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromDownLeft = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingColumn - klopa) >= 1) && ((BlKingRank - klopa) >= 1) && (DangerFromDownLeft == true))
                {
                    if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Queen") == 0))
                        DangerFromDownLeft = false;
                    else if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White King") == 0))
                        DangerFromDownLeft = false;
                }
            }


            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΚΑΤΩ-ΔΕΞΙΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromDownRight = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingColumn + klopa) <= 8) && ((BlKingRank - klopa) >= 1) && (DangerFromDownRight == true))
                {
                    if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("Black Queen") == 0))
                        DangerFromDownRight = false;
                    else if ((BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn + klopa - 1), (BlKingRank - klopa - 1)].CompareTo("White King") == 0))
                        DangerFromDownRight = false;
                }
            }



            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το μαύρο βασιλιά ΑΠΟ ΠΑΝΩ-ΑΡΙΣΤΕΡΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromUpLeft = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((BlKingColumn - klopa) >= 1) && ((BlKingRank + klopa) <= 8) && (DangerFromUpLeft == true))
                {
                    if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Bishop") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Queen") == 0))
                        KingCheck = true;
                    else if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Pawn") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Rook") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Knight") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Bishop") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("Black Queen") == 0))
                        DangerFromUpLeft = false;
                    else if ((BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Pawn") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Rook") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White Knight") == 0) || (BCSkakiera[(BlKingColumn - klopa - 1), (BlKingRank + klopa - 1)].CompareTo("White King") == 0))
                        DangerFromUpLeft = false;
                }
            }


            //////////////////////////////////////////////////////////////////////////
            // Έλεγχος για το αν ο μαύρος βασιλιάς απειλείται από πιόνι.
            //////////////////////////////////////////////////////////////////////////

            if (((BlKingColumn + 1) <= 8) && ((BlKingRank - 1) >= 1))
            {
                if (BCSkakiera[(BlKingColumn + 1 - 1), (BlKingRank - 1 - 1)].CompareTo("White Pawn") == 0)
                {
                    KingCheck = true;
                }
            }


            if (((BlKingColumn - 1) >= 1) && ((BlKingRank - 1) >= 1))
            {
                if (BCSkakiera[(BlKingColumn - 1 - 1), (BlKingRank - 1 - 1)].CompareTo("White Pawn") == 0)
                {
                    KingCheck = true;
                }
            }


            ///////////////////////////////////////////////////////////////////////
            // Έλεγχος για το αν ο μαύρος βασιλιάς απειλείται από ίππο.
            ///////////////////////////////////////////////////////////////////////

            if (((BlKingColumn + 1) <= 8) && ((BlKingRank + 2) <= 8))
                if (BCSkakiera[(BlKingColumn + 1 - 1), (BlKingRank + 2 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            if (((BlKingColumn + 2) <= 8) && ((BlKingRank - 1) >= 1))
                if (BCSkakiera[(BlKingColumn + 2 - 1), (BlKingRank - 1 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            if (((BlKingColumn + 1) <= 8) && ((BlKingRank - 2) >= 1))
                if (BCSkakiera[(BlKingColumn + 1 - 1), (BlKingRank - 2 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            if (((BlKingColumn - 1) >= 1) && ((BlKingRank - 2) >= 1))
                if (BCSkakiera[(BlKingColumn - 1 - 1), (BlKingRank - 2 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            if (((BlKingColumn - 2) >= 1) && ((BlKingRank - 1) >= 1))
                if (BCSkakiera[(BlKingColumn - 2 - 1), (BlKingRank - 1 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            if (((BlKingColumn - 2) >= 1) && ((BlKingRank + 1) <= 8))
                if (BCSkakiera[(BlKingColumn - 2 - 1), (BlKingRank + 1 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            if (((BlKingColumn - 1) >= 1) && ((BlKingRank + 2) <= 8))
                if (BCSkakiera[(BlKingColumn - 1 - 1), (BlKingRank + 2 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            if (((BlKingColumn + 2) <= 8) && ((BlKingRank + 1) <= 8))
                if (BCSkakiera[(BlKingColumn + 2 - 1), (BlKingRank + 1 - 1)].CompareTo("White Knight") == 0)
                    KingCheck = true;

            return KingCheck;
        }

        // v0.990 changes
        //public static bool CheckForBlackMate(string[,] BMSkakiera)
        //{
        //    // Check if the BK is under checkmate

        //    bool Mate;
        //    //v0.990: Changed MovingPiece and ProsorinoKommati with the CBM variables
        //    String MovingPieceCBM;
        //    String ProsorinoKommatiCBM;

        //    /////////////////////////////////////////////////////////////////////////////////////////////////////////
        //    // Μεταβλητή που χρησιμεύει στον έλεγχο για το αν υπάρχει ματ (βλ. συναρτήσεις CheckForWhiteMate() και
        //    // CheckForBlMate()).
        //    // Αναλυτικότερα, το πρόγραμμα ελέγχει αν αρχικά υπάρχει σαχ και, αν υπάρχει, ελέγχει αν αυτό το
        //    // σαχ μπορεί να αποφευχθεί με τη μετακίνηση του υπό απειλή βασιλιά σε κάποιο γειτονικό τετράγωνο.
        //    // Η μεταβλητή καταγράφει το αν συνεχίζει να υπάρχει πιθανότητα να υπάρχει ματ στη σκακιέρα.
        //    /////////////////////////////////////////////////////////////////////////////////////////////////////////

        //    bool DangerForMate;

        //    ////////////////////////////////////////////////////////////
        //    // Έλεγχος του αν υπάρχει "ματ" στον μαύρο βασιλιά
        //    ////////////////////////////////////////////////////////////

        //    Mate = false;
        //    DangerForMate = true;    // Αρχικά, προφανώς υπάρχει πιθανότητα να υπάρχει ματ στη σκακιέρα.
        //                             // Αν, ωστόσο, κάποια στιγμή βρεθεί ότι αν ο βασιλιάς μπορεί να μετακινηθεί
        //                             // σε ένα διπλανό τετράγωνο και να πάψει να υφίσταται σαχ, τότε παύει να
        //                             // υπάρχει πιθανότητα να υπάρχει ματ (προφανώς) και η μεταβλητή παίρνει την
        //                             // τιμή false.


        //    //////////////////////////////////////////////////////////////
        //    // Εύρεση των αρχικών συντεταγμένων του βασιλιά
        //    //////////////////////////////////////////////////////////////

        //    for (i = 0; i <= 7; i++)
        //    {
        //        for (j = 0; j <= 7; j++)
        //        {

        //            if (BMSkakiera[(i), (j)].CompareTo("Black King") == 0)
        //            {
        //                StartingBlKingColumn = (i + 1);
        //                StartingBlKingRank = (j + 1);
        //            }

        //        }
        //    }


        //    //////////////////////////////////////////////////
        //    // Έλεγχος αν ο μαύρος βασιλιάς είναι ματ
        //    //////////////////////////////////////////////////


        //    if (m_WhichColorPlays.CompareTo("Black") == 0)
        //    {

        //        ////////////////////////////////////////////////
        //        // Έλεγχος αν υπάρχει σαχ αυτή τη στιγμή
        //        ////////////////////////////////////////////////

        //        BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //        if (BlackKingCheck == false)     // Αν αυτή τη στιγμή δεν υφίσταται σαχ, τότε να μη συνεχιστεί ο έλεγχος
        //            DangerForMate = false;         // καθώς ΔΕΝ συνεχίζει να υφίσταται πιθανότητα να υπάρχει ματ.

        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα πάνω
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingBlKingRank < 8)
        //        {
        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1 + 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingRank - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά προς τα πάνω και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.
        //                // Ο έλεγχος γίνεται μόνο αν στο τετράγωνο που μετακινείται προσωρινά ο βασιλιάς δεν υπάρχει άλλο κομμάτι
        //                // του ίδιου χρώματος που να τον εμποδίζει και αν, φυσικά, ο βασιλιάς δεν βγαίνει έξω από τη σκακιέρα με
        //                // αυτή του την κίνηση και αν, προφανώς, συνεχίζει να υπάρχει πιθανότητα να ύπάρχει ματ (καθώς αν δεν
        //                // υπάρχει τέτοια πιθανότητα, τότε ο έλεγχος είναι άχρηστος).

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1 + 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1 + 1)] = ProsorinoKommatiCBM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα πάνω-δεξιά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingBlKingColumn < 8) && (StartingBlKingRank < 8))
        //        {

        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1 + 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingRank - 1 + 1) <= 7) && ((StartingBlKingColumn - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1 + 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1 + 1)] = ProsorinoKommatiCBM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα δεξιά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingBlKingColumn < 8)
        //        {

        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingColumn - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1)] = ProsorinoKommatiCBM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα κάτω-δεξιά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingBlKingColumn < 8) && (StartingBlKingRank > 1))
        //        {

        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1 - 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingRank - 1 - 1) >= 0) && ((StartingBlKingColumn - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1 - 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1 + 1), (StartingBlKingRank - 1 - 1)] = ProsorinoKommatiCBM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα κάτω
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingBlKingRank > 1)
        //        {

        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1 - 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingRank - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά προς τα πάνω και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1 - 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1 - 1)] = ProsorinoKommatiCBM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα κάτω-αριστερά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingBlKingColumn > 1) && (StartingBlKingRank > 1))
        //        {

        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1 - 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingRank - 1 - 1) >= 0) && ((StartingBlKingColumn - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1 - 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1 - 1)] = ProsorinoKommatiCBM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα αριστερά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingBlKingColumn > 1)
        //        {

        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingColumn - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1)] = ProsorinoKommatiCBM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο μαύρος βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα πάνω-αριστερά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingBlKingColumn > 1) && (StartingBlKingRank < 8))
        //        {

        //            MovingPieceCBM = BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)];
        //            ProsorinoKommatiCBM = BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1 + 1)];

        //            if ((ProsorinoKommatiCBM.CompareTo("Black Queen") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Rook") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Knight") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Bishop") == 1) && (ProsorinoKommatiCBM.CompareTo("Black Pawn") == 1) && (DangerForMate == true) && ((StartingBlKingRank - 1 + 1) <= 7) && ((StartingBlKingColumn - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = "";
        //                BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1 + 1)] = MovingPieceCBM;
        //                BlackKingCheck = CheckForBlackCheck(BMSkakiera);

        //                if (BlackKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                BMSkakiera[(StartingBlKingColumn - 1), (StartingBlKingRank - 1)] = MovingPieceCBM;
        //                BMSkakiera[(StartingBlKingColumn - 1 - 1), (StartingBlKingRank - 1 + 1)] = ProsorinoKommatiCBM;

        //            }

        //        }

        //        if (DangerForMate == true)
        //            Mate = true;

        //    }

        //    return Mate;
        //}

        // v0.990 changes
        public static bool CheckForWhiteCheck(string[,] WCSkakiera)
        {
            // Check if the WK is under check

            bool KingCheck;
            //v0.990
            int klopa;

            ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Εύρεση των συντεταγμένων του βασιλιά.
            // Αν σε κάποιο τετράγωνο βρεθεί ότι υπάρχει ένας βασιλιάς, τότε απλά καταγράφεται η τιμή του εν λόγω
            // τετραγώνου στις αντίστοιχες μεταβλητές που δηλώνουν τη στήλη και τη γραμμή στην οποία υπάρχει λευκός
            // βασιλιάς.
            // ΠΡΟΣΟΧΗ: Γράφω (i+1) αντί για i και (j+1) αντί για j γιατί το πρώτο στοιχείο του πίνακα WCWCSkakiera[(8),(8)]
            // είναι το WCSkakiera[(0),(0)] και ΟΧΙ το WCSkakiera[(1),(1)]!
            ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

            for (i = 0; i <= 7; i++)
            {
                for (j = 0; j <= 7; j++)
                {

                    if (WCSkakiera[(i), (j)].CompareTo("White King") == 0)
                    {
                        WhiteKingColumn = (i + 1);
                        WhiteKingRank = (j + 1);
                    }

                }
            }

            ///////////////////////////////////////////////////////////////
            // Έλεγχος του αν ο λευκός βασιλιάς υφίσταται "σαχ"
            ///////////////////////////////////////////////////////////////

            KingCheck = false;

            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Ελέγχουμε αρχικά αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΤΑ ΔΕΞΙΑ ΤΟΥ. Για να μην βγούμε έξω από τα
            // όρια της WCSkakiera[(8),(8)] έχουμε προσθέσει τον έλεγχο (WhiteKingColumn + 1) <= 8 στο "if". Αρχικά ο "κίνδυνος"
            // από τα "δεξιά" είναι υπαρκτός, άρα DangerFromRight = true. Ωστόσο αν βρεθεί ότι στα δεξιά του λευκού βασι-
            // λιά υπάρχει κάποιο λευκό κομμάτι, τότε δεν είναι δυνατόν ο εν λόγω βασιλιάς να υφίσταται σαχ από τα δεξιά
            // του (αφού θα "προστατεύεται" από το κομμάτι ιδίου χρώματος), οπότε η DangerFromRight = false και ο έλεγχος
            // για απειλές από τα δεξιά σταματάει (για αυτό και έχω προσθέσει την προϋπόθεση (DangerFromRight == true) στα
            // "if" που κάνουν αυτόν τον έλεγχο).
            // Αν όμως δεν υπάρχει κανένα λευκό κομμάτι δεξιά του βασιλιά για να τον προστατεύει, τότε συνεχίζει να
            // υπάρχει πιθανότητα να απειλείται ο βασιλιάς από τα δεξιά του, οπότε ο έλεγχος συνεχίζεται.
            // Σημείωση: Ο έλεγχος γίνεται για πιθανό σαχ από πύργο ή βασίλισσα αντίθετου χρώματος.
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromRight = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingColumn + klopa) <= 8) && (DangerFromRight == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("White Queen") == 0))
                        DangerFromRight = false;
                    else if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - 1)].CompareTo("Black King") == 0))
                        DangerFromRight = false;
                }
            }


            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΤΑ ΑΡΙΣΤΕΡΑ ΤΟΥ (από πύργο ή βασίλισσα).
            ///////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromLeft = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingColumn - klopa) >= 1) && (DangerFromLeft == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("White Queen") == 0))
                        DangerFromLeft = false;
                    else if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - 1)].CompareTo("Black King") == 0))
                        DangerFromLeft = false;
                }
            }


            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΠΑΝΩ (από πύργο ή βασίλισσα).
            ///////////////////////////////////////////////////////////////////////////////////////////////////////


            DangerFromUp = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingRank + klopa) <= 8) && (DangerFromUp == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Queen") == 0))
                        DangerFromUp = false;
                    else if ((WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black King") == 0))
                        DangerFromUp = false;
                }
            }


            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΚΑΤΩ (από πύργο ή βασίλισσα).
            ///////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromDown = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingRank - klopa) >= 1) && (DangerFromDown == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Queen") == 0))
                        DangerFromDown = false;
                    else if ((WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black King") == 0))
                        DangerFromDown = false;
                }
            }


            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΠΑΝΩ-ΔΕΞΙΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromUpRight = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingColumn + klopa) <= 8) && ((WhiteKingRank + klopa) <= 8) && (DangerFromUpRight == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Queen") == 0))
                        DangerFromUpRight = false;
                    else if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black King") == 0))
                        DangerFromUpRight = false;
                }
            }


            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΚΑΤΩ-ΑΡΙΣΤΕΡΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromDownLeft = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingColumn - klopa) >= 1) && ((WhiteKingRank - klopa) >= 1) && (DangerFromDownLeft == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Queen") == 0))
                        DangerFromDownLeft = false;
                    else if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black King") == 0))
                        DangerFromDownLeft = false;
                }
            }

            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΚΑΤΩ-ΔΕΞΙΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromDownRight = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingColumn + klopa) <= 8) && ((WhiteKingRank - klopa) >= 1) && (DangerFromDownRight == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("White Queen") == 0))
                        DangerFromDownRight = false;
                    else if ((WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn + klopa - 1), (WhiteKingRank - klopa - 1)].CompareTo("Black King") == 0))
                        DangerFromDownRight = false;
                }
            }


            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος αν υπάρχει κίνδυνος για το λευκό βασιλιά ΑΠΟ ΠΑΝΩ-ΑΡΙΣΤΕΡΑ ΤΟΥ (από βασίλισσα ή αξιωματικό).
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            DangerFromUpLeft = true;

            for (klopa = 1; klopa <= 7; klopa++)
            {
                if (((WhiteKingColumn - klopa) >= 1) && ((WhiteKingRank + klopa) <= 8) && (DangerFromUpLeft == true))
                {
                    if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Queen") == 0))
                        KingCheck = true;
                    else if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Rook") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Knight") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Bishop") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("White Queen") == 0))
                        DangerFromUpLeft = false;
                    else if ((WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Pawn") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Rook") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black Knight") == 0) || (WCSkakiera[(WhiteKingColumn - klopa - 1), (WhiteKingRank + klopa - 1)].CompareTo("Black King") == 0))
                        DangerFromUpLeft = false;
                }
            }



            //////////////////////////////////////////////////////////////////////////
            // Έλεγχος για το αν ο λευκός βασιλιάς απειλείται από πιόνι.
            //////////////////////////////////////////////////////////////////////////

            if (((WhiteKingColumn + 1) <= 8) && ((WhiteKingRank + 1) <= 8))
            {
                if (WCSkakiera[(WhiteKingColumn + 1 - 1), (WhiteKingRank + 1 - 1)].CompareTo("Black Pawn") == 0)
                {
                    KingCheck = true;
                }
            }


            if (((WhiteKingColumn - 1) >= 1) && ((WhiteKingRank + 1) <= 8))
            {
                if (WCSkakiera[(WhiteKingColumn - 1 - 1), (WhiteKingRank + 1 - 1)].CompareTo("Black Pawn") == 0)
                {
                    KingCheck = true;
                }
            }


            ///////////////////////////////////////////////////////////////////////
            // Έλεγχος για το αν ο λευκός βασιλιάς απειλείται από ίππο.
            ///////////////////////////////////////////////////////////////////////

            if (((WhiteKingColumn + 1) <= 8) && ((WhiteKingRank + 2) <= 8))
                if (WCSkakiera[(WhiteKingColumn + 1 - 1), (WhiteKingRank + 2 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            if (((WhiteKingColumn + 2) <= 8) && ((WhiteKingRank - 1) >= 1))
                if (WCSkakiera[(WhiteKingColumn + 2 - 1), (WhiteKingRank - 1 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            if (((WhiteKingColumn + 1) <= 8) && ((WhiteKingRank - 2) >= 1))
                if (WCSkakiera[(WhiteKingColumn + 1 - 1), (WhiteKingRank - 2 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            if (((WhiteKingColumn - 1) >= 1) && ((WhiteKingRank - 2) >= 1))
                if (WCSkakiera[(WhiteKingColumn - 1 - 1), (WhiteKingRank - 2 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            if (((WhiteKingColumn - 2) >= 1) && ((WhiteKingRank - 1) >= 1))
                if (WCSkakiera[(WhiteKingColumn - 2 - 1), (WhiteKingRank - 1 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            if (((WhiteKingColumn - 2) >= 1) && ((WhiteKingRank + 1) <= 8))
                if (WCSkakiera[(WhiteKingColumn - 2 - 1), (WhiteKingRank + 1 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            if (((WhiteKingColumn - 1) >= 1) && ((WhiteKingRank + 2) <= 8))
                if (WCSkakiera[(WhiteKingColumn - 1 - 1), (WhiteKingRank + 2 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            if (((WhiteKingColumn + 2) <= 8) && ((WhiteKingRank + 1) <= 8))
                if (WCSkakiera[(WhiteKingColumn + 2 - 1), (WhiteKingRank + 1 - 1)].CompareTo("Black Knight") == 0)
                    KingCheck = true;

            return KingCheck;
        }

        // v0.990 changes
        //public static bool CheckForWhiteMate(string[,] WMSkakiera)
        //{
        //    // Check if the WK is under checkmate

        //    bool Mate;
        //    //v0.990: Changed MovingPiece and ProsorinoKommati with the CWM variables
        //    String MovingPieceCWM;
        //    String ProsorinoKommatiCWM;

        //    /////////////////////////////////////////////////////////////////////////////////////////////////////////
        //    // Μεταβλητή που χρησιμεύει στον έλεγχο για το αν υπάρχει ματ (βλ. συναρτήσεις CheckForWhiteMate() και
        //    // CheckForBlMate()).
        //    // Αναλυτικότερα, το πρόγραμμα ελέγχει αν αρχικά υπάρχει σαχ και, αν υπάρχει, ελέγχει αν αυτό το
        //    // σαχ μπορεί να αποφευχθεί με τη μετακίνηση του υπό απειλή βασιλιά σε κάποιο γειτονικό τετράγωνο.
        //    // Η μεταβλητή καταγράφει το αν συνεχίζει να υπάρχει πιθανότητα να υπάρχει ματ στη σκακιέρα.
        //    /////////////////////////////////////////////////////////////////////////////////////////////////////////

        //    bool DangerForMate;

        //    ////////////////////////////////////////////////////////////
        //    // Έλεγχος του αν υπάρχει "ματ" στον λευκό βασιλιά
        //    ////////////////////////////////////////////////////////////

        //    Mate = false;
        //    DangerForMate = true;    // Αρχικά, προφανώς υπάρχει πιθανότητα να υπάρχει ματ στη σκακιέρα.
        //                             // Αν, ωστόσο, κάποια στιγμή βρεθεί ότι αν ο βασιλιάς μπορεί να μετακινηθεί
        //                             // σε ένα διπλανό τετράγωνο και να πάψει να υφίσταται σαχ, τότε παύει να
        //                             // υπάρχει πιθανότητα να υπάρχει ματ (προφανώς) και η μεταβλητή παίρνει την
        //                             // τιμή false.


        //    //////////////////////////////////////////////////////////////
        //    // Εύρεση των αρχικών συντεταγμένων του βασιλιά
        //    //////////////////////////////////////////////////////////////

        //    for (i = 0; i <= 7; i++)
        //    {
        //        for (j = 0; j <= 7; j++)
        //        {

        //            if (WMSkakiera[(i), (j)].CompareTo("White King") == 0)
        //            {
        //                StartingWhiteKingColumn = (i + 1);
        //                StartingWhiteKingRank = (j + 1);
        //            }

        //        }
        //    }


        //    //////////////////////////////////////////////////
        //    // Έλεγχος αν ο λευκός βασιλιάς είναι ματ
        //    //////////////////////////////////////////////////


        //    if (m_WhichColorPlays.CompareTo("White") == 0)
        //    {

        //        ////////////////////////////////////////////////
        //        // Έλεγχος αν υπάρχει σαχ αυτή τη στιγμή
        //        ////////////////////////////////////////////////

        //        WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //        if (WhiteKingCheck == false)     // Αν αυτή τη στιγμή δεν υφίσταται σαχ, τότε να μη συνεχιστεί ο έλεγχος
        //            DangerForMate = false;         // καθώς ΔΕΝ συνεχίζει να υφίσταται πιθανότητα να υπάρχει ματ.

        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα πάνω
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingWhiteKingRank < 8)
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1 + 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingRank - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά προς τα πάνω και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.
        //                // Ο έλεγχος γίνεται μόνο αν στο τετράγωνο που μετακινείται προσωρινά ο βασιλιάς δεν υπάρχει άλλο κομμάτι
        //                // του ίδιου χρώματος που να τον εμποδίζει και αν, φυσικά, ο βασιλιάς δεν βγαίνει έξω από τη σκακιέρα με
        //                // αυτή του την κίνηση και αν, προφανώς, συνεχίζει να υπάρχει πιθανότητα να ύπάρχει ματ (καθώς αν δεν
        //                // υπάρχει τέτοια πιθανότητα, τότε ο έλεγχος είναι άχρηστος).

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1 + 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1 + 1)] = ProsorinoKommatiCWM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα πάνω-δεξιά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingWhiteKingColumn < 8) && (StartingWhiteKingRank < 8))
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1 + 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingRank - 1 + 1) <= 7) && ((StartingWhiteKingColumn - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1 + 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1 + 1)] = ProsorinoKommatiCWM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα δεξιά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingWhiteKingColumn < 8)
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingColumn - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1)] = ProsorinoKommatiCWM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα κάτω-δεξιά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingWhiteKingColumn < 8) && (StartingWhiteKingRank > 1))
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1 - 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingRank - 1 - 1) >= 0) && ((StartingWhiteKingColumn - 1 + 1) <= 7))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1 - 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1 + 1), (StartingWhiteKingRank - 1 - 1)] = ProsorinoKommatiCWM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα κάτω
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingWhiteKingRank > 1)
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1 - 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingRank - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά προς τα πάνω και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1 - 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1 - 1)] = ProsorinoKommatiCWM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα κάτω-αριστερά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingWhiteKingColumn > 1) && (StartingWhiteKingRank > 1))
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1 - 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingRank - 1 - 1) >= 0) && ((StartingWhiteKingColumn - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1 - 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1 - 1)] = ProsorinoKommatiCWM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα αριστερά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if (StartingWhiteKingColumn > 1)
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingColumn - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1)] = ProsorinoKommatiCWM;

        //            }

        //        }


        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////
        //        // Έλεγχος του αν θα συνεχίσει να υπάρχει σαχ αν ο λευκός βασιλιάς προσπαθήσει να διαφύγει μετακινούμενος
        //        // προς τα πάνω-αριστερά
        //        ///////////////////////////////////////////////////////////////////////////////////////////////////////////////

        //        if ((StartingWhiteKingColumn > 1) && (StartingWhiteKingRank < 8))
        //        {

        //            MovingPieceCWM = WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)];
        //            ProsorinoKommatiCWM = WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1 + 1)];

        //            if ((ProsorinoKommatiCWM.CompareTo("White Queen") == 1) && (ProsorinoKommatiCWM.CompareTo("White Rook") == 1) && (ProsorinoKommatiCWM.CompareTo("White Knight") == 1) && (ProsorinoKommatiCWM.CompareTo("White Bishop") == 1) && (ProsorinoKommatiCWM.CompareTo("White Pawn") == 1) && (DangerForMate == true) && ((StartingWhiteKingRank - 1 + 1) <= 7) && ((StartingWhiteKingColumn - 1 - 1) >= 0))
        //            {

        //                // (Προσωρινή) μετακίνηση του βασιλιά και έλεγχος του αν συνεχίζει τότε να υπάρχει σαχ.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = "";
        //                WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1 + 1)] = MovingPieceCWM;
        //                WhiteKingCheck = CheckForWhiteCheck(WMSkakiera);

        //                if (WhiteKingCheck == false)
        //                    DangerForMate = false;

        //                // Επαναφορά της σκακιέρας στην κατάσταση στην οποία βρισκόταν πριν μετακινηθεί ο βασιλιάς για τους
        //                // σκοπούς του ελέγχου.

        //                WMSkakiera[(StartingWhiteKingColumn - 1), (StartingWhiteKingRank - 1)] = MovingPieceCWM;
        //                WMSkakiera[(StartingWhiteKingColumn - 1 - 1), (StartingWhiteKingRank - 1 + 1)] = ProsorinoKommatiCWM;

        //            }

        //        }

        //        if (DangerForMate == true)
        //            Mate = true;

        //    }

        //    return Mate;
        //}

        // v0.990 changes
        public static void CheckMove(string[,] CMSkakiera, int m_StartingRankCM, int m_StartingColumnNumberCM, int m_FinishingRankCM, int m_FinishingColumnNumberCM, String MovingPieceCM)
        {
            for (int iii = 0; iii <= 7; iii++)
            {
                for (int jjj = 0; jjj <= 7; jjj++)
                {
                    Skakiera_CM_Check[iii, jjj] = CMSkakiera[(iii), (jjj)];
                }
            }

            //number_of_moves_analysed++;

            m_WhoPlays = "Human";
            m_WrongColumn = false;

            // Check correctness of move
            m_OrthotitaKinisis = ElegxosOrthotitas(CMSkakiera, 0, m_StartingRankCM, m_StartingColumnNumberCM, m_FinishingRankCM, m_FinishingColumnNumberCM, MovingPieceCM);
            // if move is correct, then check the legality also
            if (m_OrthotitaKinisis == true)
                m_NomimotitaKinisis = ElegxosNomimotitas(CMSkakiera, 0, m_StartingRankCM, m_StartingColumnNumberCM, m_FinishingRankCM, m_FinishingColumnNumberCM, MovingPieceCM);

            // Restore the normal value of the m_WhoPlays
            m_WhoPlays = "HY";
        }

        public static void ComputerMove(string[,] Skakiera_Thinking_init)
        {
            #region Initialize
            int iii = 0;
            int jjj = 0;
            Temp_Score_Move_0 = 0;
            Temp_Score_Move_1_human = 0;
            Temp_Score_Move_2 = 0;
            Human_last_move_target_column = 0;
            Human_last_move_target_row = 0;
            MovingPiece = "";
            ProsorinoKommati = "";
            exit_elegxos_nomimothtas = false;
            First_Call = true;
            h = 0;
            p = 0;
            WhiteKingColumn = 0;
            WhiteKingRank = 0;
            BlKingColumn = 0;
            BlKingRank = 0;
            DangerFromUp = false;
            m_OrthotitaKinisis = false;
            m_NomimotitaKinisis = false;
            i = 0;
            j = 0;
            Current_Move_Score = 0;
            Best_Move_FinishingColumnNumber = 0;
            Best_Move_FinishingRank = 0;
            Best_Move_StartingColumnNumber = 0;
            Best_Move_StartingRank = 0;
            Stop_Analyzing = true;
            m_StartingColumnNumber_HY = 0;
            m_StartingRank_HY = 0;
            m_FinishingColumnNumber_HY = 0;
            m_FinishingRank_HY = 0;
            enpassant_possible_target_column = 0;
            // If there is a possibility to eat back what was eaten, then go for it!
            possibility_to_eat_back = false;
            possibility_to_eat = false;
            Mate_Found = false;
            Pat_Found = false;
            m_StartingColumnNumber_mate = 0;
            m_FinishingColumnNumber_mate = 0;
            m_StartingRank_mate = 0;
            m_FinishingRank_mate = 0;

            #region InitializeNodes
            // START [MiniMax algorithm - skakos]
            NodeLevel_0_count = 0;
            NodeLevel_1_count = 0;
            NodeLevel_2_count = 0;
            //v0.980: Removed unwanted nodes (+total nodes) v.0.992: Re-entered nodes 3 and 4 initialization
            NodeLevel_3_count = 0;
            NodeLevel_4_count = 0;
            Nodes_Total_count = 0;

            //v0.990 Added initialization of variables
            ValueOfHumanMovingPiece = 0;
            ValueOfMovingPiece = 0;

            for (int dimension1 = 0; dimension1 < 1000000; dimension1++)
            {
                for (int dimension2 = 0; dimension2 < 6; dimension2++)
                {
                    NodesAnalysis0[dimension1, dimension2] = 0;
                }
            }

            for (int dimension1 = 0; dimension1 < 1000000; dimension1++)
            {
                for (int dimension2 = 0; dimension2 < 2; dimension2++)
                {
                    NodesAnalysis1[dimension1, dimension2] = 0;
                    NodesAnalysis2[dimension1, dimension2] = 0;
                }
            }

            // v0.992
            for (int dimension1 = 0; dimension1 < 10000000; dimension1++)
            {
                for (int dimension2 = 0; dimension2 < 2; dimension2++)
                {
                    NodesAnalysis3[dimension1, dimension2] = 0;
                }
            }

            // v0.992
            for (int dimension1 = 0; dimension1 < 10000000; dimension1++)
            {
                for (int dimension2 = 0; dimension2 < 2; dimension2++)
                {
                    NodesAnalysis4[dimension1, dimension2] = 0;
                }
            }
            #endregion InitializeNodes
            #endregion Initialize

            // v0.992: Is this needed at all? Yes it is. At least I need to think about it. Skakiera_Thinking is used everywhere.
            #region StoreInitialPosition
            // Store the initial position in the chessboard
            for (iii = 0; iii <= 7; iii++)
            {
                for (jjj = 0; jjj <= 7; jjj++)
                {
                    Skakiera_Thinking[iii, jjj] = Skakiera_Thinking_init[(iii), (jjj)];
                    Skakiera_Move_0[(iii), (jjj)] = Skakiera_Thinking_init[(iii), (jjj)];
                }
            }
            #endregion StoreInitialPosition

            // v0.991: Add (again) opening book capability
            //Mini edition: Removed opening functionality
            #region OpeningBook
            //////////////////////////////////////////////////////////////////////////
            //// CHECK IF POSITION IS IN THE OPENING BOOK
            //////////////////////////////////////////////////////////////////////////

            //int op_iii;
            //int op_jjj;
            //bool foundOpening;

            //int opening = 1;
            //foundOpening = false;

            //bool exit_opening_loop = false;
            //// Μεταβλητή που καταδεικνύει το αν υπάρχει ταίριασμα της παρούσας θέσης με κάποια από τις θέσεις που υπάρχουν αποθηκευμένες στο βιβλίο ανοιγμάτων του ΗΥ
            //bool match_found;

            //String line_in_opening_book;

            //do
            //{
            //    if (File.Exists(String.Concat("Huo Chess Opening Book\\", opening.ToString(), ".txt")))
            //    {
            //        // Άνοιγμα των αρχείων .txt που περιέχει η βάση δεδομένων του ΗΥ
            //        StreamReader sr = new StreamReader(String.Concat("Huo Chess Opening Book\\", opening.ToString(), ".txt"));
            //        match_found = true;

            //        for (op_iii = 0; op_iii <= 7; op_iii++)
            //        {
            //            for (op_jjj = 0; op_jjj <= 7; op_jjj++)
            //            {
            //                line_in_opening_book = sr.ReadLine();

            //                //MessageBox.Show(String.Concat("i = ", op_iii.ToString(), ", j = ", op_jjj.ToString(), "\nOpening file: ", line_in_opening_book, ", Skakiera:", Skakiera_Thinking[op_iii, op_jjj].ToString()));

            //                if (Skakiera_Thinking[op_iii, op_jjj].CompareTo(line_in_opening_book) != 0)
            //                {
            //                    match_found = false;
            //                }
            //            }
            //        }

            //        // Αν βρέθηκε μια θέση που είναι αποθηκευμένη στο βιβλίο ανοιγμάτων,
            //        // τότε διάβασε και τις επόμενες σειρές στο αρχείο text οι οποίες περιέχουν
            //        // την κίνηση που πρέπει να κάνει ο ΗΥ στην παρούσα θέση.

            //        if (match_found == true)
            //        {
            //            // Αφού βρέθηκε θέση, τότε δεν χρειάζεται περαιτέρω ανάλυση.
            //            exit_opening_loop = true;

            //            // Αφού βρέθηκε θέση, τότε ο ΗΥ δεν χρειάζεται να σκεφτεί για την κίνηση του, την έχει βρει έτοιμη!
            //            Stop_Analyzing = true;

            //            // Διάβασμα της κενής γραμμής που υπάρχει στο αρχείο.
            //            line_in_opening_book = sr.ReadLine();

            //            line_in_opening_book = sr.ReadLine();
            //            Best_Move_StartingColumnNumber = Int32.Parse(line_in_opening_book);
            //            line_in_opening_book = sr.ReadLine();
            //            Best_Move_StartingRank = Int32.Parse(line_in_opening_book);

            //            line_in_opening_book = sr.ReadLine();
            //            Best_Move_FinishingColumnNumber = Int32.Parse(line_in_opening_book);
            //            line_in_opening_book = sr.ReadLine();
            //            Best_Move_FinishingRank = Int32.Parse(line_in_opening_book);

            //            foundOpening = true;
            //            //MessageBox.Show("Found position in opening book!");
            //        }
            //    }
            //    else
            //    {
            //        exit_opening_loop = true;
            //    }

            //    opening = opening + 1;
            //} while (exit_opening_loop == false);

            ////////////////////////////////////////
            //// END OF OPENING BOOK CHECK
            ////////////////////////////////////////
            #endregion OpeningBook

            // CHECK FOR DANGEROUS SQUARES
            // Also find number and value of attackers and defenders for each square of the chessboard: will be used below to determine if the move is stupid
            // Mini version: Removed
            #region DangerousSquares
            //Danger_for_piece = false;

            //for (int o1 = 0; o1 <= 7; o1++)
            //{
            //    for (int p1 = 0; p1 <= 7; p1++)
            //    {
            //        //v0.980: Change small Strings to Int
            //        Skakiera_Dangerous_Squares[(o1), (p1)] = 0;
            //        //v0.990 test. Added initialization. By adding it it makes the computer not wanting to eat the bishop.
            //        Value_of_defenders[(o1), (p1)] = 0;
            //        Value_of_attackers[(o1), (p1)] = 0;
            //        //v0.990: Added also these initializations! Let's see what happens now...
            //        //        I had forgot those! Could this be the reason the HY did not
            //        //        want to eat the bishop?
            //        Number_of_defenders[(o1), (p1)] = 0;
            //        Number_of_attackers[(o1), (p1)] = 0;
            //    }
            //}

            //// Find attackers-defenders
            //FindAttackers(Skakiera_Thinking);
            //FindDefenders(Skakiera_Thinking);

            //// Determine dangerous squares
            //for (int o1 = 0; o1 <= 7; o1++)
            //{
            //    for (int p1 = 0; p1 <= 7; p1++)
            //    {
            //        //v0.990 debug
            //        //MessageBox.Show(String.Concat("Number of attackers for ", (o1 + 1).ToString(), (p1 + 1).ToString(), " : ", Number_of_attackers[o1, p1].ToString()));
            //        //MessageBox.Show(String.Concat("Number of defenders for ", (o1 + 1).ToString(), (p1 + 1).ToString(), " : ", Number_of_defenders[o1, p1].ToString()));
            //        //MessageBox.Show(String.Concat("Value_of_defenders for ", (o1 + 1).ToString(), (p1 + 1).ToString(), " : ", Value_of_defenders[o1, p1].ToString()));
            //        //MessageBox.Show(String.Concat("Value_of_attackers for ", (o1 + 1).ToString(), (p1 + 1).ToString(), " : ", Value_of_attackers[o1, p1].ToString()));

            //        // v0.990 change: Should ">" change to ">=" ??? No!
            //        // The case where the only defender is the moving piece can only be captured 
            //        // in the CheckMove function!
            //        // Potential improvement: Should we have a range of 'dangerousness' values, instead of just 0 and 1?
            //        if (Number_of_attackers[o1, p1] > Number_of_defenders[o1, p1])
            //            //v0.980: Change small Strings to Int
            //            Skakiera_Dangerous_Squares[(o1), (p1)] = 1;
            //    }
            //}

            #region WriteLog
            //if (activateLogs == true)
            //{
            //    //v0.990
            //    for (i = 0; i <= 7; i++)
            //    {
            //        for (j = 0; j <= 7; j++)
            //        {
            //            switch (Skakiera_Thinking_init[(i), (j)])
            //            {
            //                case "White Rook":
            //                    SkakieraLog[i, j] = "WR";
            //                    break;

            //                case "White Knight":
            //                    SkakieraLog[i, j] = "WN";
            //                    break;

            //                case "White Bishop":
            //                    SkakieraLog[i, j] = "WB";
            //                    break;

            //                case "White Queen":
            //                    SkakieraLog[i, j] = "WQ";
            //                    break;

            //                case "White King":
            //                    SkakieraLog[i, j] = "WK";
            //                    break;

            //                case "White Pawn":
            //                    SkakieraLog[i, j] = "WP";
            //                    break;

            //                case "Black Rook":
            //                    SkakieraLog[i, j] = "BR";
            //                    break;

            //                case "Black Knight":
            //                    SkakieraLog[i, j] = "BN";
            //                    break;

            //                case "Black Bishop":
            //                    SkakieraLog[i, j] = "BB";
            //                    break;

            //                case "Black Queen":
            //                    SkakieraLog[i, j] = "BQ";
            //                    break;

            //                case "Black King":
            //                    SkakieraLog[i, j] = "BK";
            //                    break;

            //                case "Black Pawn":
            //                    SkakieraLog[i, j] = "BP";
            //                    break;

            //                case "":
            //                    SkakieraLog[i, j] = "  ";
            //                    break;
            //            }
            //        }
            //    }

            //    huo_sw_attackers.WriteLine("CHESSBOARD");
            //    huo_sw_attackers.WriteLine("-----------------------------------------");
            //    for (int yj = 7; yj >= 0; yj--)
            //    {
            //        huo_sw_attackers.WriteLine(String.Concat("| ", SkakieraLog[0, yj], " | ", SkakieraLog[1, yj], " | ", SkakieraLog[2, yj], " | ", SkakieraLog[3, yj], " | ", SkakieraLog[4, yj], " | ", SkakieraLog[5, yj], " | ", SkakieraLog[6, yj], " | ", SkakieraLog[7, yj], " |"));
            //        huo_sw_attackers.WriteLine("-----------------------------------------");
            //    }

            //    huo_sw_attackers.WriteLine("");
            //    huo_sw_attackers.WriteLine("");

            //    huo_sw_attackers.WriteLine("CHESSBOARD: Number of attackers");
            //    huo_sw_attackers.WriteLine(String.Concat("Move = ", Move.ToString()));
            //    huo_sw_attackers.WriteLine("-----------------------------------------");
            //    for (int yj = 7; yj >= 0; yj--)
            //    {
            //        huo_sw_attackers.WriteLine(String.Concat("| ", Number_of_attackers[0, yj], " | ", Number_of_attackers[1, yj], " | ", Number_of_attackers[2, yj], " | ", Number_of_attackers[3, yj], " | ", Number_of_attackers[4, yj], " | ", Number_of_attackers[5, yj], " | ", Number_of_attackers[6, yj], " | ", Number_of_attackers[7, yj], " |"));
            //        huo_sw_attackers.WriteLine("-----------------------------------------");
            //    }

            //    huo_sw_attackers.WriteLine("");
            //    huo_sw_attackers.WriteLine("");

            //    huo_sw_attackers.WriteLine("CHESSBOARD: Value of attackers");
            //    huo_sw_attackers.WriteLine("-----------------------------------------");
            //    for (int yj = 7; yj >= 0; yj--)
            //    {
            //        huo_sw_attackers.WriteLine(String.Concat("| ", Value_of_attackers[0, yj], " | ", Value_of_attackers[1, yj], " | ", Value_of_attackers[2, yj], " | ", Value_of_attackers[3, yj], " | ", Value_of_attackers[4, yj], " | ", Value_of_attackers[5, yj], " | ", Value_of_attackers[6, yj], " | ", Value_of_attackers[7, yj], " |"));
            //        huo_sw_attackers.WriteLine("-----------------------------------------");
            //    }

            //    huo_sw_attackers.WriteLine("");
            //    huo_sw_attackers.WriteLine("");

            //    huo_sw_attackers.WriteLine("CHESSBOARD: Number of defenders");
            //    huo_sw_attackers.WriteLine(String.Concat("Move = ", Move.ToString()));
            //    huo_sw_attackers.WriteLine("-----------------------------------------");
            //    for (int yj = 7; yj >= 0; yj--)
            //    {
            //        huo_sw_attackers.WriteLine(String.Concat("| ", Number_of_defenders[0, yj], " | ", Number_of_defenders[1, yj], " | ", Number_of_defenders[2, yj], " | ", Number_of_defenders[3, yj], " | ", Number_of_defenders[4, yj], " | ", Number_of_defenders[5, yj], " | ", Number_of_defenders[6, yj], " | ", Number_of_defenders[7, yj], " |"));
            //        huo_sw_attackers.WriteLine("-----------------------------------------");
            //    }

            //    huo_sw_attackers.WriteLine("");
            //    huo_sw_attackers.WriteLine("");

            //    huo_sw_attackers.WriteLine("CHESSBOARD: Value of defenders");
            //    huo_sw_attackers.WriteLine("-----------------------------------------");
            //    for (int yj = 7; yj >= 0; yj--)
            //    {
            //        huo_sw_attackers.WriteLine(String.Concat("| ", Value_of_defenders[0, yj], " | ", Value_of_defenders[1, yj], " | ", Value_of_defenders[2, yj], " | ", Value_of_defenders[3, yj], " | ", Value_of_defenders[4, yj], " | ", Value_of_defenders[5, yj], " | ", Value_of_defenders[6, yj], " | ", Value_of_defenders[7, yj], " |"));
            //        huo_sw_attackers.WriteLine("-----------------------------------------");
            //    }

            //    huo_sw_attackers.WriteLine("");
            //    huo_sw_attackers.WriteLine("");

            //    huo_sw_attackers.WriteLine("CHESSBOARD: Dangerous squares");
            //    huo_sw_attackers.WriteLine("-----------------------------------------");
            //    for (int yj = 7; yj >= 0; yj--)
            //    {
            //        huo_sw_attackers.WriteLine(String.Concat("| ", Skakiera_Dangerous_Squares[0, yj], " | ", Skakiera_Dangerous_Squares[1, yj], " | ", Skakiera_Dangerous_Squares[2, yj], " | ", Skakiera_Dangerous_Squares[3, yj], " | ", Skakiera_Dangerous_Squares[4, yj], " | ", Skakiera_Dangerous_Squares[5, yj], " | ", Skakiera_Dangerous_Squares[6, yj], " | ", Skakiera_Dangerous_Squares[7, yj], " |"));
            //        huo_sw_attackers.WriteLine("-----------------------------------------");
            //    }
            //}
            #endregion WriteLog

            #endregion DangerousSquares

            #region checkForCheck
            // v0.990
            // Check if HY is currently under check
            ThereIsCheck = false;

            if (m_PlayerColor.CompareTo("White") == 0)
                ThereIsCheck = CheckForBlackCheck(Skakiera_Thinking);
            else if (m_PlayerColor.CompareTo("Black") == 0)
                ThereIsCheck = CheckForBlackCheck(Skakiera_Thinking);
            #endregion checkForCheck

            //---------------------------------------
            // CHECK ALL POSSIBLE MOVES!
            //---------------------------------------
            // v0.991: Added opening book capability
            //if (foundOpening == false)
            //{
            #region checkAllMoves
            for (iii = 0; iii <= 7; iii++)
            {
                for (jjj = 0; jjj <= 7; jjj++)
                {
                    //v0.980: Reduce all texts ("White King" for "Wh King", "White Knight" for "Wh Knight" and so on...)
                    if (((Who_Is_Analyzed.CompareTo("HY") == 0) && ((((Skakiera_Thinking[(iii), (jjj)].CompareTo("White King") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Queen") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Rook") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Knight") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Bishop") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)) || (((Skakiera_Thinking[(iii), (jjj)].CompareTo("Black King") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Queen") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Rook") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Knight") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Bishop") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)))) || ((Who_Is_Analyzed.CompareTo("Hu") == 0) && ((((Skakiera_Thinking[(iii), (jjj)].CompareTo("White King") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Queen") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Rook") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Knight") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Bishop") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)) || (((Skakiera_Thinking[(iii), (jjj)].CompareTo("Black King") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Queen") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Rook") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Knight") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Bishop") == 0) || (Skakiera_Thinking[(iii), (jjj)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)))))
                    {

                        for (int w = 0; w <= 7; w++)
                        {
                            for (int r = 0; r <= 7; r++)
                            {
                                // v0.992 - Initialization (if we don't, the target piece value from the previous run
                                // will be still in the variables if in the next pass there is no target piece at the
                                // target square, thus leading to problems - activate the logs to see the difference
                                // if the initialization does not happen)
                                ProsorinoKommati = "";
                                ValueOfMovingPiece = 0;
                                ValueOfTargetPiece = 0;

                                MovingPiece = Skakiera_Thinking[(iii), (jjj)];
                                m_StartingColumnNumber = iii + 1;
                                m_FinishingColumnNumber = w + 1;
                                m_StartingRank = jjj + 1;
                                m_FinishingRank = r + 1;
                                ProsorinoKommati = Skakiera_Thinking[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)];

                                //Mini version: Removed
                                //ThisIsStupidMove = "N";
                                #region CheckStupidMove
                                //v0.990: MovingPiece -> MovingPiece (AND all other related variables)
                                //v0.990 test: Remove for now the stupid move checks... (for testing)
                                //if (Move < 0)
                                // v0.992: Some of these checks are already in the CountScore, so I will remove them from here!
                                //if (Move < 5)
                                //{
                                //    //if ((MovingPiece.CompareTo("White Queen") == 0) || (MovingPiece.CompareTo("Black Queen") == 0) ||
                                //    //        (MovingPiece.CompareTo("White Rook") == 0) || (MovingPiece.CompareTo("Black Rook") == 0))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //    //else if (((MovingPiece.CompareTo("White Knight") == 0) || (MovingPiece.CompareTo("Black Knight") == 0))
                                //    //        && (m_FinishingColumnNumber == 1))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //    //else if (((MovingPiece.CompareTo("White Knight") == 0) || (MovingPiece.CompareTo("Black Knight") == 0))
                                //    //        && (m_FinishingColumnNumber == 8))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //    //else if ((MovingPiece.CompareTo("White Knight") == 0) && (m_FinishingRank == 2) && (m_FinishingColumnNumber == 4)
                                //    //        && (Skakiera_Thinking[(2), (0)].CompareTo("White Bishop") == 0))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //    //else if ((MovingPiece.CompareTo("White Knight") == 0) && (m_FinishingRank == 2) && (m_FinishingColumnNumber == 5)
                                //    //        && (Skakiera_Thinking[(5), (0)].CompareTo("White Bishop") == 0))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //    //else if ((MovingPiece.CompareTo("Black Knight") == 0) && (m_FinishingRank == 7) && (m_FinishingColumnNumber == 4)
                                //    //        && (Skakiera_Thinking[(2), (7)].CompareTo("Black Bishop") == 0))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //    //else if ((MovingPiece.CompareTo("Black Knight") == 0) && (m_FinishingRank == 7) && (m_FinishingColumnNumber == 5)
                                //    //        && (Skakiera_Thinking[(5), (7)].CompareTo("Black Bishop") == 0))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //    if ((MovingPiece.CompareTo("White Pawn") == 0) && ((m_StartingColumnNumber == 1) || (m_StartingColumnNumber == 2)))
                                //    {
                                //        ThisIsStupidMove = "Y";
                                //    }
                                //    else if ((MovingPiece.CompareTo("White Pawn") == 0) && ((m_StartingColumnNumber == 7) || (m_StartingColumnNumber == 8)))
                                //    {
                                //        ThisIsStupidMove = "Y";
                                //    }
                                //    else if ((MovingPiece.CompareTo("Black Pawn") == 0) && ((m_StartingColumnNumber == 1) || (m_StartingColumnNumber == 2)))
                                //    {
                                //        ThisIsStupidMove = "Y";
                                //    }
                                //    else if ((MovingPiece.CompareTo("Black Pawn") == 0) && ((m_StartingColumnNumber == 7) || (m_StartingColumnNumber == 8)))
                                //    {
                                //        ThisIsStupidMove = "Y";
                                //    }
                                //    // Do not move the 'f' pawns!
                                //    else if ((MovingPiece.CompareTo("White Pawn") == 0) && ((m_StartingColumnNumber == 6) && (m_StartingRank == 2)))
                                //    {
                                //        ThisIsStupidMove = "Y";
                                //    }
                                //    else if ((MovingPiece.CompareTo("Black Pawn") == 0) && ((m_StartingColumnNumber == 6) && (m_StartingRank == 7)))
                                //    {
                                //        ThisIsStupidMove = "Y";
                                //    }
                                //    else if ((MovingPiece.CompareTo("White King") == 0) || (MovingPiece.CompareTo("Black King") == 0))
                                //    {
                                //        ThisIsStupidMove = "Y";
                                //    }
                                //    //else if (((MovingPiece.CompareTo("White Bishop") == 0) || (MovingPiece.CompareTo("Black Bishop") == 0))
                                //    //    && ((m_FinishingRank == 3) || (m_FinishingRank == 5) || (m_FinishingRank == 6)))
                                //    //{
                                //    //    ThisIsStupidMove = "Y";
                                //    //}
                                //}

                                // v0.970
                                // v0.990: Find value of moving piece and of the target piece eaten
                                #region findValueOfPieces

                                // Store the value of the moving piece
                                if ((MovingPiece.CompareTo("White Rook") == 0) || (MovingPiece.CompareTo("Black Rook") == 0))
                                    ValueOfMovingPiece = 5;
                                if ((MovingPiece.CompareTo("White Knight") == 0) || (MovingPiece.CompareTo("Black Knight") == 0))
                                    ValueOfMovingPiece = 3;
                                if ((MovingPiece.CompareTo("White Bishop") == 0) || (MovingPiece.CompareTo("Black Bishop") == 0))
                                    ValueOfMovingPiece = 3;
                                if ((MovingPiece.CompareTo("White Queen") == 0) || (MovingPiece.CompareTo("Black Queen") == 0))
                                    ValueOfMovingPiece = 9;
                                if ((MovingPiece.CompareTo("White King") == 0) || (MovingPiece.CompareTo("Black King") == 0))
                                    ValueOfMovingPiece = 119;
                                if ((MovingPiece.CompareTo("White Pawn") == 0) || (MovingPiece.CompareTo("Black Pawn") == 0))
                                    ValueOfMovingPiece = 1;

                                // v0.992: Improvement: We have the value of the moving piece in ValueOfMovingPiece! (see above) Perhaps I should consolidate the code.
                                // We now find the value of the pieces only in the Check Stupid Move section and not in two places.
                                //if ((MovingPiece.CompareTo("White Rook") == 0) || (MovingPiece.CompareTo("Black Rook") == 0))
                                //    ValueOfKommati = 5;
                                //if ((MovingPiece.CompareTo("White Knight") == 0) || (MovingPiece.CompareTo("Black Knight") == 0))
                                //    ValueOfKommati = 3;
                                //if ((MovingPiece.CompareTo("White Bishop") == 0) || (MovingPiece.CompareTo("Black Bishop") == 0))
                                //    ValueOfKommati = 3;
                                //if ((MovingPiece.CompareTo("White Queen") == 0) || (MovingPiece.CompareTo("Black Queen") == 0))
                                //    ValueOfKommati = 9;
                                //if ((MovingPiece.CompareTo("White King") == 0) || (MovingPiece.CompareTo("Black King") == 0))
                                //    ValueOfKommati = 119;
                                //if ((MovingPiece.CompareTo("White Pawn") == 0) || (MovingPiece.CompareTo("Black Pawn") == 0))
                                //    ValueOfKommati = 1;

                                //v0.992: Gathered all pieces valuations in one place

                                if ((ProsorinoKommati.CompareTo("White Rook") == 0) || (ProsorinoKommati.CompareTo("Black Rook") == 0))
                                    ValueOfTargetPiece = 5;
                                if ((ProsorinoKommati.CompareTo("White Knight") == 0) || (ProsorinoKommati.CompareTo("Black Knight") == 0))
                                    ValueOfTargetPiece = 3;
                                if ((ProsorinoKommati.CompareTo("White Bishop") == 0) || (ProsorinoKommati.CompareTo("Black Bishop") == 0))
                                    ValueOfTargetPiece = 3;
                                if ((ProsorinoKommati.CompareTo("White Queen") == 0) || (ProsorinoKommati.CompareTo("Black Queen") == 0))
                                    ValueOfTargetPiece = 9;
                                if ((ProsorinoKommati.CompareTo("White King") == 0) || (ProsorinoKommati.CompareTo("Black King") == 0))
                                    ValueOfTargetPiece = 119;
                                if ((ProsorinoKommati.CompareTo("White Pawn") == 0) || (ProsorinoKommati.CompareTo("Black Pawn") == 0))
                                    ValueOfTargetPiece = 1;

                                //v0.992 Debug
                                //if (activateLogs == true)
                                //{
                                //    huo_ProsorinoKommati.WriteLine(String.Concat(MovingPiece, " ", m_StartingColumnNumber.ToString(), m_StartingRank.ToString(), " -> ", m_FinishingColumnNumber.ToString(), m_FinishingRank.ToString(), " - ", ProsorinoKommati, " - ", ValueOfTargetPiece.ToString()));
                                //}

                                #endregion findValueOfPieces

                                #region ObsoleteCode
                                //v0.990 debug
                                //if ((m_StartingColumnNumber == 3)  &&
                                //    (m_StartingRank == 1)          &&
                                //    (m_FinishingColumnNumber == 6) &&
                                //    (m_FinishingRank == 4))
                                //{
                                //    MessageBox.Show(String.Concat("Moving ", MovingPiece, ": ", m_StartingColumnNumber.ToString(), m_StartingRank.ToString(), " -> ", m_FinishingColumnNumber.ToString(), m_FinishingRank.ToString()));
                                //    MessageBox.Show(Skakiera_Dangerous_Squares[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)].ToString());
                                //}
                                //v0.990 debug
                                //if ((m_StartingColumnNumber == 3) &&
                                //    (m_StartingRank == 1) &&
                                //    (m_FinishingColumnNumber == 6) &&
                                //    (m_FinishingRank == 4))
                                //{
                                //    MessageBox.Show(String.Concat("Moving ", MovingPiece, ": ", m_StartingColumnNumber.ToString(), m_StartingRank.ToString(), " -> ", m_FinishingColumnNumber.ToString(), m_FinishingRank.ToString()));
                                //    MessageBox.Show(Skakiera_Dangerous_Squares[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)].ToString());
                                //}
                                #endregion ObsoleteCode

                                // v0.990: Here we use the w and r variables, while the move is defined by the m_FinishingColumnNumber, m_FinishingRank variables!
                                // The change was not needed! w = m_FinishingColumnNumber - 1 anyway!
                                // (and in the same way r is also correct!)
                                // Left the change for clarity purposes!
                                // If a pieve of lower value attacks the square where the computer moves, then... stupid move!
                                // if ((Number_of_attackers[w, r] == 1) && (Value_of_attackers[w, r] < ValueOfMovingPiece))
                                // No need to have the "Number of attackers = 1" condition, changed it to >=
                                // v0.990: m_FinishingColumnNumber -> m_FinishingColumnNumber - 1
                                // Potential improvement: Are the below conditions correct? Should we take the sum of the value of all attackers or just the lower one?
                                //if ((Number_of_attackers[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)] >= 1) && (Value_of_attackers[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)] < ValueOfMovingPiece))
                                //{
                                //    ThisIsStupidMove = "Y";
                                //}
                                #endregion CheckStupidMove

                                // v0.992: Add move_dangerousness flag (finally not needed? Depends on how the trimming rules analysis will go)
                                // Mini version: Removed
                                #region dangerousnessFlag
                                //move_dangerousness = false;

                                // Potential improvement: Should we have a range of 'dangerousness' values, instead of just 0 and 1?
                                // Mini version: Removed
                                //if ((Skakiera_Dangerous_Squares[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)] != 0))
                                //{
                                //    move_dangerousness = true;
                                //}
                                #endregion dangerousnessFlag

                                // Mini version: Removed
                                //if (1 == 1)
                                //{
                                // THE HEART OF THE THINKING MECHANISM: Here the computer checks the moves

                                // Validity and legality of the move will be checked in CheckMove (plus some additional checks for possible mate etc)
                                CheckMove(Skakiera_Thinking, m_StartingRank, m_StartingColumnNumber, m_FinishingRank, m_FinishingColumnNumber, MovingPiece);

                                if (((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true)) && (Move_Analyzed == 0))
                                {
                                    // Store the move to ***_HY variables (because after continuous calls of ComputerMove the initial move under analysis will be lost...)
                                    MovingPiece_HY = MovingPiece;
                                    m_StartingColumnNumber_HY = m_StartingColumnNumber;
                                    m_FinishingColumnNumber_HY = m_FinishingColumnNumber;
                                    m_StartingRank_HY = m_StartingRank;
                                    m_FinishingRank_HY = m_FinishingRank;

                                    // Store the initial move coordinates (at the node 0 level)
                                    NodesAnalysis0[NodeLevel_0_count, 2] = m_StartingColumnNumber_HY;
                                    NodesAnalysis0[NodeLevel_0_count, 3] = m_FinishingColumnNumber_HY;
                                    NodesAnalysis0[NodeLevel_0_count, 4] = m_StartingRank_HY;
                                    NodesAnalysis0[NodeLevel_0_count, 5] = m_FinishingRank_HY;

                                    // Now at least one legal move is found (used to determine if there is checkmate)
                                    Best_Move_Found = true;
                                }

                                // If everything is OK, then do the move and measure it's score
                                if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
                                {
                                    Skakiera_Thinking[(m_StartingColumnNumber - 1), (m_StartingRank - 1)] = "";
                                    Skakiera_Thinking[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)] = MovingPiece;

                                    // Count the score of the move
                                    Temp_Score_Move_0 = CountScore(Skakiera_Thinking);

                                    // Store scores
                                    NodesAnalysis0[NodeLevel_0_count, 0] = Temp_Score_Move_0;
                                    // Store parents
                                    // For initial level of thought, there is no parent (i.e. value = 0)
                                    NodesAnalysis0[NodeLevel_0_count, 1] = 0;

                                    // -------------------------------------------------------
                                    // Check if the computer can eat a piece of the opponent
                                    // -------------------------------------------------------
                                    // v0.992: Replaced ValueOfKommati with ValueOfMovingPiece
                                    #region Eat
                                    if (ValueOfMovingPiece < ValueOfTargetPiece)
                                    {
                                        //v0.992: Storing the values is probably not needed, since I just use the possibility_to_eat_back flag
                                        Best_Move_StartingColumnNumber = m_StartingColumnNumber;
                                        Best_Move_StartingRank = m_StartingRank;
                                        Best_Move_FinishingColumnNumber = m_FinishingColumnNumber;
                                        Best_Move_FinishingRank = m_FinishingRank;

                                        //v0.992: Do I initialize that?
                                        possibility_to_eat = true;
                                    }
                                    #endregion Eat

                                    // ------------------------------------------------------------
                                    // Check if the computer can eat back a piece of the opponent
                                    // ------------------------------------------------------------
                                    #region EatBack
                                    // v0.970: Check if you can eat back the piece of the Hu which moved!
                                    if ((m_FinishingColumnNumber == Human_last_move_target_column)
                                         && (m_FinishingRank == Human_last_move_target_row)
                                         && (ValueOfMovingPiece <= ValueOfHumanMovingPiece))
                                    {
                                        Best_Move_StartingColumnNumber = m_StartingColumnNumber;
                                        Best_Move_StartingRank = m_StartingRank;
                                        Best_Move_FinishingColumnNumber = m_FinishingColumnNumber;
                                        Best_Move_FinishingRank = m_FinishingRank;

                                        //v0.992: Do I initialize that?
                                        possibility_to_eat_back = true;
                                    }
                                    #endregion EatBack

                                    // If thinking depth not reached and there is not an easy option to eat back...
                                    // Mini version: Removed the (Move_Analyzed < Thinking_Depth) condition
                                    if (possibility_to_eat_back == false)
                                    {
                                        // From Move 0 (the initial) we now go to Move 1 (the first response of human opponent - see Analyze_Move_1_HumanMove)
                                        Move_Analyzed = Move_Analyzed + 1;

                                        //v0.990: Added a new separate chessboard to use when passing over to a new function.
                                        String[,] Skakiera_Move_After_0_new = new String[8, 8];

                                        for (i = 0; i <= 7; i++)
                                        {
                                            for (j = 0; j <= 7; j++)
                                            {
                                                Skakiera_Move_After_0_new[(i), (j)] = Skakiera_Thinking[(i), (j)];
                                            }
                                        }

                                        //v0.980: Removed
                                        Who_Is_Analyzed = "Human";

                                        // v0.992: Switch which colour plays.
                                        // This is used for the check for check in ElegxosNomimotitas
                                        if (m_PlayerColor.CompareTo("Black") == 0)
                                            m_WhichColorPlays = "Black";
                                        else if (m_PlayerColor.CompareTo("White") == 0)
                                            m_WhichColorPlays = "White";

                                        Analyze_Move_1_HumanMove(Skakiera_Move_After_0_new);

                                        // v0.992: Switch BACK which colour plays.
                                        // This is used for the check for check in ElegxosNomimotitas
                                        if (m_PlayerColor.CompareTo("Black") == 0)
                                            m_WhichColorPlays = "White";
                                        else if (m_PlayerColor.CompareTo("White") == 0)
                                            m_WhichColorPlays = "Black";
                                    }

                                    // Undo the move
                                    Skakiera_Thinking[(m_StartingColumnNumber - 1), (m_StartingRank - 1)] = MovingPiece;
                                    Skakiera_Thinking[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)] = ProsorinoKommati;

                                    //v0.992
                                    // If Pat (= Stalemate) found then reset the score!
                                    if (Pat_Found == true)
                                    {
                                        NodesAnalysis0[NodeLevel_0_count, 0] = 0;
                                        Pat_Found = false;
                                    }

                                    NodeLevel_0_count++;
                                }

                            }
                        }

                    }


                }
            }
            #endregion checkAllMoves
            //}

            // Find if there is mate
            // v0.980: Simplified!
            // Mini version: Removed. It does not work anyway (the ThereIsCheck is null here? TBV)
            #region CheckIfMate
            //if ((ThereIsCheck == true) && (Best_Move_Found == false))
            //{
            //    //v0.990
            //    //MessageBox.Show("Checkmate!");
            //    Console.WriteLine("Checkmate!");
            //}
            #endregion CheckIfMate

            // -------------------------------------------------------------------------------
            // DO THE BEST MOVE FOUND
            // Analyze only if possibility to eat back is not true!!!
            // MessageBox.Show("Entered Best Move found area!");
            // v0.990: Added the possibility_to_eat
            // v0.991: Removed possibility to eat! Why not think everything?
            // v0.991: Added the opening book check
            // if ((possibility_to_eat_back == false) && (possibility_to_eat == false))
            // -------------------------------------------------------------------------------
            //if ((possibility_to_eat_back == false) && (foundOpening == false))
            if (possibility_to_eat_back == false)
            {
                // [MiniMax algorithm - skakos]
                int counter0, counter1, counter2, counter3, counter4;

                // -------------------------------------------------------------------
                // NodesAnalysis
                // -------------------------------------------------------------------
                // Nodes structure...
                // [ccc, xxx, 0]: Score of node No. ccc at level xxx
                // [ccc, xxx, 1]: Parent of node No. ccc at level xxx-1
                // -------------------------------------------------------------------
                // v0.991 Added the move 4 section - Needed if Thinking_Depth = 4.
                // -------------------------------------------------------------------
                // MiniMax algorithm example: https://www.geeksforgeeks.org/minimax-algorithm-in-game-theory-set-1-introduction/
                // -------------------------------------------------------------------

                // Move 4 level (Computer)

                int parentNodeAnalyzed = -999;

                // v0.991: Added this so as to make this activated only when Thinking_Depth = 4.
                if (Thinking_Depth == 4)
                {
                    // v0.991: Start from 0! Ends at "< NodeLevel_4_count" since the node count is increased before the next node is analyzed...
                    // (see Checkpoint increaseNodeCount for example)
                    for (counter4 = 0; counter4 < NodeLevel_4_count; counter4++)
                    {
                        if (Int32.Parse(NodesAnalysis4[counter4, 1].ToString()) != parentNodeAnalyzed)
                        {
                            // Update the parent node analyzed with the new one
                            parentNodeAnalyzed = Int32.Parse(NodesAnalysis4[counter4, 1].ToString());
                            // For the first parent node, store the score in the parent node. After that, compare to see if you need to replace!
                            NodesAnalysis3[Int32.Parse(NodesAnalysis4[counter4, 1].ToString()), 0] = NodesAnalysis4[counter4, 0];
                            bestNode4 = counter4;
                            bestNodes4[parentNodeAnalyzed] = counter4;
                        }

                        if (m_PlayerColor.CompareTo("White") == 0)
                        {
                            if (NodesAnalysis4[counter4, 0] <= NodesAnalysis3[Int32.Parse(NodesAnalysis4[counter4, 1].ToString()), 0])
                            {
                                NodesAnalysis3[Int32.Parse(NodesAnalysis4[counter4, 1].ToString()), 0] = NodesAnalysis4[counter4, 0];
                                bestNode4 = counter4;
                                bestNodes4[parentNodeAnalyzed] = counter4;
                            }
                        }
                        else if (m_PlayerColor.CompareTo("Black") == 0)
                        {
                            if (NodesAnalysis4[counter4, 0] >= NodesAnalysis3[Int32.Parse(NodesAnalysis4[counter4, 1].ToString()), 0])
                            {
                                NodesAnalysis3[Int32.Parse(NodesAnalysis4[counter4, 1].ToString()), 0] = NodesAnalysis4[counter4, 0];
                                bestNode4 = counter4;
                                bestNodes4[parentNodeAnalyzed] = counter4;
                            }
                        }
                    }

                    // Move 3 level (Human)

                    for (counter3 = 0; counter3 < NodeLevel_3_count; counter3++)
                    {
                        if (Int32.Parse(NodesAnalysis3[counter3, 1].ToString()) != parentNodeAnalyzed)
                        {
                            parentNodeAnalyzed = Int32.Parse(NodesAnalysis3[counter3, 1].ToString());
                            NodesAnalysis2[Int32.Parse(NodesAnalysis3[counter3, 1].ToString()), 0] = NodesAnalysis3[counter3, 0];
                            bestNode3 = counter3;
                            bestNodes3[parentNodeAnalyzed] = counter3;
                        }

                        if (m_PlayerColor.CompareTo("White") == 0)
                        {
                            if (NodesAnalysis3[counter3, 0] >= NodesAnalysis2[Int32.Parse(NodesAnalysis3[counter3, 1].ToString()), 0])
                            {
                                NodesAnalysis2[Int32.Parse(NodesAnalysis3[counter3, 1].ToString()), 0] = NodesAnalysis3[counter3, 0];
                                bestNode3 = counter3;
                                bestNodes3[parentNodeAnalyzed] = counter3;
                            }
                        }
                        else if (m_PlayerColor.CompareTo("Black") == 0)
                        {
                            if (NodesAnalysis3[counter3, 0] <= NodesAnalysis2[Int32.Parse(NodesAnalysis3[counter3, 1].ToString()), 0])
                            {
                                NodesAnalysis2[Int32.Parse(NodesAnalysis3[counter3, 1].ToString()), 0] = NodesAnalysis3[counter3, 0];
                                bestNode3 = counter3;
                                bestNodes3[parentNodeAnalyzed] = counter3;
                            }

                        }
                    }

                }

                // Move 2 level (Computer) -- The analysis starts from here if Thinking_Depth = 2.

                for (counter2 = 0; counter2 < NodeLevel_2_count; counter2++)
                {
                    if (Int32.Parse(NodesAnalysis2[counter2, 1].ToString()) != parentNodeAnalyzed)
                    {
                        parentNodeAnalyzed = Int32.Parse(NodesAnalysis2[counter2, 1].ToString());
                        NodesAnalysis1[Int32.Parse(NodesAnalysis2[counter2, 1].ToString()), 0] = NodesAnalysis2[counter2, 0];
                        bestNode2 = counter2;
                        bestNodes2[parentNodeAnalyzed] = counter2;
                    }

                    if (m_PlayerColor.CompareTo("White") == 0)
                    {
                        if ((NodesAnalysis2[counter2, 0] <= NodesAnalysis1[Int32.Parse(NodesAnalysis2[counter2, 1].ToString()), 0]))
                        {
                            NodesAnalysis1[Int32.Parse(NodesAnalysis2[counter2, 1].ToString()), 0] = NodesAnalysis2[counter2, 0];
                            bestNode2 = counter2;
                            bestNodes2[parentNodeAnalyzed] = counter2;
                        }
                    }
                    else if (m_PlayerColor.CompareTo("Black") == 0)
                    {
                        if (NodesAnalysis2[counter2, 0] >= NodesAnalysis1[Int32.Parse(NodesAnalysis2[counter2, 1].ToString()), 0])
                        {
                            NodesAnalysis1[Int32.Parse(NodesAnalysis2[counter2, 1].ToString()), 0] = NodesAnalysis2[counter2, 0];
                            bestNode2 = counter2;
                            bestNodes2[parentNodeAnalyzed] = counter2;
                        }
                    }
                }

                // Now the Node1 level is filled with the score data
                // this is line 1 in the shape at http://upload.wikimedia.org/wikipedia/commons/thumb/6/6f/Minimax.svg/300px-Minimax.svg.png

                // Move 1 level (Human)

                parentNodeAnalyzed = -999;

                for (counter1 = 0; counter1 < NodeLevel_1_count; counter1++)
                {
                    if (Int32.Parse(NodesAnalysis1[counter1, 1].ToString()) != parentNodeAnalyzed)
                    {
                        parentNodeAnalyzed = Int32.Parse(NodesAnalysis1[counter1, 1].ToString());
                        NodesAnalysis0[Int32.Parse(NodesAnalysis1[counter1, 1].ToString()), 0] = NodesAnalysis1[counter1, 0];
                        bestNode1 = counter1;
                        bestNodes1[parentNodeAnalyzed] = counter1;
                    }

                    if (m_PlayerColor.CompareTo("White") == 0)
                    {
                        if (NodesAnalysis1[counter1, 0] >= NodesAnalysis0[Int32.Parse(NodesAnalysis1[counter1, 1].ToString()), 0])
                        {
                            NodesAnalysis0[Int32.Parse(NodesAnalysis1[counter1, 1].ToString()), 0] = NodesAnalysis1[counter1, 0];
                            bestNode1 = counter1;
                            bestNodes1[parentNodeAnalyzed] = counter1;
                        }
                    }
                    else if (m_PlayerColor.CompareTo("Black") == 0)
                    {
                        if (NodesAnalysis1[counter1, 0] <= NodesAnalysis0[Int32.Parse(NodesAnalysis1[counter1, 1].ToString()), 0])
                        {
                            NodesAnalysis0[Int32.Parse(NodesAnalysis1[counter1, 1].ToString()), 0] = NodesAnalysis1[counter1, 0];
                            bestNode1 = counter1;
                            bestNodes1[parentNodeAnalyzed] = counter1;
                        }
                    }
                }

                // Choose the biggest score at the Node0 level
                // Check example at http://en.wikipedia.org/wiki/Minimax#Example_2
                // This is line 0 at the shape at http://upload.wikimedia.org/wikipedia/commons/thumb/6/6f/Minimax.svg/300px-Minimax.svg.png

                // Move 0 level (Computer)

                // Initialize the score with the first score and move found
                double temp_score = NodesAnalysis0[0, 0];
                Best_Move_StartingColumnNumber = Int32.Parse(NodesAnalysis0[0, 2].ToString());
                Best_Move_StartingRank = Int32.Parse(NodesAnalysis0[0, 4].ToString());
                Best_Move_FinishingColumnNumber = Int32.Parse(NodesAnalysis0[0, 3].ToString());
                Best_Move_FinishingRank = Int32.Parse(NodesAnalysis0[0, 5].ToString());
                bestNode0 = 0;

                for (counter0 = 0; counter0 < NodeLevel_0_count; counter0++)
                {
                    //v0.992: Add a penalty if the move is the same as the previous one, so as to avoid threefold repetition!
                    //(if the finishing column and rank is the same as the starting column and rank of the previous move and the moving piece is the same)
                    if ((NodesAnalysis0[counter0, 3] == prev_Best_Move_StartingColumnNumber) &&
                       (NodesAnalysis0[counter0, 5] == prev_Best_Move_StartingRank) &&
                       (MovingPiece.CompareTo(prev_MovingPiece) == 0))
                    {
                        if (m_PlayerColor.CompareTo("Black") == 0)
                        {
                            NodesAnalysis0[counter0, 0] = NodesAnalysis0[counter0, 0] - 10;
                        }
                        else if (m_PlayerColor.CompareTo("White") == 0)
                        {
                            NodesAnalysis0[counter0, 0] = NodesAnalysis0[counter0, 0] + 10;
                        }
                    }

                    if (m_PlayerColor.CompareTo("Black") == 0)
                    {
                        if (NodesAnalysis0[counter0, 0] > temp_score)
                        {
                            temp_score = NodesAnalysis0[counter0, 0];

                            Best_Move_StartingColumnNumber = Int32.Parse(NodesAnalysis0[counter0, 2].ToString());
                            Best_Move_StartingRank = Int32.Parse(NodesAnalysis0[counter0, 4].ToString());
                            Best_Move_FinishingColumnNumber = Int32.Parse(NodesAnalysis0[counter0, 3].ToString());
                            Best_Move_FinishingRank = Int32.Parse(NodesAnalysis0[counter0, 5].ToString());
                            bestNode0 = counter0;
                        }
                    }
                    else if (m_PlayerColor.CompareTo("White") == 0)
                    {
                        if (NodesAnalysis0[counter0, 0] < temp_score)
                        {
                            temp_score = NodesAnalysis0[counter0, 0];

                            Best_Move_StartingColumnNumber = Int32.Parse(NodesAnalysis0[counter0, 2].ToString());
                            Best_Move_StartingRank = Int32.Parse(NodesAnalysis0[counter0, 4].ToString());
                            Best_Move_FinishingColumnNumber = Int32.Parse(NodesAnalysis0[counter0, 3].ToString());
                            Best_Move_FinishingRank = Int32.Parse(NodesAnalysis0[counter0, 5].ToString());
                            bestNode0 = counter0;
                        }
                    }
                }

                //v0.992: If mate is found, go for it!
                if (Mate_Found == true)
                {
                    Best_Move_StartingColumnNumber = m_StartingColumnNumber_mate;
                    Best_Move_FinishingColumnNumber = m_FinishingColumnNumber_mate;
                    Best_Move_StartingRank = m_StartingRank_mate;
                    Best_Move_FinishingRank = m_FinishingRank_mate;
                }

                //Store the best move starting column and rank, so that the move is not repeated next time
                //(see above - this was added to remove the possibility of threefold repetition)
                prev_MovingPiece = MovingPiece;
                prev_Best_Move_StartingColumnNumber = Best_Move_StartingColumnNumber;
                prev_Best_Move_StartingRank = Best_Move_StartingRank;
            }

            // Total final positions analyzed is...
            // Mini version: Removed
            // HuoChess_main.FinalPositions = Nodes_Total_count.ToString();

            /////////////////////////////////////////////////////////////////////////////////////////////////
            // REDRAW THE CHESSBOARD
            /////////////////////////////////////////////////////////////////////////////////////////////////

            // Erase the initial square
            //v0.980: Removed. The move is un-done previously anyway
            //for (iii = 0; iii <= 7; iii++)
            //{
            //    for (jjj = 0; jjj <= 7; jjj++)
            //    {
            //        Skakiera[(iii), (jjj)] = Skakiera_Move_0[(iii), (jjj)];
            //    }
            //}

            // v0.981: If no move found => Resign. If best move found => OK. Go do it.
            if (Best_Move_StartingColumnNumber > 0)
            {
                MovingPiece = Skakiera[(Best_Move_StartingColumnNumber - 1), (Best_Move_StartingRank - 1)];
                Skakiera[(Best_Move_StartingColumnNumber - 1), (Best_Move_StartingRank - 1)] = "";

                if (Best_Move_StartingColumnNumber == 1)
                    HY_Starting_Column_Text = "a";
                else if (Best_Move_StartingColumnNumber == 2)
                    HY_Starting_Column_Text = "b";
                else if (Best_Move_StartingColumnNumber == 3)
                    HY_Starting_Column_Text = "c";
                else if (Best_Move_StartingColumnNumber == 4)
                    HY_Starting_Column_Text = "d";
                else if (Best_Move_StartingColumnNumber == 5)
                    HY_Starting_Column_Text = "e";
                else if (Best_Move_StartingColumnNumber == 6)
                    HY_Starting_Column_Text = "f";
                else if (Best_Move_StartingColumnNumber == 7)
                    HY_Starting_Column_Text = "g";
                else if (Best_Move_StartingColumnNumber == 8)
                    HY_Starting_Column_Text = "h";

                // Position piece to the square of destination

                Skakiera[(Best_Move_FinishingColumnNumber - 1), (Best_Move_FinishingRank - 1)] = MovingPiece;

                if (Best_Move_FinishingColumnNumber == 1)
                    HY_Finishing_Column_Text = "a";
                else if (Best_Move_FinishingColumnNumber == 2)
                    HY_Finishing_Column_Text = "b";
                else if (Best_Move_FinishingColumnNumber == 3)
                    HY_Finishing_Column_Text = "c";
                else if (Best_Move_FinishingColumnNumber == 4)
                    HY_Finishing_Column_Text = "d";
                else if (Best_Move_FinishingColumnNumber == 5)
                    HY_Finishing_Column_Text = "e";
                else if (Best_Move_FinishingColumnNumber == 6)
                    HY_Finishing_Column_Text = "f";
                else if (Best_Move_FinishingColumnNumber == 7)
                    HY_Finishing_Column_Text = "g";
                else if (Best_Move_FinishingColumnNumber == 8)
                    HY_Finishing_Column_Text = "h";

                // v0.9921
                // Check if castling occured (so as to move the rook next to the moving king)
                #region castlingOccured
                if (m_PlayerColor.CompareTo("Black") == 0)
                {
                    if ((MovingPiece.CompareTo("White King") == 0) &&
                        (Best_Move_StartingColumnNumber == 5) &&
                        (Best_Move_StartingRank == 1) &&
                        (Best_Move_FinishingColumnNumber == 7) &&
                        (Best_Move_FinishingRank == 1))
                    {
                        Skakiera[(5), (0)] = "White Rook";
                        Skakiera[(7), (0)] = "";
                        White_Castling_Occured = true;
                        //MessageBox.Show( "Ο λευκός κάνει μικρό ροκε." );
                    }
                    else if ((MovingPiece.CompareTo("White King") == 0) &&
                            (Best_Move_StartingColumnNumber == 5) &&
                            (Best_Move_StartingRank == 1) &&
                            (Best_Move_FinishingColumnNumber == 3) &&
                            (Best_Move_FinishingRank == 1))
                    {
                        Skakiera[(3), (0)] = "White Rook";
                        Skakiera[(0), (0)] = "";
                        White_Castling_Occured = true;
                        //MessageBox.Show( "Ο λευκός κάνει μεγάλο ροκε." );
                    }
                }
                else if (m_PlayerColor.CompareTo("White") == 0)
                {
                    if ((MovingPiece.CompareTo("Black King") == 0) &&
                            (Best_Move_StartingColumnNumber == 5) &&
                            (Best_Move_StartingRank == 8) &&
                            (Best_Move_FinishingColumnNumber == 7) &&
                            (Best_Move_FinishingRank == 8))
                    {
                        Skakiera[(5), (7)] = "Black Rook";
                        Skakiera[(7), (7)] = "";
                        Black_Castling_Occured = true;
                        //MessageBox.Show( "Ο μαύρος κάνει μικρό ροκε." );
                    }
                    else if ((MovingPiece.CompareTo("Black King") == 0) &&
                            (Best_Move_StartingColumnNumber == 5) &&
                            (Best_Move_StartingRank == 8) &&
                            (Best_Move_FinishingColumnNumber == 3) &&
                            (Best_Move_FinishingRank == 8))
                    {
                        Skakiera[(3), (7)] = "Black Rook";
                        Skakiera[(0), (7)] = "";
                        Black_Castling_Occured = true;
                        //MessageBox.Show( "Ο μαύρος κάνει μεγάλο ροκε." );
                    }
                }
                #endregion castlingOccured

                // If king is moved, no castling can occur
                if (MovingPiece.CompareTo("White King") == 0)
                    White_King_Moved = true;
                else if (MovingPiece.CompareTo("Black King") == 0)
                    Black_King_Moved = true;

                // Is there a pawn to promote?
                PawnPromotion();

                //////////////////////////////////////////////////////////////////////
                // Show HY move
                //////////////////////////////////////////////////////////////////////

                // v0.980: No need to have NextLine
                NextLine = String.Concat(HY_Starting_Column_Text, Best_Move_StartingRank.ToString(), " -> ", HY_Finishing_Column_Text, Best_Move_FinishingRank.ToString(), " (Move ", Move_Number_Global.ToString(), ")");
                Console.WriteLine(String.Concat("My move: ", HY_Starting_Column_Text, Best_Move_StartingRank.ToString(), " -> ", HY_Finishing_Column_Text, Best_Move_FinishingRank.ToString()));
                //Display_board(Skakiera);
                //MessageBox.Show(number_of_moves_analysed.ToString());
                //MessageBox.Show(NextLine);

                //number_of_moves_analysed = 0;

                // Now it is the other color's turn to play
                if (m_PlayerColor.CompareTo("Black") == 0)
                {
                    m_WhichColorPlays = "Black";
                }
                else if (m_PlayerColor.CompareTo("White") == 0)
                {
                    m_WhichColorPlays = "White";
                }

                //v0.9921: Increase move. Use Move_Number_Global!
                //Move = Move + 1;
                Move_Number_Global = Move_Number_Global + 1;
                // Now it is the Human's turn to play
                m_WhoPlays = "Human";
            }
            // v0.981: If no move found => Resign
            else
            {
                //MessageBox.Show("I resign!");
                Console.WriteLine("I resign!");
            }
        }

        // v0.970: Changed the return type to integer to help memory usage
        // v0.970: Return to basics! Remove too much sauce!
        // v0.980: Changed to be more simple. Removed DangerWeight from the parameters of the function.
        // v0.990: Changes
        // v0.991: Added a penalty for stupid moves and moves to dangerous squares
        // v0.992: Try to make the score double (from int), so as to be able to make more subtle scoring decisions. Did not do at the end due to memory problems.
        // v0.992: Multipled all scores by 10-factor (e.g. score of a bishop is now 30 instead of 3), so that I can include additional checks for the position score.
        // Without doing that I could not add the quality checks I added, e.g. the if (CSSkakiera[3, 4].CompareTo("Black Pawn") == 0) THEN positionScore = positionScore - 0.1.
        // Now the additional score checks can be added with integers, e.g. if (CSSkakiera[3, 4].CompareTo("Black Pawn") == 0) THEN positionScore = positionScore - 1 for the above example.
        // If I wanted to do what using decimals, then all positionScore, bestPositionScore, NodesAnalysis0... NodesAnalysis4 variables and arrays should de defined as DOUBLE, but then we would have memory problems...
        // REMEMBER NOTATION: CSSkakiera[column, row] with columns and rows starting from zero.
        // v0.9921 changes
        // Mini version: Simplified.
        public static int CountScore(string[,] CSSkakiera)
        {
            // White pieces: positive score
            // Black pieces: negative score

            // Scores are x10 so that we can have more detaile scores for specific positions

            //v0.992
            //int Score_Multiplier = 1;
            // Mini version: Removed these
            //int Score_Multiplier_White = 1;
            //int Score_Multiplier_Black = 1;
            int WhiteKingColumn = 0;
            int WhiteKingRank = 0;
            int BlackKingColumn = 0;
            int BlackKingRank = 0;

            //v0.992
            //Detect the kings
            for (i = 0; i <= 7; i++)
            {
                for (j = 0; j <= 7; j++)
                {
                    if (CSSkakiera[(i), (j)].CompareTo("White King") == 0)
                    {
                        WhiteKingColumn = i;
                        WhiteKingRank = j;
                    }
                    if (CSSkakiera[(i), (j)].CompareTo("Black King") == 0)
                    {
                        BlackKingColumn = i;
                        BlackKingRank = j;
                    }
                }
            }

            //v0.992
            //At the ending, make computer more aggressive...
            //if (Move > 30)
            //{
            //    Score_Multiplier = 2;

            //    if (m_PlayerColor.CompareTo("White") == 0)
            //        Score_Multiplier_White = 2;
            //    else if (m_PlayerColor.CompareTo("Black") == 0)
            //        Score_Multiplier_Black = 2;
            //}

            Current_Move_Score = 0;

            // Mini version: Removed
            // v0.991: Have the stupid move generate penalty in the score, without blocking the analysis of moves (all the moves are analyzed)!
            // Mini version: Removed
            //if (ThisIsStupidMove.CompareTo("Y") == 0)
            //{
            //    if (m_PlayerColor.CompareTo("White") == 0)
            //        Current_Move_Score = Current_Move_Score + 1;
            //    else if (m_PlayerColor.CompareTo("Black") == 0)
            //        Current_Move_Score = Current_Move_Score - 1;
            //}

            // Mini version: Removed
            // v0.991: Added a penalty for moving to dangerous square, without blocking the analysis of moves (all the moves are analyzed)!
            //if ((Skakiera_Dangerous_Squares[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)] != 0))
            //{
            //    if (m_PlayerColor.CompareTo("White") == 0)
            //        Current_Move_Score = Current_Move_Score + 1;
            //    else if (m_PlayerColor.CompareTo("Black") == 0)
            //        Current_Move_Score = Current_Move_Score - 1;
            //}

            // v0.991: Add points if possibility to eat is true
            //if ((possibility_to_eat == true))
            //{
            //    if (m_PlayerColor.CompareTo("White") == 0)
            //        Current_Move_Score = Current_Move_Score - 1;
            //    else if (m_PlayerColor.CompareTo("Black") == 0)
            //        Current_Move_Score = Current_Move_Score + 1;
            //}

            for (i = 0; i <= 7; i++)
            {
                for (j = 0; j <= 7; j++)
                {
                    if (CSSkakiera[(i), (j)].CompareTo("White Pawn") == 0)
                    {
                        Current_Move_Score = Current_Move_Score + 10;

                        //Advanced pawns
                        //Current_Move_Score = Current_Move_Score + j;
                        if ((Move_Number_Global > 40) && (j > 3))
                        {
                            Current_Move_Score = Current_Move_Score + j;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("White Rook") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score + 5;
                        Current_Move_Score = Current_Move_Score + 50;

                        //v0.992
                        // Get near the King at the ending...
                        if ((Move_Number_Global > 40) && (Math.Abs(i - BlackKingColumn) < 4))
                        {
                            Current_Move_Score = Current_Move_Score + 1;
                        }
                        if ((Move_Number_Global > 40) && (Math.Abs(j - BlackKingRank) < 4))
                        {
                            Current_Move_Score = Current_Move_Score + 1;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("White Knight") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score + 3;
                        Current_Move_Score = Current_Move_Score + 30;

                        // Get near the King at the ending...
                        if ((Move_Number_Global > 40) && (Math.Abs(i - BlackKingColumn) < 4))
                        {
                            Current_Move_Score = Current_Move_Score + 1;
                        }
                        if ((Move_Number_Global > 40) && (Math.Abs(j - BlackKingRank) < 4))
                        {
                            Current_Move_Score = Current_Move_Score + 1;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("White Bishop") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score + 3;
                        Current_Move_Score = Current_Move_Score + 30;

                        // Get near the King at the ending...
                        //if ((Move_Number_Global > 40) && (Math.Abs(i - BlackKingColumn) < 4))
                        //{
                        //    Current_Move_Score = Current_Move_Score + 1;
                        //}
                        //if ((Move_Number_Global > 40) && (Math.Abs(j - BlackKingRank) < 4))
                        //{
                        //    Current_Move_Score = Current_Move_Score + 1;
                        //}
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("White Queen") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score + 9;
                        Current_Move_Score = Current_Move_Score + 90;

                        // Get near the King at the ending...
                        if ((Move_Number_Global > 40) && (Math.Abs(i - BlackKingColumn) < 3))
                        {
                            Current_Move_Score = Current_Move_Score + 1;
                        }
                        if ((Move_Number_Global > 40) && (Math.Abs(j - BlackKingRank) < 3))
                        {
                            Current_Move_Score = Current_Move_Score + 1;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("White King") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score + 15;
                        Current_Move_Score = Current_Move_Score + 150;
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("Black Pawn") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score - 1;
                        Current_Move_Score = Current_Move_Score - 10;

                        // Advanced pawns
                        //Current_Move_Score = Current_Move_Score - j;
                        if ((Move_Number_Global > 40) && (j < 4))
                        {
                            Current_Move_Score = Current_Move_Score - j;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("Black Rook") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score - 5;
                        Current_Move_Score = Current_Move_Score - 50;

                        // Get near the King at the ending...
                        if ((Move_Number_Global > 40) && (Math.Abs(i - WhiteKingColumn) < 4))
                        {
                            Current_Move_Score = Current_Move_Score - 1;
                        }
                        if ((Move_Number_Global > 40) && (Math.Abs(j - WhiteKingRank) < 4))
                        {
                            Current_Move_Score = Current_Move_Score - 1;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("Black Knight") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score - 3;
                        Current_Move_Score = Current_Move_Score - 30;
                        // Decrease score based on the danger in which the piece is in
                        // v0.970: Delete tis polles malakies
                        // Current_Move_Score = Current_Move_Score + DangerWeight * CheckDanger_Bl(CSSkakiera, i, j);
                        // Get near the King at the ending...
                        if ((Move_Number_Global > 40) && (Math.Abs(i - WhiteKingColumn) < 4))
                        {
                            Current_Move_Score = Current_Move_Score - 1;
                        }
                        if ((Move_Number_Global > 40) && (Math.Abs(j - WhiteKingRank) < 4))
                        {
                            Current_Move_Score = Current_Move_Score - 1;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("Black Bishop") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score - 3;
                        Current_Move_Score = Current_Move_Score - 30;

                        // Get near the King at the ending...
                        //if ((Move_Number_Global > 40) && (Math.Abs(i - WhiteKingColumn) < 4))
                        //{
                        //    Current_Move_Score = Current_Move_Score - 1;
                        //}
                        //if ((Move_Number_Global > 40) && (Math.Abs(j - WhiteKingRank) < 4))
                        //{
                        //    Current_Move_Score = Current_Move_Score - 1;
                        //}
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("Black Queen") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score - 9;
                        Current_Move_Score = Current_Move_Score - 90;

                        // Get near the King at the ending...
                        if ((Move_Number_Global > 40) && (Math.Abs(i - WhiteKingColumn) < 3))
                        {
                            Current_Move_Score = Current_Move_Score - 1;
                        }
                        if ((Move_Number_Global > 40) && (Math.Abs(j - WhiteKingRank) < 3))
                        {
                            Current_Move_Score = Current_Move_Score - 1;
                        }
                    }
                    else if (CSSkakiera[(i), (j)].CompareTo("Black King") == 0)
                    {
                        //Current_Move_Score = Current_Move_Score - 15;    //v0.990: Changed + to -
                        Current_Move_Score = Current_Move_Score - 150;
                    }

                }
            }

            // Position Quality Checks
            // Take the center with the pawns
            if (Move_Number_Global < 16)
            {
                if (CSSkakiera[3, 3].CompareTo("White Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                if (CSSkakiera[4, 3].CompareTo("White Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                if (CSSkakiera[3, 4].CompareTo("Black Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                if (CSSkakiera[4, 4].CompareTo("Black Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                // Do not leave the king in harm's way! Do castling! (small castling promoted)
                // Does not work properly, so for now this is not used - To be improved
                //if (CSSkakiera[4, 0].CompareTo("White King") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score - 5;
                //}
                //if (CSSkakiera[6, 0].CompareTo("White King") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score + 5;
                //}
                //if (CSSkakiera[4, 7].CompareTo("Black King") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score + 5;
                //}
                //if (CSSkakiera[6, 7].CompareTo("Black King") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score - 5;
                //}
                //if (White_Castling_Occured == true)
                //{
                //    Current_Move_Score = Current_Move_Score + 5;
                //}
                //if (Black_Castling_Occured == true)
                //{
                //    Current_Move_Score = Current_Move_Score - 5;
                //}
            }

            // Don't make stupid moves in the beginning
            if (Move_Number_Global < 10)
            {
                // WHITE PIECES
                // Move the knight
                if (CSSkakiera[1, 0].CompareTo("White Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                if (CSSkakiera[6, 0].CompareTo("White Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                // Move the bishop
                if (CSSkakiera[2, 0].CompareTo("White Bishop") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                if (CSSkakiera[5, 0].CompareTo("White Bishop") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                // Do not move the rook
                //if (CSSkakiera[0, 0].CompareTo("") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score - 1;
                //}
                if (CSSkakiera[7, 0].CompareTo("") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                // Do not make stupid moves with knights
                if (CSSkakiera[0, 2].CompareTo("White Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                if (CSSkakiera[7, 2].CompareTo("White Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                // Do not make stupid moves with pawns
                if (CSSkakiera[0, 3].CompareTo("White Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                if (CSSkakiera[7, 3].CompareTo("White Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                // Do not move the queen
                //if (CSSkakiera[3, 0].CompareTo("") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score - 1;
                //}
                // Do not move the king
                //if (CSSkakiera[4, 0].CompareTo("") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score - 1;
                //}

                // BLACK PIECES
                // Move the knight
                if (CSSkakiera[1, 7].CompareTo("Black Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                if (CSSkakiera[6, 7].CompareTo("Black Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                // Move the bishop
                if (CSSkakiera[2, 7].CompareTo("Black Bishop") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                if (CSSkakiera[5, 7].CompareTo("Black Bishop") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                // Do not move the rook
                //if (CSSkakiera[0, 7].CompareTo("") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score + 1;
                //}
                if (CSSkakiera[7, 7].CompareTo("") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                // Do not make stupid moves with knights
                if (CSSkakiera[0, 5].CompareTo("Black Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                if (CSSkakiera[7, 5].CompareTo("Black Knight") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                // Do not make stupid moves with pawns
                if (CSSkakiera[0, 4].CompareTo("Black Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                if (CSSkakiera[7, 4].CompareTo("Black Pawn") == 0)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
                // Do not move the queen
                //if (CSSkakiera[3, 7].CompareTo("") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score + 1;
                //}
                // Do not move the king
                //if (CSSkakiera[4, 7].CompareTo("") == 0)
                //{
                //    Current_Move_Score = Current_Move_Score + 1;
                //}
            }

            // v0.992
            // Check for check
            WhiteKingCheck = CheckForWhiteCheck(CSSkakiera);
            BlackKingCheck = CheckForBlackCheck(CSSkakiera);

            //v0.992
            // Don't make stupid moves in the end...
            //if (Move > 30)
            //{
            //    // Move the rook!
            //    if (CSSkakiera[0, 0].CompareTo("White Rook") == 0)
            //    {
            //        Current_Move_Score = Current_Move_Score - 1;
            //    }
            //    if (CSSkakiera[7, 0].CompareTo("White Rook") == 0)
            //    {
            //        Current_Move_Score = Current_Move_Score - 1;
            //    }
            //    if (CSSkakiera[0, 7].CompareTo("Black Rook") == 0)
            //    {
            //        Current_Move_Score = Current_Move_Score + 1;
            //    }
            //    if (CSSkakiera[7, 7].CompareTo("Black Rook") == 0)
            //    {
            //        Current_Move_Score = Current_Move_Score + 1;
            //    }

            //    //Checking is a good thing...
            //    //(but not too much)
            //    if (WhiteKingCheck == true)
            //    {
            //        Current_Move_Score = Current_Move_Score - 1 * Score_Multiplier_Black;
            //    }
            //    if (BlackKingCheck == true)
            //    {
            //        Current_Move_Score = Current_Move_Score + 1 * Score_Multiplier_White;
            //    }
            //}

            // Finale...
            if (Move_Number_Global > 40)
            {
                //Checking is a good thing...
                //(but not too much)
                if (WhiteKingCheck == true)
                {
                    Current_Move_Score = Current_Move_Score - 1;
                }
                if (BlackKingCheck == true)
                {
                    Current_Move_Score = Current_Move_Score + 1;
                }
            }

            return Current_Move_Score;
        }

        // FUNCTION TO CHECK THE LEGALITY (='Nomimotita' in Greek) OF A MOVE
        // (i.e. if between the initial and the destination square lies another piece, then the move is not legal).
        // The ElegxosNomimotitas "checkForDanger" function differs from the normal function in that it does not make all the validations
        // (since it is used to check for "Dangerous" squares in the chessboard and not to actually judge the correctness of an actual move)
        public static bool ElegxosNomimotitas(string[,] ENSkakiera, int checkForDanger, int startRank, int startColumn, int finishRank, int finishColumn, String MovingPiece_EN)
        {
            //v0.990: Changed MovingPiece_2 to MovingPiece_EN
            String ProsorinoKommati_EN;  // Replaced ProsorinoKommati_KingCheck

            // TODO: Add your control notification handler code here

            bool Nomimotita;
            //Console.WriteLine("into Elegxos Nomimotitas");

            ////////////////////////////////////////////////////////////////////////////////////////////////////////////
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////
            // Έλεγχος της "ΝΟΜΙΜΟΤΗΤΑΣ" της κίνησης. Αν π.χ. ο χρήστης έχει επιλέξει να κινήσει έναν πύργο από
            // το α2 στο α5, αλλά στο α4 υπάρχει κάποιο πιόνι του, τότε η Nomimotita έχει τιμή false.
            // Η συνάρτηση "επιστρέφει" τη boolean μεταβλητή Nomimotita.
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////

            Nomimotita = true;

            if (((finishRank - 1) > 7) || ((finishRank - 1) < 0) || ((finishColumn - 1) > 7) || ((finishColumn - 1) < 0))
                Nomimotita = false;

            // if a piece of the same colour is in the destination square...
            if (checkForDanger == 0)
            {
                if ((MovingPiece_EN.CompareTo("White King") == 0) || (MovingPiece_EN.CompareTo("White Queen") == 0) || (MovingPiece_EN.CompareTo("White Rook") == 0) || (MovingPiece_EN.CompareTo("White Knight") == 0) || (MovingPiece_EN.CompareTo("White Bishop") == 0) || (MovingPiece_EN.CompareTo("White Pawn") == 0))
                {
                    if ((ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("White King") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("White Queen") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("White Rook") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("White Knight") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("White Bishop") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("White Pawn") == 0))
                    {
                        Nomimotita = false;
                    }
                }
                else if ((MovingPiece_EN.CompareTo("Black King") == 0) || (MovingPiece_EN.CompareTo("Black Queen") == 0) || (MovingPiece_EN.CompareTo("Black Rook") == 0) || (MovingPiece_EN.CompareTo("Black Knight") == 0) || (MovingPiece_EN.CompareTo("Black Bishop") == 0) || (MovingPiece_EN.CompareTo("Black Pawn") == 0))
                {
                    if ((ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("Black King") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("Black Queen") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("Black Rook") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("Black Knight") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("Black Bishop") == 0) || (ENSkakiera[((finishColumn - 1)), ((finishRank - 1))].CompareTo("Black Pawn") == 0))
                        Nomimotita = false;
                }
            }

            if (MovingPiece_EN.CompareTo("White King") == 0)
            {
                if (checkForDanger == 0)
                {
                    /////////////////////////
                    // WK
                    /////////////////////////
                    // Is the king threatened in the destination square?
                    // Temporarily move king
                    // huo_sw1.WriteLine(String.Concat("[Point X1 -> ", ENSkakiera[(4), (0)].ToString(), "]"));

                    ENSkakiera[(startColumn - 1), (startRank - 1)] = "";
                    //V0.990
                    //ProsorinoKommati_KingCheck = ENSkakiera[(finishColumn - 1), (finishRank - 1)];
                    ProsorinoKommati_EN = ENSkakiera[(finishColumn - 1), (finishRank - 1)];
                    ENSkakiera[(finishColumn - 1), (finishRank - 1)] = "White King";

                    WhiteKingCheck = CheckForWhiteCheck(ENSkakiera);

                    //huo_sw1.WriteLine(String.Concat("[Point X2 -> ", ENSkakiera[4, 0].ToString(), "]"));

                    if (WhiteKingCheck == true)
                        Nomimotita = false;

                    // Restore pieces

                    // v0.990: Switched line order in restoration of King, because if the starting and destination points are the same, then the King will dissapear! :)
                    // ENSkakiera[(startColumn - 1), (startRank - 1)] = "White King";
                    // v0.990 QUESTION: How can this change affect the table Skakiera_Thinking_HY_2 in Analyze_Move_2_ComputerMove?
                    // v0.990 test of the way changes in ENSkakiera affect the original table in the calling function: ENSkakiera[(startColumn - 1), (startRank - 1)] = "Trela!";
                    // huo_sw1.WriteLine(String.Concat("[Point X3 -> ", ENSkakiera[4, 0].ToString(), "]"));

                    ENSkakiera[(finishColumn - 1), (finishRank - 1)] = ProsorinoKommati_EN; //v0.990 ProsorinoKommati_KingCheck;
                    ENSkakiera[(startColumn - 1), (startRank - 1)] = "White King";
                }
            }
            else if (MovingPiece_EN.CompareTo("Black King") == 0)
            {
                if (checkForDanger == 0)
                {
                    ///////////////////////////
                    // BK
                    ///////////////////////////
                    // Is the BK threatened in the destination square?
                    // Temporarily move king
                    ENSkakiera[(startColumn - 1), (startRank - 1)] = "";
                    // v0.990
                    // ProsorinoKommati_KingCheck = ENSkakiera[(finishColumn - 1), (finishRank - 1)];
                    ProsorinoKommati_EN = ENSkakiera[(finishColumn - 1), (finishRank - 1)];
                    ENSkakiera[(finishColumn - 1), (finishRank - 1)] = "Black King";

                    BlackKingCheck = CheckForBlackCheck(ENSkakiera);

                    if (BlackKingCheck == true)
                        Nomimotita = false;

                    // Restore pieces

                    // v0.990: Switched line order in restoration of King, because if the starting and destination points are the same, then the King will dissapear! :)
                    // ENSkakiera[(startColumn - 1), (startRank - 1)] = "Black King";

                    ENSkakiera[(finishColumn - 1), (finishRank - 1)] = ProsorinoKommati_EN; //v0.990 ProsorinoKommati_KingCheck;
                    ENSkakiera[(startColumn - 1), (startRank - 1)] = "Black King";
                }
            }
            else if (MovingPiece_EN.CompareTo("White Pawn") == 0)
            {
                if (checkForDanger == 0)
                {
                    //Console.WriteLine("checking WP");

                    /////////////////////
                    // WP
                    /////////////////////

                    // Move forward

                    if ((finishRank == (startRank + 1)) && (finishColumn == startColumn))
                    {
                        if (ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 1)
                        {
                            //Console.WriteLine("pawn Nomimotita false");
                            Nomimotita = false;
                        }
                    }

                    // Move forward for 2 squares
                    else if ((finishRank == (startRank + 2)) && (finishColumn == startColumn))
                    {
                        if (startRank == 2)
                        {
                            if ((ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 1) || (ENSkakiera[(finishColumn - 1), (finishRank - 1 - 1)].CompareTo("") == 1))
                                Nomimotita = false;
                        }
                    }

                    // Eat forward to the right

                    else if ((finishRank == (startRank + 1)) && (finishColumn == startColumn + 1))
                    {
                        if (enpassant_occured == false)
                        {
                            if (ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 0)
                                Nomimotita = false;
                        }
                    }

                    // Eat forward to the left

                    else if ((finishRank == (startRank + 1)) && (finishColumn == startColumn - 1))
                    {
                        if (enpassant_occured == false)
                        {
                            if (ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 0)
                                Nomimotita = false;
                        }
                    }
                }
            }
            else if (MovingPiece_EN.CompareTo("Black Pawn") == 0)
            {
                if (checkForDanger == 0)
                {
                    /////////////////////
                    // BP
                    /////////////////////

                    // Move forward

                    if ((finishRank == (startRank - 1)) && (finishColumn == startColumn))
                    {
                        if (ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 1)
                            Nomimotita = false;
                    }

                    // Move forward for 2 squares
                    else if ((finishRank == (startRank - 2)) && (finishColumn == startColumn))
                    {
                        if (startRank == 7)
                        {
                            if ((ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 1) || (ENSkakiera[(finishColumn - 1), (finishRank + 1 - 1)].CompareTo("") == 1))
                                Nomimotita = false;
                        }
                    }

                    // Eat forward to the right

                    else if ((finishRank == (startRank - 1)) && (finishColumn == startColumn + 1))
                    {
                        if (enpassant_occured == false)
                        {
                            if (ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 0)
                                Nomimotita = false;
                        }
                    }

                    // Eat forward to the left

                    else if ((finishRank == (startRank - 1)) && (finishColumn == startColumn - 1))
                    {
                        if (enpassant_occured == false)
                        {
                            if (ENSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("") == 0)
                                Nomimotita = false;
                        }
                    }
                }
            }
            else if ((MovingPiece_EN.CompareTo("White Rook") == 0) || (MovingPiece_EN.CompareTo("White Queen") == 0) || (MovingPiece_EN.CompareTo("White Bishop") == 0) || (MovingPiece_EN.CompareTo("Black Rook") == 0) || (MovingPiece_EN.CompareTo("Black Queen") == 0) || (MovingPiece_EN.CompareTo("Black Bishop") == 0))
            {
                h = 0;
                p = 0;
                //hhh = 0;
                how_to_move_Rank = 0;
                how_to_move_Column = 0;

                if (((finishRank - 1) > (startRank - 1)) || ((finishRank - 1) < (startRank - 1)))
                    how_to_move_Rank = ((finishRank - 1) - (startRank - 1)) / System.Math.Abs((finishRank - 1) - (startRank - 1));

                if (((finishColumn - 1) > (startColumn - 1)) || ((finishColumn - 1) < (startColumn - 1)))
                    how_to_move_Column = ((finishColumn - 1) - (startColumn - 1)) / System.Math.Abs((finishColumn - 1) - (startColumn - 1));

                exit_elegxos_nomimothtas = false;

                do
                {
                    h = h + how_to_move_Rank;
                    p = p + how_to_move_Column;

                    if ((((startRank - 1) + h) == (finishRank - 1)) && ((((startColumn - 1) + p)) == (finishColumn - 1)))
                        exit_elegxos_nomimothtas = true;

                    if ((startColumn - 1 + p) < 0)
                        exit_elegxos_nomimothtas = true;
                    else if ((startRank - 1 + h) < 0)
                        exit_elegxos_nomimothtas = true;
                    else if ((startColumn - 1 + p) > 7)
                        exit_elegxos_nomimothtas = true;
                    else if ((startRank - 1 + h) > 7)
                        exit_elegxos_nomimothtas = true;

                    // If a piece exists between the initial and the destination square, then the move is illegal!
                    if (exit_elegxos_nomimothtas == false)
                    {
                        if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("White Rook") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("White Knight") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("White Bishop") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("White Queen") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("White King") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("White Pawn") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }

                        if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("Black Rook") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("Black Knight") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("Black Bishop") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("Black Queen") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("Black King") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                        else if (ENSkakiera[(startColumn - 1 + p), (startRank - 1 + h)].CompareTo("Black Pawn") == 0)
                        {
                            Nomimotita = false;
                            exit_elegxos_nomimothtas = true;
                        }
                    }
                } while (exit_elegxos_nomimothtas == false);
            }

            // v0.992: The check if there is a check after the move is a check that should be always checked!
            // ATTENTION: This did not work well! Potentially it messed up with a table. So I reverted to the previous situation where the check is done separately in EnterMove and ChecMove.
            // ATTENTION: No, everything is ok! :)
            // Yes: It is done in CheckMove AND EnterMove (for the human player's move)!
            // But it is better to have it centrally and also do it for all moves in the thinking process (not only the first one)!
            // Check for check (do it only for the first two levels of thinking, to speed up thinking)
            if ((Nomimotita == true) && (Move_Analyzed < 2))
            {
                // Check for check (before the move)
                //WhiteKingCheck_before = CheckForWhiteCheck(ENSkakiera);
                //BlackKingCheck_before = CheckForBlackCheck(ENSkakiera);

                // Make the move temporarily
                ENSkakiera[(startColumn - 1), (startRank - 1)] = "";
                ProsorinoKommati_EN = ENSkakiera[(finishColumn - 1), (finishRank - 1)];
                ENSkakiera[(finishColumn - 1), (finishRank - 1)] = MovingPiece_EN;

                // Check for check (after the move)

                // m_WhichColorPlays is not updated throughout the app!
                if (m_WhichColorPlays.CompareTo("White") == 0)
                {
                    WhiteKingCheck = CheckForWhiteCheck(ENSkakiera);
                }
                else if (m_WhichColorPlays.CompareTo("Black") == 0)
                {
                    BlackKingCheck = CheckForBlackCheck(ENSkakiera);
                }

                if ((m_WhichColorPlays.CompareTo("White") == 0) && (WhiteKingCheck == true))
                {
                    Nomimotita = false;
                }
                if ((m_WhichColorPlays.CompareTo("Black") == 0) && (BlackKingCheck == true))
                {
                    Nomimotita = false;
                }

                //if ((WhiteKingCheck_before == true) && (WhiteKingCheck == true))
                //{
                //    Nomimotita = false;
                //}
                //if ((BlackKingCheck_before == true) && (BlackKingCheck == true))
                //{
                //    Nomimotita = false;
                //}

                // Return pieces to original position (potentially not needed, but let's be consistent and ψείρες)
                ENSkakiera[(finishColumn - 1), (finishRank - 1)] = ProsorinoKommati_EN; //v0.990 ProsorinoKommati_KingCheck;
                ENSkakiera[(startColumn - 1), (startRank - 1)] = MovingPiece_EN;
            }

            //--------------- v0.9921: Castling -------------------
            #region checkCastling
            // White castling

            //MessageBox.Show(String.Concat("m_WhichColorPlays = ", m_WhichColorPlays));
            //MessageBox.Show(String.Concat("startColumn = ", startColumn.ToString()));
            //MessageBox.Show(String.Concat("finishColumn = ", finishColumn.ToString()));
            //MessageBox.Show(String.Concat("startRank = ", startRank.ToString()));
            //MessageBox.Show(String.Concat("finishRank = ", finishRank.ToString()));
            //MessageBox.Show(String.Concat("White_Castling_Occured = ", White_Castling_Occured.ToString()));
            //MessageBox.Show(String.Concat("White_King_Moved = ", White_King_Moved.ToString()));
            //MessageBox.Show(String.Concat("m_StartingColumnNumber = ", m_StartingColumnNumber.ToString()));
            //MessageBox.Show(String.Concat("m_FinishingColumnNumber = ", m_FinishingColumnNumber.ToString()));
            //MessageBox.Show(String.Concat("m_StartingRank = ", m_StartingRank.ToString()));
            //MessageBox.Show(String.Concat("m_FinishingRank = ", m_FinishingRank.ToString()));
            //MessageBox.Show(String.Concat("Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)] = ", Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].ToString()));
            //MessageBox.Show(String.Concat("Skakiera[(5), (0)] = ", Skakiera[(5), (0)].ToString()));
            //MessageBox.Show(String.Concat("Skakiera[(6), (0)] = ", Skakiera[(6), (0)].ToString()));
            //MessageBox.Show(String.Concat("Skakiera[(7), (0)] = ", Skakiera[(7), (0)].ToString()));
            //MessageBox.Show(String.Concat("ENSkakiera[(5), (0)] = ", ENSkakiera[(5), (0)].ToString()));
            //MessageBox.Show(String.Concat("ENSkakiera[(6), (0)] = ", ENSkakiera[(6), (0)].ToString()));

            // Small castling
            if ((m_WhichColorPlays.CompareTo("White") == 0) &&
                (startColumn == 5) &&
                (finishColumn == 7) &&
                (startRank == 1) &&
                (finishRank == 1) &&
                (White_Castling_Occured == false) &&
                (White_King_Moved == false))
            {
                //MessageBox.Show("Check 1.0");
                if ((ENSkakiera[(startColumn - 1), (startRank - 1)].CompareTo("White King") == 0) && (ENSkakiera[(7), (0)].CompareTo("White Rook") == 0) && (ENSkakiera[(5), (0)].CompareTo("") == 0) && (ENSkakiera[(6), (0)].CompareTo("") == 0))
                {
                    //m_OrthotitaKinisis = true;
                    m_NomimotitaKinisis = true;
                    Castling_Move = true;
                    //MessageBox.Show("Check 1.1");
                }
            }

            // Big castling
            if ((m_WhichColorPlays.CompareTo("White") == 0) && (m_StartingColumnNumber == 5) && (m_FinishingColumnNumber == 3) && (m_StartingRank == 1) && (m_FinishingRank == 1) && (White_Castling_Occured == false) && (White_King_Moved == false))
            {
                if ((ENSkakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("White King") == 0) && (ENSkakiera[(0), (0)].CompareTo("White Rook") == 0) && (ENSkakiera[(1), (0)].CompareTo("") == 0) && (ENSkakiera[(2), (0)].CompareTo("") == 0) && (ENSkakiera[(3), (0)].CompareTo("") == 0))
                {
                    //m_OrthotitaKinisis = true;
                    m_NomimotitaKinisis = true;
                    Castling_Move = true;
                    //MessageBox.Show("Check 1.2");
                }
            }

            // Black castling

            // Small castling
            if ((m_WhichColorPlays.CompareTo("Black") == 0) && (m_StartingColumnNumber == 5) && (m_FinishingColumnNumber == 7) && (m_StartingRank == 8) && (m_FinishingRank == 8) && (Black_Castling_Occured == false) && (Black_King_Moved == false))
            {
                if ((ENSkakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black King") == 0) && (ENSkakiera[(7), (7)].CompareTo("Black Rook") == 0) && (ENSkakiera[(5), (7)].CompareTo("") == 0) && (ENSkakiera[(6), (7)].CompareTo("") == 0))
                {
                    //m_OrthotitaKinisis = true;
                    m_NomimotitaKinisis = true;
                    Castling_Move = true;
                    //MessageBox.Show("Check 1.3");
                    //if (m_WhichColorPlays.CompareTo("Black") == 0)
                    //    MessageBox.Show(String.Concat("Castling_Move = ", Castling_Move.ToString()));
                }
            }

            // Big castling
            if ((m_WhichColorPlays.CompareTo("Black") == 0) && (m_StartingColumnNumber == 5) && (m_FinishingColumnNumber == 3) && (m_StartingRank == 8) && (m_FinishingRank == 8) && (Black_Castling_Occured == false) && (Black_King_Moved == false))
            {
                if ((ENSkakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black King") == 0) && (ENSkakiera[(0), (7)].CompareTo("Black Rook") == 0) && (ENSkakiera[(1), (7)].CompareTo("") == 0) && (ENSkakiera[(2), (7)].CompareTo("") == 0) && (ENSkakiera[(3), (7)].CompareTo("") == 0))
                {
                    //m_OrthotitaKinisis = true;
                    m_NomimotitaKinisis = true;
                    Castling_Move = true;
                    //MessageBox.Show("Check 1.4");
                }
            }
            #endregion checkCastling
            //--------------- v0.9921: Castling -------------------

            return Nomimotita;
        }

        // FUNCTION TO CHECK THE CORRECTNESS (='Orthotita' in Greek) OF THE MOVE
        // (i.e. a Bishop can only move in diagonals, rooks in lines and columns etc)
        // The ElegxosOrthotitas "checkForDanger" mode differs from the ElegxosOrthotitas normal mode in that it does not make all the validations
        // (since it is used to check for "Dangerous" squares in the chessboard and not to actually judge the correctness of an actual move)
        public static bool ElegxosOrthotitas(string[,] EOSkakiera, int checkForDanger, int startRank, int startColumn, int finishRank, int finishColumn, String MovingPiece_EO)
        {
            // v0.990: Changed MovingPiece_2 to MovingPiece_EO
            // TODO: Add your control notification handler code here
            // If called for checking dangerous squares, put a virtual piece in the destination square so as to pass the validation checks
            // if (checkForDanger == 1)
            // Don't care about checking for the existence of a piece in the destination square

            bool Orthotita;
            Orthotita = false;
            enpassant_occured = false;

            //Console.WriteLine("ElegxosOrthotitas");
            //Console.WriteLine(MovingPiece_EO);

            if ((m_WhoPlays.CompareTo("Human") == 0) && (m_WrongColumn == false) && (MovingPiece_EO.CompareTo("") == 1))    // Αν ο χρήστης έχει γράψει μία έγκυρη στήλη και έχει
            {                                                         // επιλέξει να κινήσει ένα κομμάτι (και δεν έχει επι-
                                                                      // λέξει να κινήσει ένα "κενό" τετράγωνο) και είναι η σειρά του να παίξει, τότε να γί-
                                                                      // νει έλεγχος της ορθότητας της κίνησης. 

                // Console.WriteLine("1");

                // ROOK

                if ((MovingPiece_EO.CompareTo("White Rook") == 0) || (MovingPiece_EO.CompareTo("Black Rook") == 0))
                {
                    if ((finishColumn != startColumn) && (finishRank == startRank))       // Κίνηση σε στήλη
                        Orthotita = true;
                    else if ((finishRank != startRank) && (finishColumn == startColumn))  // Κίνηση σε γραμμή
                        Orthotita = true;
                }

                // Horse (with knight...)

                if ((MovingPiece_EO.CompareTo("White Knight") == 0) || (MovingPiece_EO.CompareTo("Black Knight") == 0))
                {
                    if ((finishColumn == (startColumn + 1)) && (finishRank == (startRank + 2)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn + 2)) && (finishRank == (startRank - 1)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn + 1)) && (finishRank == (startRank - 2)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn - 1)) && (finishRank == (startRank - 2)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn - 2)) && (finishRank == (startRank - 1)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn - 2)) && (finishRank == (startRank + 1)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn - 1)) && (finishRank == (startRank + 2)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn + 2)) && (finishRank == (startRank + 1)))
                        Orthotita = true;
                }

                // Bishop

                if ((MovingPiece_EO.CompareTo("White Bishop") == 0) || (MovingPiece_EO.CompareTo("Black Bishop") == 0))
                {
                    ////////////////////
                    // 2009 v4 change
                    ////////////////////
                    //if ((Math.Abs(finishColumn - startColumn)) == (Math.Abs(finishRank - startRank)))
                    //    Orthotita = true;
                    if (((Math.Abs(finishColumn - startColumn)) == (Math.Abs(finishRank - startRank))) && (finishColumn != startColumn) && (finishRank != startRank))
                        Orthotita = true;
                    ////////////////////
                    // 2009 v4 change
                    ////////////////////
                }

                // Queen

                if ((MovingPiece_EO.CompareTo("White Queen") == 0) || (MovingPiece_EO.CompareTo("Black Queen") == 0))
                {
                    if ((finishColumn != startColumn) && (finishRank == startRank))       // Κίνηση σε στήλη
                        Orthotita = true;
                    else if ((finishRank != startRank) && (finishColumn == startColumn))  // Κίνηση σε γραμμή
                        Orthotita = true;

                    ////////////////////
                    // 2009 v4 change
                    ////////////////////
                    // move in diagonals
                    //if ((Math.Abs(finishColumn - startColumn)) == (Math.Abs(finishRank - startRank)))
                    //    Orthotita = true;
                    if (((Math.Abs(finishColumn - startColumn)) == (Math.Abs(finishRank - startRank))) && (finishColumn != startColumn) && (finishRank != startRank))
                        Orthotita = true;
                    ////////////////////
                    // 2009 v4 change
                    ////////////////////
                }

                // King

                if ((MovingPiece_EO.CompareTo("White King") == 0) || (MovingPiece_EO.CompareTo("Black King") == 0))
                {
                    // Move in rows and columns

                    if ((finishColumn == (startColumn + 1)) && (finishRank == startRank))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn - 1)) && (finishRank == startRank))
                        Orthotita = true;
                    else if ((finishRank == (startRank + 1)) && (finishColumn == startColumn))
                        Orthotita = true;
                    else if ((finishRank == (startRank - 1)) && (finishColumn == startColumn))
                        Orthotita = true;

                    // Move in diagonals

                    else if ((finishColumn == (startColumn + 1)) && (finishRank == (startRank + 1)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn + 1)) && (finishRank == (startRank - 1)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn - 1)) && (finishRank == (startRank - 1)))
                        Orthotita = true;
                    else if ((finishColumn == (startColumn - 1)) && (finishRank == (startRank + 1)))
                        Orthotita = true;

                }

                // WP

                if (MovingPiece_EO.CompareTo("White Pawn") == 0)
                {
                    // Move forward
                    // Console.WriteLine("2");

                    if ((finishRank == (startRank + 1)) && (finishColumn == startColumn))
                        Orthotita = true;

                    // Move forward for 2 squares
                    else if ((finishRank == (startRank + 2)) && (finishColumn == startColumn) && (startRank == 2))
                        Orthotita = true;

                    else if ((finishRank == (startRank + 1)) && ((finishColumn == (startColumn - 1)) || (finishColumn == (startColumn + 1))))
                    {
                        if (checkForDanger == 0)
                        {
                            // Eat forward to the left
                            if ((finishRank == (startRank + 1)) && (finishColumn == (startColumn - 1)) && ((EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Pawn") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Rook") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Knight") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Bishop") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Queen") == 0)))
                                Orthotita = true;

                            // Eat forward to the right
                            if ((finishRank == (startRank + 1)) && (finishColumn == (startColumn + 1)) && ((EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Pawn") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Rook") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Knight") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Bishop") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("Black Queen") == 0)))
                                Orthotita = true;
                        }
                        else if (checkForDanger == 1)
                        {
                            Orthotita = true;
                        }
                    }

                    // En Passant eat forward to the left
                    else if ((finishRank == (startRank + 1)) && (finishColumn == (startColumn - 1)))
                    {
                        if (checkForDanger == 0)
                        {
                            //Console.WriteLine(finishRank.ToString());
                            //Console.WriteLine(finishColumn.ToString());
                            //Console.WriteLine("checking En passant...");
                            if ((finishRank == 6) && (EOSkakiera[(finishColumn - 1), (4)].CompareTo("Black Pawn") == 0))
                            {
                                Orthotita = true;
                                enpassant_occured = true;
                                EOSkakiera[(finishColumn - 1), (finishRank - 1 - 1)] = "";
                                //Console.WriteLine("En passant true");
                            }
                            else
                            {
                                Orthotita = false;
                                enpassant_occured = false;
                            }
                        }
                    }

                    // En Passant eat forward to the right
                    else if ((finishRank == (startRank + 1)) && (finishColumn == (startColumn + 1)))
                    {
                        if (checkForDanger == 0)
                        {
                            if ((finishRank == 6) && (EOSkakiera[(finishColumn - 1), (4)].CompareTo("Black Pawn") == 0))
                            {
                                Orthotita = true;
                                enpassant_occured = true;
                                EOSkakiera[(finishColumn - 1), (finishRank - 1 - 1)] = "";
                            }
                            else
                            {
                                Orthotita = false;
                                enpassant_occured = false;
                            }
                        }
                    }

                }


                // BP

                if (MovingPiece_EO.CompareTo("Black Pawn") == 0)
                {
                    // Move forward

                    if ((finishRank == (startRank - 1)) && (finishColumn == startColumn))
                        Orthotita = true;

                    // Move forward for 2 squares
                    else if ((finishRank == (startRank - 2)) && (finishColumn == startColumn) && (startRank == 7))
                        Orthotita = true;

                    else if ((finishRank == (startRank - 1)) && ((finishColumn == (startColumn + 1)) || (finishColumn == (startColumn - 1))))
                    {
                        if (checkForDanger == 0)
                        {
                            // Eat forward to the left
                            if ((finishRank == (startRank - 1)) && (finishColumn == (startColumn + 1)) && ((EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Pawn") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Rook") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Knight") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Bishop") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Queen") == 0)))
                                Orthotita = true;

                            // Eat forward to the right
                            if ((finishRank == (startRank - 1)) && (finishColumn == (startColumn - 1)) && ((EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Pawn") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Rook") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Knight") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Bishop") == 0) || (EOSkakiera[(finishColumn - 1), (finishRank - 1)].CompareTo("White Queen") == 0)))
                                Orthotita = true;
                        }
                        else if (checkForDanger == 1)
                        {
                            // Eat forward to the left
                            if ((finishRank == (startRank - 1)) && (finishColumn == (startColumn + 1)))
                                Orthotita = true;

                            // Eat forward to the right
                            if ((finishRank == (startRank - 1)) && (finishColumn == (startColumn - 1)))
                                Orthotita = true;
                        }
                    }

                    // En Passant eat forward to the left
                    else if ((finishRank == (startRank - 1)) && (finishColumn == (startColumn + 1)))
                    {
                        if (checkForDanger == 0)
                        {
                            if ((finishRank == 3) && (EOSkakiera[(finishColumn - 1), (3)].CompareTo("White Pawn") == 0))
                            {
                                Orthotita = true;
                                enpassant_occured = true;
                                EOSkakiera[(finishColumn - 1), (finishRank + 1 - 1)] = "";
                            }
                            else
                            {
                                Orthotita = false;
                                enpassant_occured = false;
                            }
                        }
                    }

                    // En Passant eat forward to the right
                    else if ((finishRank == (startRank - 1)) && (finishColumn == (startColumn - 1)))
                    {
                        if (checkForDanger == 0)
                        {
                            if ((finishRank == 3) && (EOSkakiera[(finishColumn - 1), (3)].CompareTo("White Pawn") == 0))
                            {
                                Orthotita = true;
                                enpassant_occured = true;
                                EOSkakiera[(finishColumn - 1), (finishRank + 1 - 1)] = "";
                            }
                            else
                            {
                                Orthotita = false;
                                enpassant_occured = false;
                            }
                        }
                    }

                }

            }

            //Console.WriteLine(Orthotita.ToString());
            return Orthotita;
        }


        // v0.970: Fixed comments
        // v0.980: Fixed it!
        // v0.990 changes
        public static void Enter_move()
        {
            // Validate the move the Hu opponent entered

            // Show the move entered by the Hu player

            if (m_StartingColumn.CompareTo("A") == 0)
                m_StartingColumnNumber = 1;
            else if (m_StartingColumn.CompareTo("B") == 0)
                m_StartingColumnNumber = 2;
            else if (m_StartingColumn.CompareTo("C") == 0)
                m_StartingColumnNumber = 3;
            else if (m_StartingColumn.CompareTo("D") == 0)
                m_StartingColumnNumber = 4;
            else if (m_StartingColumn.CompareTo("E") == 0)
                m_StartingColumnNumber = 5;
            else if (m_StartingColumn.CompareTo("F") == 0)
                m_StartingColumnNumber = 6;
            else if (m_StartingColumn.CompareTo("G") == 0)
                m_StartingColumnNumber = 7;
            else if (m_StartingColumn.CompareTo("H") == 0)
                m_StartingColumnNumber = 8;


            if (m_FinishingColumn.CompareTo("A") == 0)
                m_FinishingColumnNumber = 1;
            else if (m_FinishingColumn.CompareTo("B") == 0)
                m_FinishingColumnNumber = 2;
            else if (m_FinishingColumn.CompareTo("C") == 0)
                m_FinishingColumnNumber = 3;
            else if (m_FinishingColumn.CompareTo("D") == 0)
                m_FinishingColumnNumber = 4;
            else if (m_FinishingColumn.CompareTo("E") == 0)
                m_FinishingColumnNumber = 5;
            else if (m_FinishingColumn.CompareTo("F") == 0)
                m_FinishingColumnNumber = 6;
            else if (m_FinishingColumn.CompareTo("G") == 0)
                m_FinishingColumnNumber = 7;
            else if (m_FinishingColumn.CompareTo("H") == 0)
                m_FinishingColumnNumber = 8;

            // Is it his turn?
            // Mini version: Removed. The user anyway is not able to write when computer is thinking!
            //if (m_WhoPlays.CompareTo("HY") == 0)   // Αν είναι η σειρά του υπολογιστή να παίξει (και όχι του χρήστη), τότε άκυρο!!
            //    Console.WriteLine("Not your turn");  // v0.980: Reduced the text everywhere

            // Is the column entered valid?

            // Αν χρήστης έχει εισάγει μία έγκυρη στήλη (π.χ. "ε" ή "ζ") και πάει να κινήσει ένα κομμάτι του σωστού
            // χρώματος (π.χ. έναν λευκό ίππο και είναι πράγματι η σειρά των λευκών να παίξουν) τότε να προχωρήσει το
            // πρόγραμμα σε ό,τι κάνει.
            // Δεν είναι απαραίτητο να γίνει και έλεγχος του αν ο χρήστης έχει γράψει σωστή γραμμή (ήτοι ένα
            // νούμερο από το 1 έως το 8), διότι αυτό απαγορεύεται από τη δήλωση των μεταβλητών m_StartingRank και
            // m_FinishingRank (οι οποίες έχουν δηλωθεί σαν ακέραιοι που παίρνουν τιμές από 1 έως 8).

            if (((m_WhoPlays.CompareTo("Human") == 0)) && (((m_WhichColorPlays.CompareTo("White") == 0) && ((Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("White Pawn") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("White Rook") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("White Knight") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("White Bishop") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("White Queen") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("White King") == 0))) || ((m_WhichColorPlays.CompareTo("Black") == 0) && ((Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black Pawn") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black Rook") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black Knight") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black Bishop") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black Queen") == 0) || (Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)].CompareTo("Black King") == 0)))))
            {
                m_WrongColumn = false;
                MovingPiece = Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)];
            }
            else
            {
                m_WrongColumn = true;
            }

            //V0.9921
            Castling_Move = false;

            // Check correctness of move entered
            m_OrthotitaKinisis = ElegxosOrthotitas(Skakiera, 0, m_StartingRank, m_StartingColumnNumber, m_FinishingRank, m_FinishingColumnNumber, MovingPiece);

            // Check legality of move entered (only if it is correct - so as to save time!)
            //v0.9921: Always check for Nomimotita, because there the castling is analyzed!
            //if (m_OrthotitaKinisis == true)
            m_NomimotitaKinisis = ElegxosNomimotitas(Skakiera, 0, m_StartingRank, m_StartingColumnNumber, m_FinishingRank, m_FinishingColumnNumber, MovingPiece);

            //v0.9921: If castling, then Orthotita is also OK!
            if (Castling_Move == true)
                m_OrthotitaKinisis = true;

            //v0.9921: Code for castling
            if (MovingPiece.CompareTo("White King") == 0)
                White_King_Moved = true;
            else if (MovingPiece.CompareTo("Black King") == 0)
                Black_King_Moved = true;

            // v0.992: Pawn promotion is checked once centrally through pawn promotion function PawnPromotion()!!
            //         However this is needed here so as to calculate correctly the value of the human piece!
            //         So since I do this here, the PawnPromotion() call is not needed... :P
            // v0.990
            // Promotion
            if ((MovingPiece.CompareTo("White Pawn") == 0) && (m_FinishingRank == 8))
                MovingPiece = "White Queen";
            if ((MovingPiece.CompareTo("Black Pawn") == 0) && (m_FinishingRank == 1))
                MovingPiece = "Black Queen";

            // Check if castling occured (so as to move the rook next to the moving king)
            #region castlingOccured
            if (m_PlayerColor.CompareTo("White") == 0)
            {
                //MessageBox.Show("Checkpoint 1.5");
                if ((MovingPiece.CompareTo("White King") == 0) &&
                    (m_StartingColumnNumber == 5) &&
                    (m_StartingRank == 1) &&
                    (m_FinishingColumnNumber == 7) &&
                    (m_FinishingRank == 1))
                {
                    Skakiera[(5), (0)] = "White Rook";
                    Skakiera[(7), (0)] = "";
                    White_Castling_Occured = true;
                    //MessageBox.Show( "Ο λευκός κάνει μικρό ροκε." );
                }
                else if ((MovingPiece.CompareTo("White King") == 0) &&
                        (m_StartingColumnNumber == 5) &&
                        (m_StartingRank == 1) &&
                        (m_FinishingColumnNumber == 3) &&
                        (m_FinishingRank == 1))
                {
                    Skakiera[(3), (0)] = "White Rook";
                    Skakiera[(0), (0)] = "";
                    White_Castling_Occured = true;
                    //MessageBox.Show( "Ο λευκός κάνει μεγάλο ροκε." );
                }
            }
            else if (m_PlayerColor.CompareTo("Black") == 0)
            {
                if ((MovingPiece.CompareTo("Black King") == 0) &&
                        (m_StartingColumnNumber == 5) &&
                        (m_StartingRank == 8) &&
                        (m_FinishingColumnNumber == 7) &&
                        (m_FinishingRank == 8))
                {
                    Skakiera[(5), (7)] = "Black Rook";
                    Skakiera[(7), (7)] = "";
                    Black_Castling_Occured = true;
                    //MessageBox.Show( "Ο μαύρος κάνει μικρό ροκε." );
                }
                else if ((MovingPiece.CompareTo("Black King") == 0) &&
                        (m_StartingColumnNumber == 5) &&
                        (m_StartingRank == 8) &&
                        (m_FinishingColumnNumber == 3) &&
                        (m_FinishingRank == 8))
                {
                    Skakiera[(3), (7)] = "Black Rook";
                    Skakiera[(0), (7)] = "";
                    Black_Castling_Occured = true;
                    //MessageBox.Show( "Ο μαύρος κάνει μεγάλο ροκε." );
                }
            }
            #endregion castlingOccured

            // Redraw the chessboard
            if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
            {
                if ((MovingPiece.CompareTo("White Rook") == 0) || (MovingPiece.CompareTo("Black Rook") == 0))
                    ValueOfHumanMovingPiece = 5;
                if ((MovingPiece.CompareTo("White Knight") == 0) || (MovingPiece.CompareTo("Black Knight") == 0))
                    ValueOfHumanMovingPiece = 3;
                if ((MovingPiece.CompareTo("White Bishop") == 0) || (MovingPiece.CompareTo("Black Bishop") == 0))
                    ValueOfHumanMovingPiece = 3;
                if ((MovingPiece.CompareTo("White Queen") == 0) || (MovingPiece.CompareTo("Black Queen") == 0))
                    ValueOfHumanMovingPiece = 9;
                if ((MovingPiece.CompareTo("White King") == 0) || (MovingPiece.CompareTo("Black King") == 0))
                    ValueOfHumanMovingPiece = 119;
                if ((MovingPiece.CompareTo("White Pawn") == 0) || (MovingPiece.CompareTo("Black Pawn") == 0))
                    ValueOfHumanMovingPiece = 1;

                // Erase initial square
                Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)] = "";

                // Store last human move
                Human_last_move_target_column = -1;
                Human_last_move_target_row = -1;

                if (Skakiera[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)].CompareTo("") != 0)
                {
                    Human_last_move_target_column = m_FinishingColumnNumber;
                    Human_last_move_target_row = m_FinishingRank;
                }

                // Go to destination square
                Skakiera[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1)] = MovingPiece;

                // Check for en passant
                #region checkEnPassant
                if (enpassant_occured == true)
                {
                    if (m_PlayerColor.CompareTo("White") == 0)
                        Skakiera[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1 - 1)] = "";
                    else if (m_PlayerColor.CompareTo("Black") == 0)
                        Skakiera[(m_FinishingColumnNumber - 1), (m_FinishingRank - 1 + 1)] = "";
                }

                ////////////////////////////////////////////////////////////////////
                // Record possible square when the next one playing will be able to perform en passant
                ////////////////////////////////////////////////////////////////////
                if ((m_StartingRank == 2) && (m_FinishingRank == 4))
                {
                    enpassant_possible_target_rank = m_FinishingRank - 1;
                    enpassant_possible_target_column = m_FinishingColumnNumber;
                }
                else if ((m_StartingRank == 7) && (m_FinishingRank == 5))
                {
                    enpassant_possible_target_rank = m_FinishingRank + 1;
                    enpassant_possible_target_column = m_FinishingColumnNumber;
                }
                else
                {
                    // Invalid value for enpassant move (= enpassant not possible in the next move)
                    enpassant_possible_target_rank = -9;
                    enpassant_possible_target_column = -9;
                }
                #endregion checkEnPassant

                m_WhoPlays = "HY";

                // It is the other color's turn to play
                if (m_WhichColorPlays.CompareTo("White") == 0)
                    m_WhichColorPlays = "Black";
                else if (m_WhichColorPlays.CompareTo("Black") == 0)
                    m_WhichColorPlays = "White";

                // Restore variable values to initial values
                m_StartingColumn = "";
                m_FinishingColumn = "";
                m_StartingRank = 1;
                m_FinishingRank = 1;

                // If it is the turn of the HY to play, then call the respective HY Thought function
                if (m_WhoPlays.CompareTo("HY") == 0)
                {
                    Move_Analyzed = 0;
                    Stop_Analyzing = false;
                    First_Call = true;
                    Best_Move_Found = false;
                    Who_Is_Analyzed = "HY";
                }

            }

            else
            {
                //v0.980: Simplify
                Console.WriteLine("Invalid move");
                //MessageBox.Show("Invalid move");
                //v0.980: These are not required. WhoPlayes will remain unchanged if move is not legal
                //Skakiera[(m_StartingColumnNumber - 1), (m_StartingRank - 1)] = MovingPiece;
                //MovingPiece = "";
                //m_WhoPlays = "Human";
            }


        }

        public static void Analyze_Move_1_HumanMove(string[,] Skakiera_Human_Thinking_2)
        {
            // Mini version: Removed unused variables
            //int bestScoreLevel1 = 0;

            // Scan chessboard . Find a piece of the Human player . Move to all possible squares.
            // Check corr1ectness and legality of move . If all OK then measure the move's score.
            // Do the best move and handle over to the ComputerMove function to continue analysis in the next move (deeper depth...)
            // v0.990: Initialized the values
            int skakos1 = 0;
            int trelos35 = 0;
            String MovingPiece1 = "";
            String ProsorinoKommati1 = "";
            int m_StartingColumnNumber1 = 0;
            int m_FinishingColumnNumber1 = 0;
            int m_StartingRank1 = 0;
            int m_FinishingRank1 = 0;

            //v0.992
            Human_Move_Found = false;

            // Check all possible moves
            for (skakos1 = 0; skakos1 <= 7; skakos1++)
            {
                for (trelos35 = 0; trelos35 <= 7; trelos35++)
                {
                    if (((Who_Is_Analyzed.CompareTo("Human") == 0) && ((((Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("Black King") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("Black Queen") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("Black Rook") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("Black Knight") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("Black Bishop") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)) || (((Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("White King") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("White Queen") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("White Rook") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("White Knight") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("White Bishop") == 0) || (Skakiera_Human_Thinking_2[(skakos1), (trelos35)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)))))
                    {
                        for (int w = 0; w <= 7; w++)
                        {
                            for (int r = 0; r <= 7; r++)
                            {
                                MovingPiece1 = Skakiera_Human_Thinking_2[(skakos1), (trelos35)];
                                m_StartingColumnNumber1 = skakos1 + 1;
                                m_FinishingColumnNumber1 = w + 1;
                                m_StartingRank1 = trelos35 + 1;
                                m_FinishingRank1 = r + 1;

                                m_StartingColumnNumber1_public = m_StartingColumnNumber1;
                                m_FinishingColumnNumber1_public = m_FinishingColumnNumber1;
                                m_StartingRank1_public = m_StartingRank1;
                                m_FinishingRank1_public = m_FinishingRank1;

                                ProsorinoKommati1 = Skakiera_Human_Thinking_2[(m_FinishingColumnNumber1 - 1), (m_FinishingRank1 - 1)];

                                // Check the move
                                // number_of_moves_analysed++;

                                // Necessary values for variables for the ElegxosOrthotitas (check move corr1ectness) and
                                // ElegxosNomimotitas (check move legality) function to...function properly.
                                m_WhoPlays = "Human";
                                m_WrongColumn = false;
                                m_OrthotitaKinisis = ElegxosOrthotitas(Skakiera_Human_Thinking_2, 0, m_StartingRank1, m_StartingColumnNumber1, m_FinishingRank1, m_FinishingColumnNumber1, MovingPiece1);
                                m_NomimotitaKinisis = ElegxosNomimotitas(Skakiera_Human_Thinking_2, 0, m_StartingRank1, m_StartingColumnNumber1, m_FinishingRank1, m_FinishingColumnNumber1, MovingPiece1);
                                // Restore normal value of m_WhoPlays
                                m_WhoPlays = "HY";

                                // If all ok, then do the move and measure it
                                if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
                                {
                                    Human_Move_Found = true;

                                    // Do the move
                                    ProsorinoKommati1 = Skakiera_Human_Thinking_2[(m_FinishingColumnNumber1 - 1), (m_FinishingRank1 - 1)];
                                    Skakiera_Human_Thinking_2[(m_StartingColumnNumber1 - 1), (m_StartingRank1 - 1)] = "";
                                    Skakiera_Human_Thinking_2[(m_FinishingColumnNumber1 - 1), (m_FinishingRank1 - 1)] = MovingPiece1;

                                    // Count the score of the move
                                    Temp_Score_Move_1_human = CountScore(Skakiera_Human_Thinking_2);

                                    // Store score
                                    NodesAnalysis1[NodeLevel_1_count, 0] = Temp_Score_Move_1_human;
                                    // Store parent
                                    NodesAnalysis1[NodeLevel_1_count, 1] = NodeLevel_0_count;

                                    // Mini version: Directly call next thinking function
                                    // Call ComputerMove for the HY throught process to continue
                                    Move_Analyzed = Move_Analyzed + 1;

                                    Who_Is_Analyzed = "HY";

                                    String[,] Skakiera_Move_After_1_new = new String[8, 8];

                                    for (i = 0; i <= 7; i++)
                                    {
                                        for (j = 0; j <= 7; j++)
                                        {
                                            Skakiera_Move_After_1_new[(i), (j)] = Skakiera_Human_Thinking_2[(i), (j)];
                                        }
                                    }

                                    Analyze_Move_2_ComputerMove(Skakiera_Move_After_1_new);

                                    // Undo the move
                                    Skakiera_Human_Thinking_2[(m_StartingColumnNumber1 - 1), (m_StartingRank1 - 1)] = MovingPiece1;
                                    Skakiera_Human_Thinking_2[(m_FinishingColumnNumber1 - 1), (m_FinishingRank1 - 1)] = ProsorinoKommati1;

                                    // v0.991 - This should be done here!
                                    NodeLevel_1_count++;
                                    Nodes_Total_count++;
                                }

                            } // For 4
                        } // For 3

                    }// IF

                } // For 2
            } // For 1

            //v0.992 suggestion: Check if there is mate or stalemate!
            if (Human_Move_Found == false)
            {
                // Check for check
                if (m_PlayerColor.CompareTo("White") == 0)
                {
                    WhiteKingCheck = CheckForWhiteCheck(Skakiera_Human_Thinking_2);
                }
                else if (m_PlayerColor.CompareTo("Black") == 0)
                {
                    BlackKingCheck = CheckForBlackCheck(Skakiera_Human_Thinking_2);
                }
                // If no move found and it is check, then it is mate! Go for it!
                if ((m_PlayerColor.CompareTo("White") == 0) && (WhiteKingCheck == true))
                {
                    Mate_Found = true;
                    m_StartingColumnNumber_mate = m_StartingColumnNumber_HY;
                    m_FinishingColumnNumber_mate = m_FinishingColumnNumber_HY;
                    m_StartingRank_mate = m_StartingRank_HY;
                    m_FinishingRank_mate = m_FinishingRank_HY;
                }
                // If there is no move and the king is not under check, it is pat! (stalemate)
                if ((m_PlayerColor.CompareTo("White") == 0) && (WhiteKingCheck == false))
                {
                    Pat_Found = true;
                }
                if ((m_PlayerColor.CompareTo("Black") == 0) && (BlackKingCheck == true))
                {
                    Mate_Found = true;
                    m_StartingColumnNumber_mate = m_StartingColumnNumber_HY;
                    m_FinishingColumnNumber_mate = m_FinishingColumnNumber_HY;
                    m_StartingRank_mate = m_StartingRank_HY;
                    m_FinishingRank_mate = m_FinishingRank_HY;
                }
                // If there is no move and the king is not under check, it is pat! (stalemate)
                if ((m_PlayerColor.CompareTo("Black") == 0) && (BlackKingCheck == false))
                {
                    //Pat! (= stalemate)
                    Pat_Found = true;
                }
            }

            Move_Analyzed = Move_Analyzed - 1;
            Who_Is_Analyzed = "HY";
        }

        public static void Analyze_Move_3_HumanMove(string[,] Skakiera_Human_Thinking_3)
        {
            // v0.990 change: The best score for every move will be stored at each level. Only if the new move analyzed
            // has a better score than the best score, will it be analyzed (target: trim the analysis tree)
            // Mini version: Removed
            // int bestScoreLevel3 = 0;

            // Scan chessboard . Find a piece of the Hu player . Move to all possible squares.
            // Check correctness and legality of move . If all OK then measure the move's score.
            // Do the best move and handle over to the ComputerMove function to continue analysis in the next move (deeper depth...)
            // v0.990: Initialized the values
            int skakos3 = 0;
            int trelos35 = 0;
            String MovingPiece3 = "";
            String ProsorinoKommati3 = "";
            int m_StartingColumnNumber3 = 0;
            int m_FinishingColumnNumber3 = 0;
            int m_StartingRank3 = 0;
            int m_FinishingRank3 = 0;

            String[,] Skakiera_Move_After_3 = new String[8, 8];

            // Check all possible moves
            for (skakos3 = 0; skakos3 <= 7; skakos3++)
            {
                for (trelos35 = 0; trelos35 <= 7; trelos35++)
                {
                    if (((Who_Is_Analyzed.CompareTo("Human") == 0) && ((((Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("Black King") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("Black Queen") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("Black Rook") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("Black Knight") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("Black Bishop") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)) || (((Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("White King") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("White Queen") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("White Rook") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("White Knight") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("White Bishop") == 0) || (Skakiera_Human_Thinking_3[(skakos3), (trelos35)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)))))
                    {
                        for (int w = 0; w <= 7; w++)
                        {
                            for (int r = 0; r <= 7; r++)
                            {
                                MovingPiece3 = Skakiera_Human_Thinking_3[(skakos3), (trelos35)];
                                m_StartingColumnNumber3 = skakos3 + 1;
                                m_FinishingColumnNumber3 = w + 1;
                                m_StartingRank3 = trelos35 + 1;
                                m_FinishingRank3 = r + 1;
                                ProsorinoKommati3 = Skakiera_Human_Thinking_3[(m_FinishingColumnNumber3 - 1), (m_FinishingRank3 - 1)];

                                // Check the move
                                // number_of_moves_analysed++;

                                // Necessary values for variables for the ElegxosOrthotitas (check move corr1ectness) and
                                // ElegxosNomimotitas (check move legality) function to...function properly.
                                m_WhoPlays = "Human";
                                m_WrongColumn = false;
                                m_OrthotitaKinisis = ElegxosOrthotitas(Skakiera_Human_Thinking_3, 0, m_StartingRank3, m_StartingColumnNumber3, m_FinishingRank3, m_FinishingColumnNumber3, MovingPiece3);
                                m_NomimotitaKinisis = ElegxosNomimotitas(Skakiera_Human_Thinking_3, 0, m_StartingRank3, m_StartingColumnNumber3, m_FinishingRank3, m_FinishingColumnNumber3, MovingPiece3);
                                // Restore normal value of m_WhoPlays
                                m_WhoPlays = "HY";

                                // If all ok, then do the move and measure it
                                if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
                                {
                                    // Do the move
                                    Skakiera_Human_Thinking_3[(m_StartingColumnNumber3 - 1), (m_StartingRank3 - 1)] = "";
                                    Skakiera_Human_Thinking_3[(m_FinishingColumnNumber3 - 1), (m_FinishingRank3 - 1)] = MovingPiece3;

                                    Temp_Score_Move_3_human = CountScore(Skakiera_Human_Thinking_3);

                                    // Store score
                                    NodesAnalysis3[NodeLevel_3_count, 0] = Temp_Score_Move_3_human;
                                    // Store parent
                                    NodesAnalysis3[NodeLevel_3_count, 1] = NodeLevel_2_count;

                                    // v0.9921: Go deeper if we are at the end of the game
                                    // Mini version: Go at next level anyway. Removed the (Move_Analyzed < Thinking_Depth) condition
                                    if (ProsorinoKommati3.CompareTo("") == 1)
                                    {
                                        // Call ComputerMove for the HY throught process to continue
                                        Move_Analyzed = Move_Analyzed + 1;

                                        // v0.990 change: Store the best move at this level
                                        // bestScoreLevel3 = Temp_Score_Move_3_human;

                                        Who_Is_Analyzed = "HY";

                                        String[,] Skakiera_Move_After_3_new = new String[8, 8];

                                        for (i = 0; i <= 7; i++)
                                        {
                                            for (j = 0; j <= 7; j++)
                                            {
                                                //v0.992: Is Skakiera_Move_After_3 used anywhere?
                                                Skakiera_Move_After_3[(i), (j)] = Skakiera_Human_Thinking_3[(i), (j)];
                                                Skakiera_Move_After_3_new[(i), (j)] = Skakiera_Human_Thinking_3[(i), (j)];
                                            }
                                        }

                                        // Call next level of thinking
                                        Analyze_Move_4_ComputerMove(Skakiera_Move_After_3_new);
                                    }

                                    // Undo the move
                                    Skakiera_Human_Thinking_3[(m_StartingColumnNumber3 - 1), (m_StartingRank3 - 1)] = MovingPiece3;
                                    Skakiera_Human_Thinking_3[(m_FinishingColumnNumber3 - 1), (m_FinishingRank3 - 1)] = ProsorinoKommati3;

                                    // Checkpoint increaseNodeCount
                                    NodeLevel_3_count++;
                                    Nodes_Total_count++;
                                }

                            } // For 4
                        } // For 3

                    }// IF

                } // For 2
            } // For 1

            Move_Analyzed = Move_Analyzed - 1;
            Who_Is_Analyzed = "HY";
        }

        public static void Analyze_Move_2_ComputerMove(string[,] Skakiera_Thinking_HY_2)
        {
            // v0.990 change: The best score for every move will be stored at each level. Only if the new move analyzed
            // has a better score than the best score, will it be analyzed (target: trim the analysis tree)
            int bestScoreLevel2 = 0;

            // Δήλωση μεταβλητών που χρησιμοποιούνται στο βρόγχο "for" (δεν μπορεί να χρησιμοποιηθούν οι μεταβλητές i και j διότι αυτές οι
            // μεταβλητές είναι καθολικές και δημιουργείται πρόβλημα κατά την επιστροφή στην ComputerMove από την CheckMove)
            // v0.990: Initialized the values
            int iii2 = 0;
            int jjj2 = 0;
            String MovingPiece2 = "";
            String ProsorinoKommati2 = "";
            int m_StartingColumnNumber2 = 0;
            int m_FinishingColumnNumber2 = 0;
            int m_StartingRank2 = 0;
            int m_FinishingRank2 = 0;

            // v0.990: Added a new separate chessboard to communicate between different functions.
            String[,] Skakiera_Move_After_2 = new String[8, 8];

            // Σκανάρισμα της σκακιέρας: Όταν εντοπίζεται κάποιο κομμάτι του υπολογιστή,
            // θα υπολογίζονται ΟΛΕΣ οι πιθανές κινήσεις του προς κάθε κατεύθυνση, ακόμα
            // και αυτές που δεν μπορεί να κάνει το κομμάτι. Στη συνέχεια, με τη βοήθεια
            // των συναρτήσεων ElegxosNomimotitas και ElegxosOrthotitas θα ελέγχεται το
            // αν η κίνηση είναι ορθή και νόμιμη. Αν είναι, η εν λόγω κίνηση θα γίνεται
            // προσωρινά στη σκακιέρα και θα καταγράφεται το σκορ της νέας θέσης που προέκυψε

            // ΣΗΜΕΙΩΣΗ: Σε όλες τις στήλες και τις οριζόντιους προστίθεται η μονάδα (+1)
            // διότι πρέπει να μετατραπούν από το "σύστημα" μέτρησης "0-7" (που χρησιμο-
            // ποιείται στο παρακάτω "for i…next" αλλά και στο συμβολισμό του πίνακα
            // Skakiera) στο σύστημα μέτρησης "1-8" το οποίο χρησιμοποιείται στις
            // μεταβλητές Starting/Finishing_Column/Rank σε όλο το υπόλοιπο πρόγραμμα.

            for (iii2 = 0; iii2 <= 7; iii2++)
            {
                for (jjj2 = 0; jjj2 <= 7; jjj2++)
                {

                    if (((Who_Is_Analyzed.CompareTo("HY") == 0) && ((((Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("White King") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("White Queen") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("White Rook") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("White Knight") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("White Bishop") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)) || (((Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("Black King") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("Black Queen") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("Black Rook") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("Black Knight") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("Black Bishop") == 0) || (Skakiera_Thinking_HY_2[(iii2), (jjj2)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)))))
                    {
                        for (int w = 0; w <= 7; w++)
                        {
                            for (int r = 0; r <= 7; r++)
                            {
                                MovingPiece2 = Skakiera_Thinking_HY_2[(iii2), (jjj2)];
                                m_StartingColumnNumber2 = iii2 + 1;
                                m_FinishingColumnNumber2 = w + 1;
                                m_StartingRank2 = jjj2 + 1;
                                m_FinishingRank2 = r + 1;
                                ProsorinoKommati2 = Skakiera_Thinking_HY_2[(m_FinishingColumnNumber2 - 1), (m_FinishingRank2 - 1)];

                                //v0.992
                                m_StartingColumnNumber2_public = m_StartingColumnNumber2;
                                m_FinishingColumnNumber2_public = m_FinishingColumnNumber2;
                                m_StartingRank2_public = m_StartingRank2;
                                m_FinishingRank2_public = m_FinishingRank2;

                                // Έλεγχος της κίνησης (Check the move)

                                // Check validity and legality
                                // Necessary values for variables for the ElegxosOrthotitas (check move corr1ectness) and
                                // ElegxosNomimotitas (check move legality) function to...function properly.
                                m_WhoPlays = "Human";
                                m_WrongColumn = false;

                                m_OrthotitaKinisis = ElegxosOrthotitas(Skakiera_Thinking_HY_2, 0, m_StartingRank2, m_StartingColumnNumber2, m_FinishingRank2, m_FinishingColumnNumber2, MovingPiece2);
                                m_NomimotitaKinisis = ElegxosNomimotitas(Skakiera_Thinking_HY_2, 0, m_StartingRank2, m_StartingColumnNumber2, m_FinishingRank2, m_FinishingColumnNumber2, MovingPiece2);

                                // Restore normal value of m_WhoPlays
                                m_WhoPlays = "HY";

                                // If all ok, then do the move and measure it
                                if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
                                {
                                    // Do the move
                                    ProsorinoKommati2 = Skakiera_Thinking_HY_2[(m_FinishingColumnNumber2 - 1), (m_FinishingRank2 - 1)];
                                    Skakiera_Thinking_HY_2[(m_StartingColumnNumber2 - 1), (m_StartingRank2 - 1)] = "";
                                    Skakiera_Thinking_HY_2[(m_FinishingColumnNumber2 - 1), (m_FinishingRank2 - 1)] = MovingPiece2;

                                    // Count the score of the move
                                    Temp_Score_Move_2 = CountScore(Skakiera_Thinking_HY_2);

                                    // Store scores
                                    NodesAnalysis2[NodeLevel_2_count, 0] = Temp_Score_Move_2;
                                    // Store parents
                                    NodesAnalysis2[NodeLevel_2_count, 1] = NodeLevel_1_count;

                                    // If thinking depth not reached? (Don't forget to trim the tree!)
                                    // v0.9921: Go deeper in the end of the game anyway
                                    // Mini version: Removed the (Move_Analyzed < Thinking_Depth) condition.
                                    if (ProsorinoKommati2.CompareTo("") == 1)
                                    {
                                        Move_Analyzed = Move_Analyzed + 1;

                                        // Store the best score at this level
                                        bestScoreLevel2 = Temp_Score_Move_2;

                                        for (i = 0; i <= 7; i++)
                                        {
                                            for (j = 0; j <= 7; j++)
                                            {
                                                Skakiera_Move_After_2[(i), (j)] = Skakiera_Thinking_HY_2[(i), (j)];
                                            }
                                        }

                                        Who_Is_Analyzed = "Human";

                                        Analyze_Move_3_HumanMove(Skakiera_Move_After_2);
                                    }

                                    // Undo the move
                                    Skakiera_Thinking_HY_2[(m_StartingColumnNumber2 - 1), (m_StartingRank2 - 1)] = MovingPiece2;
                                    Skakiera_Thinking_HY_2[(m_FinishingColumnNumber2 - 1), (m_FinishingRank2 - 1)] = ProsorinoKommati2;

                                    // v0.991 - This should be done here!
                                    NodeLevel_2_count++;
                                    Nodes_Total_count++;
                                }

                            }
                        }

                    }


                }
            }

            Move_Analyzed = Move_Analyzed - 1;
            Who_Is_Analyzed = "Human";
        }

        public static void Analyze_Move_4_ComputerMove(string[,] Skakiera_Thinking_HY_4)
        {
            // v0.990 change: The best score for every move will be stored at each level. Only if the new move analyzed
            // has a better score than the best score, will it be analyzed (target: trim the analysis tree)
            //int bestScoreLevel4 = 0;

            // Δήλωση μεταβλητών που χρησιμοποιούνται στο βρόγχο "for" (δεν μπορεί να χρησιμοποιηθούν οι μεταβλητές i και j διότι αυτές οι
            // μεταβλητές είναι καθολικές και δημιουργείται πρόβλημα κατά την επιστροφή στην ComputerMove από την CheckMove)
            // v0.990: Initialized the values
            int iii42 = 0;
            int jjj42 = 0;
            String MovingPiece4 = "";
            String ProsorinoKommati4 = "";
            int m_StartingColumnNumber4 = 0;
            int m_FinishingColumnNumber4 = 0;
            int m_StartingRank4 = 0;
            int m_FinishingRank4 = 0;

            // Mini version: Removed
            //String[,] Skakiera_Move_After_4 = new String[8, 8];

            // Σκανάρισμα της σκακιέρας: Όταν εντοπίζεται κάποιο κομμάτι του υπολογιστή,
            // θα υπολογίζονται ΟΛΕΣ οι πιθανές κινήσεις του προς κάθε κατεύθυνση, ακόμα
            // και αυτές που δεν μπορεί να κάνει το κομμάτι. Στη συνέχεια, με τη βοήθεια
            // των συναρτήσεων ElegxosNomimotitas και ElegxosOrthotitas θα ελέγχεται το
            // αν η κίνηση είναι ορθή και νόμιμη. Αν είναι, η εν λόγω κίνηση θα γίνεται
            // προσωρινά στη σκακιέρα και θα καταγράφεται το σκορ της νέας θέσης που προέκυψε.

            // ΣΗΜΕΙΩΣΗ: Σε όλες τις στήλες και τις οριζόντιους προστίθεται η μονάδα (+1)
            // διότι πρέπει να μετατραπούν από το "σύστημα" μέτρησης "0-7" (που χρησιμο-
            // ποιείται στο παρακάτω "for i…next" αλλά και στο συμβολισμό του πίνακα
            // Skakiera) στο σύστημα μέτρησης "1-8" το οποίο χρησιμοποιείται στις
            // μεταβλητές Starting/Finishing_Column/Rank σε όλο το υπόλοιπο πρόγραμμα.

            for (iii42 = 0; iii42 <= 7; iii42++)
            {
                for (jjj42 = 0; jjj42 <= 7; jjj42++)
                {

                    if (((Who_Is_Analyzed.CompareTo("HY") == 0) && ((((Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("White King") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("White Queen") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("White Rook") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("White Knight") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("White Bishop") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)) || (((Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("Black King") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("Black Queen") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("Black Rook") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("Black Knight") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("Black Bishop") == 0) || (Skakiera_Thinking_HY_4[(iii42), (jjj42)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)))))
                    {

                        for (int w = 0; w <= 7; w++)
                        {
                            for (int r = 0; r <= 7; r++)
                            {
                                MovingPiece4 = Skakiera_Thinking_HY_4[(iii42), (jjj42)];
                                m_StartingColumnNumber4 = iii42 + 1;
                                m_FinishingColumnNumber4 = w + 1;
                                m_StartingRank4 = jjj42 + 1;
                                m_FinishingRank4 = r + 1;
                                ProsorinoKommati4 = Skakiera_Thinking_HY_4[(m_FinishingColumnNumber4 - 1), (m_FinishingRank4 - 1)];

                                // Έλεγχος της κίνησης (Check move)
                                // Check validity and legality
                                // Necessary values for variables for the ElegxosOrthotitas (check move corr1ectness) and
                                // ElegxosNomimotitas (check move legality) function to...function properly.
                                m_WhoPlays = "Human";
                                m_WrongColumn = false;

                                m_OrthotitaKinisis = ElegxosOrthotitas(Skakiera_Thinking_HY_4, 0, m_StartingRank4, m_StartingColumnNumber4, m_FinishingRank4, m_FinishingColumnNumber4, MovingPiece4);
                                m_NomimotitaKinisis = ElegxosNomimotitas(Skakiera_Thinking_HY_4, 0, m_StartingRank4, m_StartingColumnNumber4, m_FinishingRank4, m_FinishingColumnNumber4, MovingPiece4);

                                // Restore normal value of m_WhoPlays
                                m_WhoPlays = "HY";

                                // If all ok, then do the move and measure it
                                if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
                                {
                                    // Do the move
                                    Skakiera_Thinking_HY_4[(m_StartingColumnNumber4 - 1), (m_StartingRank4 - 1)] = "";
                                    Skakiera_Thinking_HY_4[(m_FinishingColumnNumber4 - 1), (m_FinishingRank4 - 1)] = MovingPiece4;

                                    Temp_Score_Move_4 = CountScore(Skakiera_Thinking_HY_4);

                                    // Store scores
                                    NodesAnalysis4[NodeLevel_4_count, 0] = Temp_Score_Move_4;
                                    // Store parents
                                    NodesAnalysis4[NodeLevel_4_count, 1] = NodeLevel_3_count;

                                    // Undo the move
                                    Skakiera_Thinking_HY_4[(m_StartingColumnNumber4 - 1), (m_StartingRank4 - 1)] = MovingPiece4;
                                    Skakiera_Thinking_HY_4[(m_FinishingColumnNumber4 - 1), (m_FinishingRank4 - 1)] = ProsorinoKommati4;

                                    // v0.992
                                    NodeLevel_4_count++;
                                    Nodes_Total_count++;
                                }

                            }
                        }

                    }


                }
            }

            Move_Analyzed = Move_Analyzed - 1;
            Who_Is_Analyzed = "Human";
        }

        // v0.990 changes
        // Mini version: Removed
        //public static void FindAttackers(string[,] SkakieraAttackers)
        //{
        //    //v0.990: Initialized the values
        //    String MovingPiece_Attack = "";
        //    int m_StartingRank_Attack = 0;
        //    int m_StartingColumnNumber_Attack = 0;
        //    int m_FinishingRank_Attack = 0;
        //    int m_FinishingColumnNumber_Attack = 0;

        //    // Scan the chessboard . if a piece of HY is found . check all
        //    // possible destinations in the chessboard . check correctness of
        //    // the move analyzed . check legality of the move analyzed . if
        //    // correct and legal, then do the move.
        //    // NOTE: In all column and rank numbers I add +1, because I must transform
        //    // them from the 0...7 'measure system' of the chessboard (='Skakiera' in Greek) table
        //    // to the 1...8 'measure system' of the chessboard.

        //    for (int iii2 = 0; iii2 <= 7; iii2++)
        //    {
        //        for (int jjj2 = 0; jjj2 <= 7; jjj2++)
        //        {
        //            if ((((SkakieraAttackers[(iii2), (jjj2)].CompareTo("White King") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("White Queen") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("White Rook") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("White Knight") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("White Bishop") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)) || (((SkakieraAttackers[(iii2), (jjj2)].CompareTo("Black King") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("Black Queen") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("Black Rook") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("Black Knight") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("Black Bishop") == 0) || (SkakieraAttackers[(iii2), (jjj2)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)))
        //            {

        //                MovingPiece_Attack = SkakieraAttackers[(iii2), (jjj2)];
        //                m_StartingColumnNumber_Attack = iii2 + 1;
        //                m_StartingRank_Attack = jjj2 + 1;

        //                // find squares where the Hu opponent can hit
        //                for (int w2 = 0; w2 <= 7; w2++)
        //                {
        //                    for (int r2 = 0; r2 <= 7; r2++)
        //                    {
        //                        m_FinishingColumnNumber_Attack = w2 + 1;
        //                        m_FinishingRank_Attack = r2 + 1;

        //                        // check the move
        //                        m_WhoPlays = "Human";
        //                        m_WrongColumn = false;
        //                        m_OrthotitaKinisis = ElegxosOrthotitas(Skakiera, 1, m_StartingRank_Attack, m_StartingColumnNumber_Attack, m_FinishingRank_Attack, m_FinishingColumnNumber_Attack, MovingPiece_Attack);
        //                        if (m_OrthotitaKinisis == true)
        //                        {
        //                            m_NomimotitaKinisis = ElegxosNomimotitas(Skakiera, 1, m_StartingRank_Attack, m_StartingColumnNumber_Attack, m_FinishingRank_Attack, m_FinishingColumnNumber_Attack, MovingPiece_Attack);
        //                        }
        //                        // restore normal value of m_whoplays
        //                        m_WhoPlays = "HY";
        //                        // 2012: If a pawn is moving, then take into account only moves of eating other pieces!
        //                        // and not moves of moving forward
        //                        if ((MovingPiece_Attack.CompareTo("White Pawn") == 0) || (MovingPiece_Attack.CompareTo("Black Pawn") == 0))
        //                        {
        //                            if (m_FinishingColumnNumber_Attack == m_StartingColumnNumber_Attack)
        //                            {
        //                                m_OrthotitaKinisis = false;
        //                            }
        //                        }

        //                        if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
        //                        {
        //                            // Another attacker on that square found!
        //                            Number_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Number_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 1;
        //                            // v0.96
        //                            //Skakiera_Dangerous_Squares[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = "Danger";

        //                            //2012 new
        //                            //v0.980: Removed Attackers_coordinates_column/rank since they are not used!
        //                            //Attackers_coordinates_column[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = m_StartingColumnNumber_Attack - 1;
        //                            //Attackers_coordinates_rank[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = m_StartingRank_Attack - 1;

        //                            // Calculate the value (total value) of the attackers
        //                            //MessageBox.Show(string.Concat("Added something to the value of attackers: ", MovingPiece_Attack.ToString()));

        //                            if ((MovingPiece_Attack.CompareTo("White Rook") == 0) || (MovingPiece_Attack.CompareTo("Black Rook") == 0))
        //                                Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 5;
        //                            else if ((MovingPiece_Attack.CompareTo("White Bishop") == 0) || (MovingPiece_Attack.CompareTo("Black Bishop") == 0))
        //                                Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 3;
        //                            else if ((MovingPiece_Attack.CompareTo("White Knight") == 0) || (MovingPiece_Attack.CompareTo("Black Knight") == 0))
        //                                Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 3;
        //                            else if ((MovingPiece_Attack.CompareTo("White Queen") == 0) || (MovingPiece_Attack.CompareTo("Black Queen") == 0))
        //                                Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 9;
        //                            else if ((MovingPiece_Attack.CompareTo("White Pawn") == 0) || (MovingPiece_Attack.CompareTo("Black Pawn") == 0))
        //                                Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 1;
        //                            //v0.95
        //                            //else if ((MovingPiece_Attack.CompareTo("White King") == 0) || (MovingPiece_Attack.CompareTo("Black King") == 0))
        //                            //    Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_attackers[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 15;
        //                        }
        //                    }
        //                }
        //            }
        //        }
        //    }


        //}

        // v0.990 changes
        // Mini version: Removed
        //public static void FindDefenders(string[,] SkakieraDefenders)
        //{
        //    //v0.990: Initialized the values
        //    String MovingPiece_Attack = "";
        //    int m_StartingRank_Attack = 0;
        //    int m_StartingColumnNumber_Attack = 0;
        //    int m_FinishingRank_Attack = 0;
        //    int m_FinishingColumnNumber_Attack = 0;

        //    // Find squares that are also 'protected' by a piece of the HY.
        //    // If protected, then the square is not really dangerous

        //    // Changed in version 0.5
        //    // Initialize all variables used to find exceptions in the non-dangerous squares.
        //    // Exceptions definition: If Hu can hit a square and the computer defends it with its pieces, then the
        //    // square is not dangerous. However, if the computer has only one (1) piece to defend that square, then
        //    // it cannot move that specific piece to that square (because then the square would have no defenders and
        //    // would become again a dangerous square!).

        //    for (int iii3 = 0; iii3 <= 7; iii3++)
        //    {
        //        for (int jjj3 = 0; jjj3 <= 7; jjj3++)
        //        {
        //            if ((((SkakieraDefenders[(iii3), (jjj3)].CompareTo("White King") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("White Queen") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("White Rook") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("White Knight") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("White Bishop") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("White Pawn") == 0)) && (m_PlayerColor.CompareTo("Black") == 0)) || (((SkakieraDefenders[(iii3), (jjj3)].CompareTo("Black King") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("Black Queen") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("Black Rook") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("Black Knight") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("Black Bishop") == 0) || (SkakieraDefenders[(iii3), (jjj3)].CompareTo("Black Pawn") == 0)) && (m_PlayerColor.CompareTo("White") == 0)))
        //            {
        //                MovingPiece_Attack = SkakieraDefenders[(iii3), (jjj3)];
        //                m_StartingColumnNumber_Attack = iii3 + 1;
        //                m_StartingRank_Attack = jjj3 + 1;

        //                for (int w1 = 0; w1 <= 7; w1++)
        //                {
        //                    for (int r1 = 0; r1 <= 7; r1++)
        //                    {

        //                        m_FinishingColumnNumber_Attack = w1 + 1;
        //                        m_FinishingRank_Attack = r1 + 1;

        //                        // Έλεγχος της κίνησης
        //                        // Απόδοση τιμών στις μεταβλητές m_WhoPlays και m_WrongColumn, οι οποίες είναι απαραίτητες για να λειτουργήσει σωστά οι συναρτήσεις ElegxosNomimotitas και ElegxosOrthotitas
        //                        m_WhoPlays = "Human";
        //                        m_WrongColumn = false;
        //                        m_OrthotitaKinisis = ElegxosOrthotitas(SkakieraDefenders, 1, m_StartingRank_Attack, m_StartingColumnNumber_Attack, m_FinishingRank_Attack, m_FinishingColumnNumber_Attack, MovingPiece_Attack);
        //                        if (m_OrthotitaKinisis == true)
        //                        {
        //                            m_NomimotitaKinisis = ElegxosNomimotitas(SkakieraDefenders, 1, m_StartingRank_Attack, m_StartingColumnNumber_Attack, m_FinishingRank_Attack, m_FinishingColumnNumber_Attack, MovingPiece_Attack);
        //                        }
        //                        // Επαναφορά της κανονικής τιμής της m_WhoPlays
        //                        m_WhoPlays = "HY";

        //                        // NEW
        //                        // You can count for all moves that "defend" a square,
        //                        // except the move of a pawn forward! :)
        //                        if ((MovingPiece_Attack.CompareTo("White Pawn") == 0) || (MovingPiece_Attack.CompareTo("Black Pawn") == 0))
        //                        {
        //                            if (m_FinishingColumnNumber_Attack == m_StartingColumnNumber_Attack)
        //                            {
        //                                m_OrthotitaKinisis = false;
        //                            }
        //                        }

        //                        m_WhoPlays = "HY";
        //                        if ((m_OrthotitaKinisis == true) && (m_NomimotitaKinisis == true))
        //                        {
        //                            // A new defender for that square is found!
        //                            Number_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Number_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 1;

        //                            // Calculate the value (total value) of the defenders
        //                            //MessageBox.Show(string.Concat("Added something to the value of defenders for (", (m_FinishingColumnNumber_Attack).ToString(), ",", (m_FinishingRank_Attack).ToString(), "): ", MovingPiece_Attack.ToString()));

        //                            if ((MovingPiece_Attack.CompareTo("White Rook") == 0) || (MovingPiece_Attack.CompareTo("Black Rook") == 0))
        //                                Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 5;
        //                            else if ((MovingPiece_Attack.CompareTo("White Bishop") == 0) || (MovingPiece_Attack.CompareTo("Black Bishop") == 0))
        //                                Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 3;
        //                            else if ((MovingPiece_Attack.CompareTo("White Knight") == 0) || (MovingPiece_Attack.CompareTo("Black Knight") == 0))
        //                                Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 3;
        //                            else if ((MovingPiece_Attack.CompareTo("White Queen") == 0) || (MovingPiece_Attack.CompareTo("Black Queen") == 0))
        //                                Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 9;
        //                            else if ((MovingPiece_Attack.CompareTo("White Pawn") == 0) || (MovingPiece_Attack.CompareTo("Black Pawn") == 0))
        //                                Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 1;
        //                            else if ((MovingPiece_Attack.CompareTo("White King") == 0) || (MovingPiece_Attack.CompareTo("Black King") == 0))
        //                                Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = Value_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] + 15;

        //                            //v0.980: Removed Exception_defender_column/ rank since they are not used!
        //                            // Exception for Defenders!
        //                            // If the defender found is the only one, then that defender cannot move to that square,
        //                            // since then the square would be again dangerous (since its only defender would have moved into it!)
        //                            // If more than one defenders is found, then no exceptions exist.
        //                            //if (Number_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] == 1)
        //                            //{
        //                            //    Exception_defender_column[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = (m_StartingColumnNumber_Attack - 1);
        //                            //    Exception_defender_rank[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = (m_StartingRank_Attack - 1);

        //                            //    // DEBUGGING
        //                            //    //if (((m_FinishingColumnNumber_Attack - 1) == 2) && ((m_FinishingRank_Attack - 1) == 4))
        //                            //    //{
        //                            //    //    MessageBox.Show("hOU");
        //                            //    //    MessageBox.Show(String.Concat("Move found: ", m_StartingColumnNumber_Attack.ToString(), m_StartingRank_Attack.ToString(), "->", m_FinishingColumnNumber_Attack.ToString(), m_FinishingRank_Attack.ToString()));
        //                            //    //    MessageBox.Show(String.Concat("Exception column: ",Exception_defender_column[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)]));
        //                            //    //    MessageBox.Show(String.Concat("Exception rank: ",Exception_defender_rank[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)]));
        //                            //    //    MessageBox.Show(String.Concat("Exception column: ",(iii3).ToString()));
        //                            //    //    MessageBox.Show(String.Concat("Exception rank: ",(jjj3).ToString() ));
        //                            //    //}
        //                            //    // PLAYING
        //                            //}
        //                            //else if (Number_of_defenders[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] > 1)
        //                            //{
        //                            //    Exception_defender_column[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = -99;
        //                            //    Exception_defender_rank[(m_FinishingColumnNumber_Attack - 1), (m_FinishingRank_Attack - 1)] = -99;
        //                            //}

        //                        }
        //                    }
        //                }
        //            }
        //        }
        //    }
        //}

        //v0.980: Reduced code size
        public static void PawnPromotion()
        {
            for (i = 0; i <= 7; i++)
            {
                if (Skakiera[(i), (0)].CompareTo("Black Pawn") == 0)
                {
                    ///////////////////////////
                    // Promote pawn
                    ///////////////////////////

                    Skakiera[(i), (0)] = "Black Queen";

                    // v0.991: Need to fix this, so that the user can select what to promote the pawn to!

                    //Console.WriteLine("Promote to: 1. Queen, 2. Rook, 3. Knight, 4. Bishop? ");
                    //choise_of_user = Int32.Parse(Console.ReadLine());

                    //switch (choise_of_user)
                    //{
                    //    case 1:
                    //        Skakiera[(i), (0)] = "Black Queen";
                    //        break;

                    //    case 2:
                    //        Skakiera[(i), (0)] = "Black Rook";
                    //        break;

                    //    case 3:
                    //        Skakiera[(i), (0)] = "Black Knight";
                    //        break;

                    //    case 4:
                    //        Skakiera[(i), (0)] = "Black Bishop";
                    //        break;
                    //};

                }

                //v0.992: Simplify. Just promote "all" pawns regardless of who plays. Anyway it will just be one!
                if (Skakiera[(i), (7)].CompareTo("White Pawn") == 0)
                {
                    ///////////////////////////
                    // Promote pawn
                    ///////////////////////////

                    Skakiera[(i), (7)] = "White Queen";

                    // v0.991: Need to fix this, so that the user can select what to promote the pawn to!

                    //Console.WriteLine("Promote to: 1. Queen, 2. Rook, 3. Knight, 4. Bishop? ");
                    //choise_of_user = Int32.Parse(Console.ReadLine());

                    //switch (choise_of_user)
                    //{
                    //    case 1:
                    //        Skakiera[(i), (7)] = "White Queen";
                    //        break;

                    //    case 2:
                    //        Skakiera[(i), (7)] = "White Rook";
                    //        break;

                    //    case 3:
                    //        Skakiera[(i), (7)] = "White Knight";
                    //        break;

                    //    case 4:
                    //        Skakiera[(i), (7)] = "White Bishop";
                    //        break;
                    //};
                }

            }
        }

        // Setup the starting position
        // v0.990 Test: Changed the starting position. Remember to reset again! :)
        public static void Starting_position()
        {
            // TODO: Add your control notification handler code here

            for (int a = 0; a <= 7; a++)
            {
                for (int b = 0; b <= 7; b++)
                {
                    Skakiera[(a), (b)] = "";
                }
            }

            // Initial
            Skakiera[(0), (0)] = "White Rook";
            Skakiera[(0), (1)] = "White Pawn";
            Skakiera[(0), (6)] = "Black Pawn";
            Skakiera[(0), (7)] = "Black Rook";
            Skakiera[(1), (0)] = "White Knight";
            Skakiera[(1), (1)] = "White Pawn";
            Skakiera[(1), (6)] = "Black Pawn";
            Skakiera[(1), (7)] = "Black Knight";
            Skakiera[(2), (0)] = "White Bishop";
            Skakiera[(2), (1)] = "White Pawn";
            Skakiera[(2), (6)] = "Black Pawn";
            Skakiera[(2), (7)] = "Black Bishop";
            Skakiera[(3), (0)] = "White Queen";
            Skakiera[(3), (1)] = "White Pawn";
            Skakiera[(3), (6)] = "Black Pawn";
            Skakiera[(3), (7)] = "Black Queen";
            Skakiera[(4), (0)] = "White King";
            Skakiera[(4), (1)] = "White Pawn";
            Skakiera[(4), (6)] = "Black Pawn";
            Skakiera[(4), (7)] = "Black King";
            Skakiera[(5), (0)] = "White Bishop";
            Skakiera[(5), (1)] = "White Pawn";
            Skakiera[(5), (6)] = "Black Pawn";
            Skakiera[(5), (7)] = "Black Bishop";
            Skakiera[(6), (0)] = "White Knight";
            Skakiera[(6), (1)] = "White Pawn";
            Skakiera[(6), (6)] = "Black Pawn";
            Skakiera[(6), (7)] = "Black Knight";
            Skakiera[(7), (0)] = "White Rook";
            Skakiera[(7), (1)] = "White Pawn";
            Skakiera[(7), (6)] = "Black Pawn";
            Skakiera[(7), (7)] = "Black Rook";

            // v0.990 Test1: Will the computer eat the bishop at B4?
            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (1)] = "White Pawn";
            //Skakiera[(0), (6)] = "Black Pawn";
            //Skakiera[(0), (7)] = "Black Rook";
            //Skakiera[(1), (0)] = "White Knight";
            //Skakiera[(1), (1)] = "White Pawn";
            //Skakiera[(1), (6)] = "Black Pawn";
            //Skakiera[(1), (7)] = "Black Knight";
            //Skakiera[(2), (0)] = "White Bishop";
            //Skakiera[(2), (2)] = "White Pawn";
            //Skakiera[(2), (6)] = "Black Pawn";
            //Skakiera[(2), (7)] = "Black Bishop";
            //Skakiera[(3), (0)] = "White Queen";
            //Skakiera[(3), (1)] = "";
            //Skakiera[(3), (4)] = "Black Pawn";
            //Skakiera[(3), (7)] = "Black Queen";
            //Skakiera[(4), (0)] = "White King";
            //Skakiera[(4), (1)] = "White Pawn";
            //Skakiera[(4), (4)] = "Black Pawn";
            //Skakiera[(4), (7)] = "Black King";
            //Skakiera[(5), (0)] = "White Bishop";
            //Skakiera[(5), (1)] = "White Pawn";
            //Skakiera[(5), (6)] = "Black Pawn";
            //Skakiera[(5), (7)] = "Black Bishop";
            //Skakiera[(6), (0)] = "White Knight";
            //Skakiera[(6), (1)] = "White Pawn";
            //Skakiera[(6), (6)] = "Black Pawn";
            //Skakiera[(6), (7)] = "Black Knight";
            //Skakiera[(7), (0)] = "White Rook";
            //Skakiera[(7), (1)] = "White Pawn";
            //Skakiera[(7), (6)] = "Black Pawn";
            //Skakiera[(7), (7)] = "Black Rook";
            //v0.990 Test result: Moves a2 -> a4. The first move analyzed since all have the same score.
            // PROBLEM 1
            // If black plays bishop to b4, then white playes Knight at a3.
            // (note: the above move is made if you disable the Check Stupid Move by putting "if Move < 0" instead of "if Move < 5".
            // HOWEVER, if we set up the same position programatically (see below), white plays a different move! (Qb3)
            // There must be a problem in the initialization of variables in ComputerMove!
            // STATUS: PROBLEM SOLVED! (with v0.990)
            // PROBLEM 2
            // If black plays bishop at B4 will the computer eat it?
            // Now with the possibility_to_eat functionality it will!

            // v0.990 Test2: Will the computer eat bishop at b4?
            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (3)] = "White Pawn";  // Moved
            //Skakiera[(0), (6)] = "Black Pawn";
            //Skakiera[(0), (7)] = "Black Rook";
            //Skakiera[(1), (0)] = "White Knight";
            //Skakiera[(1), (1)] = "White Pawn";
            //Skakiera[(1), (6)] = "Black Pawn";
            //Skakiera[(1), (7)] = "Black Knight";
            //Skakiera[(2), (0)] = "White Bishop";
            //Skakiera[(2), (2)] = "White Pawn";
            //Skakiera[(2), (6)] = "Black Pawn";
            //Skakiera[(2), (7)] = "Black Bishop";
            //Skakiera[(3), (0)] = "White Queen";
            //Skakiera[(3), (1)] = "";
            //Skakiera[(3), (4)] = "Black Pawn";
            //Skakiera[(3), (7)] = "Black Queen";
            //Skakiera[(4), (0)] = "White King";
            //Skakiera[(4), (1)] = "White Pawn";
            //Skakiera[(4), (4)] = "Black Pawn";
            //Skakiera[(4), (7)] = "Black King";
            //Skakiera[(5), (0)] = "White Bishop";
            //Skakiera[(5), (1)] = "White Pawn";
            //Skakiera[(5), (6)] = "Black Pawn";
            //Skakiera[(1), (3)] = "Black Bishop";  // Changed from (5),(7) to (1),(3)
            //Skakiera[(6), (0)] = "White Knight";
            //Skakiera[(6), (1)] = "White Pawn";
            //Skakiera[(6), (6)] = "Black Pawn";
            //Skakiera[(6), (7)] = "Black Knight";
            //Skakiera[(7), (0)] = "White Rook";
            //Skakiera[(7), (1)] = "White Pawn";
            //Skakiera[(7), (6)] = "Black Pawn";
            //Skakiera[(7), (7)] = "Black Rook";
            // PROBLEM:
            // Computer plays queen to b3. Why doesn't it eat the bishop? To be analyzed...
            // (after I fix the problem with the initialization of ComputerMove)
            // STATUS: After I added the possibility_to_eat this behavior has changed...

            // v0.991: Will the computer move the threatened bishop? And why not?
            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (1)] = "White Pawn";
            //Skakiera[(0), (6)] = "Black Pawn";
            //Skakiera[(0), (7)] = "Black Rook";
            //Skakiera[(1), (0)] = "White Knight";
            //Skakiera[(1), (1)] = "White Pawn";
            //Skakiera[(1), (6)] = "Black Pawn";
            //Skakiera[(1), (7)] = "Black Knight";
            ////Skakiera[(2), (0)] = "White Bishop";
            //Skakiera[(2), (2)] = "White Pawn";
            //Skakiera[(2), (6)] = "Black Pawn";
            //Skakiera[(2), (7)] = "Black Bishop";
            //Skakiera[(3), (0)] = "White Queen";
            //Skakiera[(3), (3)] = "White Pawn";
            //Skakiera[(3), (4)] = "Black Pawn";
            //Skakiera[(3), (7)] = "Black Queen";
            //Skakiera[(4), (0)] = "White King";
            //Skakiera[(4), (1)] = "White Pawn";
            //Skakiera[(4), (5)] = "Black Pawn";
            //Skakiera[(4), (3)] = "White Bishop";
            //Skakiera[(4), (7)] = "Black King";
            //Skakiera[(5), (0)] = "White Bishop";
            //Skakiera[(5), (1)] = "White Pawn";
            //Skakiera[(5), (6)] = "Black Pawn";
            //Skakiera[(5), (7)] = "Black Bishop";
            //Skakiera[(6), (0)] = "White Knight";
            //Skakiera[(6), (1)] = "White Pawn";
            //Skakiera[(6), (6)] = "Black Pawn";
            //Skakiera[(6), (7)] = "Black Knight";
            //Skakiera[(7), (0)] = "White Rook";
            //Skakiera[(7), (1)] = "White Pawn";
            //Skakiera[(7), (6)] = "Black Pawn";
            //Skakiera[(7), (7)] = "Black Rook";

            // V0.991 [Scenario V0991.A]
            // v0.991: Will the computer play f4->c7? And why?
            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (1)] = "White Pawn";
            //Skakiera[(0), (6)] = "Black Pawn";
            //Skakiera[(0), (7)] = "Black Rook";
            //Skakiera[(1), (0)] = "White Knight";
            //Skakiera[(1), (1)] = "White Pawn";
            //Skakiera[(1), (6)] = "Black Pawn";
            //Skakiera[(1), (7)] = "Black Knight";
            ////Skakiera[(2), (0)] = "White Bishop";
            //Skakiera[(2), (2)] = "White Pawn";
            //Skakiera[(2), (6)] = "Black Pawn";
            //Skakiera[(2), (7)] = "Black Bishop";
            //Skakiera[(3), (0)] = "White Queen";
            //Skakiera[(3), (3)] = "White Pawn";
            //Skakiera[(3), (4)] = "Black Pawn";
            //Skakiera[(3), (7)] = "Black Queen";
            //Skakiera[(4), (0)] = "White King";
            //Skakiera[(4), (1)] = "White Pawn";
            //Skakiera[(4), (5)] = "Black Pawn";
            //Skakiera[(5), (3)] = "White Bishop";
            //Skakiera[(4), (7)] = "Black King";
            //Skakiera[(5), (0)] = "White Bishop";
            //Skakiera[(5), (1)] = "White Pawn";
            //Skakiera[(5), (6)] = "Black Pawn";
            //Skakiera[(5), (7)] = "Black Bishop";
            //Skakiera[(6), (0)] = "White Knight";
            //Skakiera[(6), (1)] = "White Pawn";
            //Skakiera[(6), (6)] = "Black Pawn";
            //Skakiera[(6), (7)] = "Black Knight";
            //Skakiera[(7), (0)] = "White Rook";
            //Skakiera[(7), (1)] = "White Pawn";
            //Skakiera[(7), (6)] = "Black Pawn";
            //Skakiera[(7), (7)] = "Black Rook";

            // V0.991 [Scenario V0991.B]
            // v0.991: Will the computer eat the knight?
            //         RESULT: Success
            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (1)] = "White Pawn";
            //Skakiera[(0), (6)] = "Black Pawn";
            //Skakiera[(0), (7)] = "Black Rook";
            //Skakiera[(1), (0)] = "White Knight";
            //Skakiera[(1), (1)] = "White Pawn";
            //Skakiera[(1), (6)] = "Black Pawn";
            //Skakiera[(1), (7)] = "Black Knight";
            //Skakiera[(2), (0)] = "White Bishop";
            //Skakiera[(2), (1)] = "White Pawn";
            //Skakiera[(2), (6)] = "Black Pawn";
            //Skakiera[(2), (7)] = "Black Bishop";
            //Skakiera[(3), (0)] = "White Queen";
            //Skakiera[(3), (1)] = "White Pawn";
            //Skakiera[(3), (6)] = "Black Pawn";
            //Skakiera[(3), (7)] = "Black Queen";
            //Skakiera[(4), (0)] = "White King";
            //Skakiera[(4), (4)] = "White Pawn";
            //Skakiera[(4), (6)] = "Black Pawn";
            //Skakiera[(4), (7)] = "Black King";
            //Skakiera[(5), (0)] = "White Bishop";
            //Skakiera[(5), (1)] = "White Pawn";
            //Skakiera[(5), (6)] = "Black Pawn";
            //Skakiera[(5), (7)] = "Black Bishop";
            //Skakiera[(6), (0)] = "White Knight";
            //Skakiera[(6), (1)] = "White Pawn";
            //Skakiera[(6), (6)] = "Black Pawn";
            //Skakiera[(5), (5)] = "Black Knight";
            //Skakiera[(7), (0)] = "White Rook";
            //Skakiera[(7), (1)] = "White Pawn";
            //Skakiera[(7), (6)] = "Black Pawn";
            //Skakiera[(7), (7)] = "Black Rook";

            // v0.992
            // Test 1: Will the HY eat the bishop?
            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (1)] = "White Pawn";
            //Skakiera[(0), (6)] = "Black Pawn";
            //Skakiera[(0), (7)] = "Black Rook";
            //Skakiera[(1), (0)] = "White Knight";
            //Skakiera[(1), (1)] = "White Pawn";
            //Skakiera[(1), (6)] = "Black Pawn";
            //Skakiera[(1), (7)] = "Black Knight";
            //Skakiera[(2), (0)] = "White Bishop";
            //Skakiera[(2), (2)] = "White Pawn";
            //Skakiera[(2), (6)] = "Black Pawn";
            //Skakiera[(7), (2)] = "Black Bishop";
            //Skakiera[(3), (0)] = "White Queen";
            //Skakiera[(3), (3)] = "White Pawn";
            //Skakiera[(3), (5)] = "Black Pawn";
            //Skakiera[(3), (7)] = "Black Queen";
            //Skakiera[(4), (0)] = "White King";
            //Skakiera[(4), (1)] = "White Pawn";
            //Skakiera[(4), (6)] = "Black Pawn";
            //Skakiera[(4), (7)] = "Black King";
            //Skakiera[(5), (0)] = "White Bishop";
            //Skakiera[(5), (1)] = "White Pawn";
            //Skakiera[(5), (6)] = "Black Pawn";
            //Skakiera[(5), (7)] = "Black Bishop";
            //Skakiera[(6), (0)] = "White Knight";
            //Skakiera[(6), (1)] = "White Pawn";
            //Skakiera[(6), (6)] = "Black Pawn";
            //Skakiera[(6), (7)] = "Black Knight";
            //Skakiera[(7), (0)] = "White Rook";
            //Skakiera[(7), (1)] = "White Pawn";
            //Skakiera[(7), (6)] = "Black Pawn";
            //Skakiera[(7), (7)] = "Black Rook";

            // ---------- QBASIC TEST ----------
            // Result for Thinking Depth 2: Somewhat OK
            // Problem: The sequence b4->e7 b2->a1 b7->a8 yields the same result (+1) at the end as the
            //          sequence b7->a8 b2->a1 b4->e7 so the computer plays either of them... This can be
            //          overcome by increasing the thinking depth somewhat, but the 'termination' problem
            //          (i.e. the computer terminates its thinking at some point and does not see whether
            //          the very next move results in catastrophy) will still be there.
            // Deep Blue solution: Keep on thinking a variant where there is capturing of pieces until
            //                     there is no capturing anymore.
            // Result for Thinking Depth 4: Not playing, potentially due to problem with too many possible moves
            //                              Need to apply SET OF RULES 1 in Analyze_Move_3 for the computer to play!

            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (1)] = "White Pawn";
            //Skakiera[(1), (0)] = "White Knight";
            //Skakiera[(1), (1)] = "Black Pawn";
            //Skakiera[(2), (0)] = "";
            //Skakiera[(2), (1)] = "White Pawn";
            //Skakiera[(3), (0)] = "";
            //Skakiera[(3), (1)] = "White Pawn";
            //Skakiera[(4), (0)] = "White King";
            //Skakiera[(4), (1)] = "";
            //Skakiera[(5), (0)] = "";
            //Skakiera[(5), (1)] = "White Pawn";
            //Skakiera[(6), (0)] = "White Knight";
            //Skakiera[(6), (1)] = "White Pawn";
            //Skakiera[(7), (0)] = "White Rook";
            //Skakiera[(7), (1)] = "";
            //Skakiera[(0), (6)] = "";
            //Skakiera[(0), (7)] = "Black Rook";
            //Skakiera[(1), (6)] = "White Bishop";
            //Skakiera[(1), (7)] = "Black Knight";
            //Skakiera[(2), (6)] = "Black Pawn";
            //Skakiera[(2), (7)] = "";
            //Skakiera[(3), (6)] = "Black Pawn";
            //Skakiera[(3), (7)] = "Black Queen";
            //Skakiera[(4), (6)] = "Black Pawn";
            //Skakiera[(4), (7)] = "Black King";
            //Skakiera[(5), (6)] = "Black Pawn";
            //Skakiera[(5), (7)] = "Black Bishop";
            //Skakiera[(6), (6)] = "Black Pawn";
            //Skakiera[(6), (7)] = "Black Knight";
            //Skakiera[(7), (6)] = "Black Pawn";
            //Skakiera[(7), (7)] = "Black Rook";
            //Skakiera[(3), (3)] = "White Pawn";
            //Skakiera[(1), (3)] = "White Bishop";
            //Skakiera[(5), (3)] = "White Queen";
            //Skakiera[(6), (5)] = "Black Bishop";

            // CHECK TEST: Will the ElegxosNomimotitas work properly to detect the check?
            //Skakiera[(0), (0)] = "White Rook";
            //Skakiera[(0), (1)] = "White Pawn";
            //Skakiera[(0), (5)] = "Black Pawn";
            //Skakiera[(5), (7)] = "Black Rook";
            //Skakiera[(5), (1)] = "White Knight";
            //Skakiera[(1), (2)] = "White Pawn";
            //Skakiera[(1), (3)] = "Black Pawn";
            //Skakiera[(1), (7)] = "";
            //Skakiera[(2), (0)] = "";
            //Skakiera[(2), (3)] = "White Pawn";
            //Skakiera[(2), (4)] = "Black Pawn";
            //Skakiera[(2), (7)] = "Black Bishop";
            //Skakiera[(2), (6)] = "White Queen";
            //Skakiera[(3), (2)] = "White Pawn";
            //Skakiera[(3), (5)] = "Black Pawn";
            //Skakiera[(3), (7)] = "";
            //Skakiera[(4), (1)] = "White King";
            //Skakiera[(4), (3)] = "White Pawn";
            //Skakiera[(4), (4)] = "Black Pawn";
            //Skakiera[(5), (6)] = "Black King";
            //Skakiera[(5), (0)] = "";
            //Skakiera[(5), (4)] = "White Pawn";
            //Skakiera[(5), (5)] = "Black Pawn";
            //Skakiera[(4), (6)] = "Black Bishop";
            //Skakiera[(6), (3)] = "White Knight";
            //Skakiera[(6), (1)] = "";
            //Skakiera[(5), (3)] = "Black Pawn";
            //Skakiera[(6), (7)] = "";
            //Skakiera[(7), (0)] = "";
            //Skakiera[(7), (2)] = "White Pawn";
            //Skakiera[(7), (3)] = "Black Pawn";
            //Skakiera[(6), (2)] = "Black Rook";

            m_WhichColorPlays = "White";
        }

    };
}

